#!/usr/bin/perl

require "inc/init.pl";
require "inc/localize.pl";
require "inc/treeop.pl";
require "inc/util.pl";

( $frlang, $thisuser, $fr, $pg, $md, $msg ) = unpack( "uS*", pack( "h*", $fields{'param'} ) );

$fr ||= 0;
$pg ||= 1;
$msg ||= 0;
$md ||= 0;

if( $frlang && $definedlangs{$frlang} ){
	$lang = $frlang;
}

&makedict;
$fields{'charset'} = $charsets{$lang};

@rmnodes = ( );
@rmfrnodes = ( );
%recbin = ( );

$tblline ||= $settings{'defaultline'};

# Special case: "task" should be a long string that has to be decoded with the task and user id:
# This parameter would be transferred by a form that contains this fields:
# <input type="Hidden" name="task" value="$taskid">, where
# $taskid = unpack( "H*", pack( "uS", $taskname, $userid ) );
# $taskname could be "register", "settings", "update", "subscribe", "unsub", "remove", "logon", "logout".

# NOTE: only one "\n" here in case other headers will be written.
print "Content-type: text/html\n";

# Decode the $taskid into a taskname and a user id
# The $userid MUST match that recorded for this IP in this session (after log in) unless it is
# to register a new user

( $taskname, $thisuser ) = unpack( "uS", pack( "H*", $fields{'task'} ) );

if( $taskname eq "setup" && $fields{'grp'} eq "admin" && ( $fields{'update.x'} || $fields{'update.y'} ) && $fields{'baseurl'} != $baseurl ){
	$baseurl = $fields{'baseurl'};
}

use constant MAXSELECTSIZE => 16;
use constant MAXTITLECLIP => 30;

$currcnt = 0;
$currpg = 1;
$markedid = 0;

$treetag = "f";
# This is a just a flag var, to tell the &listtree the current tree is whether forum or message
# It is either "" or "f" so &listtree can insert proper character to the "option" values.

$separator = qq{
<table border=0 cellspacing=0 cellpadding=0 width="600">
<tr height="8">
	<td background="$baseurl/img/barbg.gif"><img src="$baseurl/img/clear.gif" border=0 height=8 width=12></td>
</tr>
</table>
};

&builderrmsg;
&buildlogonform;

if( {"setup" => 1, "dict" => 1, "users" => 1, "movenode" => 1}->{$taskname} && $thisuser != 1 ){
	print "\n";	# To make up a complete HTTP header info.
	&tellerror( "INVALID_SESS" );
	print $logonform;
	exit;
}

%mystatus = ( );

unless( {"register" => 1, "logon" => 1, "regcontinue" => 1, "update" => 1}->{$taskname} ){
	$perm = &authenticate( );
	if( !$perm ){
		print "\n";	# To make up a complete HTTP header info.
		&tellerror( "SESS_EXPIRED" );
		print $logonform;
		exit;
	} elsif( $thisuser != $userid ){
		print "\n";	# To make up a complete HTTP header info.
		&tellerror( "INVALID_SESS" );
		print $logonform;
		exit;
	}
	my @permdesc = qw(expired guest banned member senior manager webmaster);
	%mystatus = map { $permdesc[$_] => ($_<$sMember)? ($_==$perm): ($_<=$perm) } 0..6;
}

%adminsubs = (
	'autoinform' => \&autoinform,
	'dict' => \&dictionary,
	'edit' => \&edit,
	'editcontinue' => \&edit,
	'lock' => \&lockunlock,
	'lockfr' => \&lockunlockfr,
	'logon' => \&logon,
	'logout' => \&logout,
	'movenode' => \&movenode,
	'newfr' => \&newfr,
	'newfrcontinue' => \&newfr,
	'noinform' => \&autoinform,
	'regcontinue' => \&regset,
	'register' => \&regset,
	'remove' => \&remove,
	'removefr' => \&removefr,
	'sendnews' => \&sendnewsmsg,
	'settings' => \&regset,
	'setup' => \&setup,
	'subscribe' => \&subunsub,
	'unlock' => \&lockunlock,
	'unlockfr' => \&lockunlockfr,
	'unsub' => \&subunsub,
	'update' => \&regset,
	'users' => \&users,
);

eval{
if( defined $adminsubs{$taskname} ){
	&{$adminsubs{$taskname}};
}
};
print "\n";	# To make up a complete HTTP header info.
if( $@ ){
	print $@;
} else {
	&tellerror( "INVALID_SESS" );
	print $logonform;
}

sub removenode {
	my $np = shift;
	my $pp = $$np{'par'};
	if( $$np{'prev'} ){
		$$np{'prev'}{'next'} = $$np{'next'};
	} else {
		$$pp{'son'} = $$np{'next'};
	}
	if( $$np{'next'} ){
		$$np{'next'}{'prev'} = $$np{'prev'};
	} else {
		$$pp{'last'} = $$np{'prev'};
	}
}

sub moveupper{
	my $id = shift;
	my $np = &searchtree( $root, $id );
	if( $np == $root || $$np{'par'} == $root ){
		return;
	}
	my $pp = $$np{'par'};
	&removenode( $np );
	$$np{'next'} = $$pp{'next'};
	$$np{'prev'} = $pp;
	$$np{'par'} = $$pp{'par'};
	if( $$pp{'next'} ){
		$$pp{'next'}{'prev'} = $np;
	} else {
		$$pp{'par'}{'last'} = $np;
	}
	$$pp{'next'} = $np;
}

sub movelower{
	my $id = shift;
	my $np = &searchtree( $root, $id );
	return if( !$$np{'prev'} );
	my $pp = $$np{'prev'};
	&removenode( $np );
	if( !$$pp{'son'} ){
		$$pp{'son'} = $np;
	} else {
		$$np{'prev'} = $$pp{'last'};
		$$pp{'last'}{'next'} = $np;
	}
	$$pp{'last'} = $np;
	$$np{'par'} = $pp;
	$$np{'next'} = 0;
}

sub bubblenode{
	my $id = shift;
	my $np = &searchtree( $root, $id );
	return if( !$$np{'prev'} );
	my $pp = $$np{'prev'};
	&removenode( $np );
	$$pp{'next'} = $$np{'next'};
	$$np{'prev'} = $$pp{'prev'};
	if( $$np{'next'} ){
		$$np{'next'}{'prev'} = $pp;
	} else {
		$$pp{'par'}{'last'} = $pp;
	}
	if( $$pp{'prev'} ){
		$$pp{'prev'}{'next'} = $np;
	} else {
		$$np{'par'}{'son'} = $np;
	}
	$$np{'next'} = $pp;
	$$pp{'prev'} = $np;
}

sub sinknode{
	my $id = shift;
	my $np = &searchtree( $root, $id );
	return if( !$$np{'next'} );
	my $pp = $$np{'next'};
	&removenode( $np );
	$$pp{'prev'} = $$np{'prev'};
	$$np{'next'} = $$pp{'next'};
	if( $$np{'prev'} ){
		$$np{'prev'}{'next'} = $pp;
	} else {
		$$pp{'par'}{'son'} = $pp;
	}
	if( $$pp{'next'} ){
		$$pp{'next'}{'prev'} = $np;
	} else {
		$$np{'par'}{'last'} = $np;
	}
	$$np{'prev'} = $pp;
	$$pp{'next'} = $np;
}

sub exportfr{
	my $fr = shift;
	my %frdb = ( );
	my %msgdat = ( );
	my @treedat = ( );
	tie( %frdb, $DB_Type, "dat/fr$fr", &GDBM_WRCREAT, 0666 );
	open( FRDAT, "<dat/fr$fr.dat" );
	open( ARCH, ">arc/fr${fr}_" . time  . ".txt" );
	while( <FRDAT> ){
		$_ =~ /^(\t+)/;
		( $msgdat{'id'}, $msgdat{'title'}, $msgdat{'userid'}, $msgdat{'lastmod'}, $msgdat{'status'} ) = split( /\t/, $' );
		if( $msgdat{'id'} ){ push( @treedat, $1 . $msgdat{'id'} . ": " . $msgdat{'title'} . "\n" ); }
		my @msgtxt = split( /\t/, $frdb{$msgdat{'id'}}, 5 );
		print ARCH $msgdat{'id'}, "\n";
		print ARCH $dict{'date'}, ":\t", &customtime( $msgdat{'lastmod'} ), "\n";
		print ARCH $dict{'author'}, ":\t", ( $users{$msgdat{'userid'}} || $dict{'guest'} ), " (", $msgdat{'userid'}, ") \@",  $msgtxt[1], "\n";
		print ARCH $dict{'title'}, ":\t", $msgdat{'title'}, "\n", '-' x 40, "\n";
		print ARCH $msgtxt[4], "\n\n";
	}
	print ARCH @treedat;
	close( ARCH );
	close( FRDAT );
	untie %frdb;
}

sub logon {
	if( $fields{'username'} =~ /^s*$/ || $fields{'password'} =~ /^s*$/
		|| $fields{'username'} =~ /\W/ || $fields{'password'} =~ /\W/ ){
		print "\n";
		&tellerror( "SUSP_LOGON" );
		print $logonform;
		exit;
	}
	tie( %userdb, $DB_Type, "dat/users", &GDBM_WRCREAT, 0666 );
	$found = 0;
	foreach $id ( grep{/^\d+/} keys %userdb ){
		last if( $found );
		if( $userdb{$id} =~ /^$fields{'username'}\t/i ){
			if( $' =~ /^$fields{'password'}\t/ ){
				$found = 1;
				srand($$|time);
				$sessionid = int(rand(50000));
				tie( %sess, $DB_Type, "dat/sess", &GDBM_WRCREAT, 0666 );
				if( !$sess{'lastcleanup'} || time - $sess{'lastcleanup'} > $settings{'checkupsess'} * 3600 ){
					foreach $sid (keys %sess) {
						my @sessdat = split( /\t/, $sess{$sid}, 3 );
						if( time - $sessdat[1] > $settings{'expiretime'} * 60 ){
							delete $sess{$sid};
						}
					}
					$sess{'lastcleanup'} = time;
				}
				my @userdata = split( /\t/, $userdb{$id} );
				for( 0..$userdb{'fields'}-1 ){
					$userdb{ "f" . $_ } =~ /^(\S+)\t/;
					$userinfo{$1} = ( $userdata[$_] || "" );
				}
				for( keys %sess ){
					if( $sess{$_} =~ /^$id\t/ ){
						delete $sess{$_};
					}
				}
				$sess{ join( ".", $ENV{'REMOTE_ADDR'}, $sessionid ) } = join( "\t", $id, time, $userinfo{'permission'} );
				$userid = $id;
				untie %sess;
				&setcookie( "sessionid", $sessionid );
			} else {
				untie %userdb;
				print "\n";
				&tellerror( "PASSWD_MISMATCH" );
				exit;
			}
		}
	}
	untie %userdb;
	if( !$found ){
		print "\n";
		&tellerror( "NOT_REGISTERED" );
	} else {
		my $param = unpack( "h*", pack( "uS*", ($userinfo{'langpref'} || $lang), $userid, $fr, $pg, $md, $msg ) );
		print "Location: index.cgi?param=$param\n\n";
	}
	exit;
}

sub logout {
	tie( %sess, $DB_Type, "dat/sess", &GDBM_WRCREAT, 0666 );
	delete $sess{ join( ".", $ENV{'REMOTE_ADDR'}, $cookies{'sessionid'} ) };
	foreach $pid ( keys %sess ){
		my @sdata = split( /\t/, $sess{'$pid'} );
		if( $sdata[0] == $userid ){
			delete $sess{$pid};
		}
	}
	untie %sess;
	my $param = unpack( "h*", pack( "uS*", $lang, 0, $fr, $pg, $md, $msg ) );
	&delcookie( "sessionid" );
	&delcookie( "hitrecorded" );
	&setcookie( "lastlogin", time, 30*24 );
	print "Location: index.cgi?param=$param\n\n";
	exit;
}

sub subunsub {
	&readtree( "dat/topics.dat" );
	my $frnode = &searchtree( $root, $fr );
	my @fdata = split( /\t/, $$frnode{'cap'} );
	&getuserinfo( $thisuser );
	my $email = $userinfo{'email'};
	# %userinfo is a global hash, whose keys are defined in "users"
	my %maillist = ( );
	my %msgs = ( );
	tie( %maillist, $DB_Type, "dat/ml$fr", &GDBM_WRCREAT, 0666 );
	if( $taskname eq "unsub" ){
		unless( defined $maillist{$email} ){
			print "\n";
			&tellerror( "NOT_SUBSCRIBED" );
			untie %maillist;
			exit;
		}
		delete $maillist{$email};
		%msgs = (
		'eng' => qq{You have declined to receive new messages posted on forum "$settings{'bbstitle'}" under the discussion group "$fdata[0]".\n\nTo subscribe to this topic again, please log on to the forum and click on the "Subscribe" button. Thank you for your business.\n},
		'fr' => qq{Vous avez refus&eacute; de recevoir de nouveaux messages &eacute;crit sur le forum "$settings{'bbstitle'}" sous le groupe de discussion "$fdata[0]".\n\nPour souscrire &agrave; ce sujet encore, entrer veuillez au forum et cliqueter en fonction "Souscrivez" le bouton. Merci de vos affaires.\n},
		'de' => qq{Sie sind gesunken, die neuen Meldungen zu empfangen, die auf Forum "$settings{'bbstitle'}" unter der Diskussion Gruppe "$fdata[0]" bekanntgegeben werden.\n\nZu diesem Thema wieder zu unterzeichnen, zum Forum bitte anzumelden und an zu klicken "Unterzeichnen" Taste. Danke f&uuml;r Ihr Gesch&auml;ft.\n},
		'gb' => qq{ȡ$settings{'bbstitle'}$fdata[0]ӣ¶ģڱվ¼ӦĿ¼֮󰴡ġťллʹñϵͳ\n},
		'big5' => qq{zwq\\$settings{'bbstitle'}_Qײ$fdata[0]olApݭsq\\AЦbn\}۬QײեؿAZq\\sC±zϥΥtΡC\n},
		);
	} else {
		if( defined $maillist{$email} ){
			print "\n";
			&tellerror( "HAVE_SUBSCRIBED" );
			untie %maillist;
			exit;
		}
		$maillist{$email} = 1;	# Always 1
		%msgs = (
		'eng' => qq{You have subscribed to receive new messages posted on forum "$settings{'bbstitle'}" under the discussion group "$fdata[0]".\n\nTo unsubscribe, please log on to the forum and click on the "Unsubscribe" button. Thank you for your business.\n},
		'fr' => qq{Vous avez souscrit pour recevoir de nouveaux messages &eacute;crit sur le forum "$settings{'bbstitle'}" sous le groupe de discussion "$fdata[0]".\n\nPour annuler, satisfaire entrez au forum et cliquetez en fonction le bouton d'"Annulation".\n},
		'de' => qq{Sie haben unterzeichnet, um die neuen Meldungen zu empfangen, die auf Forum "$settings{'bbstitle'}" unter der Diskussion Gruppe "$fdata[0]" bekanntgegeben werden.\n\nZum Beenden melden Sie bitte zum Forum an und klicken Sie an die "Beenden" Taste. Danke f&uuml;r Ihr Gesch&auml;ft.\n},
		'gb' => qq{Ѷ$settings{'bbstitle'}$fdata[0]ӣ˶ڱվ¼ӦĿ¼֮󰴡˶ťɡллʹñϵͳ\n},
		'big5' => qq{zwq\\$settings{'bbstitle'}_Qײ$fdata[0]olApݰhqAЦbn\}۬QײեؿAZhqsYiC±zϥΥtΡC\n},
		);
	}
	untie %maillist;
	my $from = "$settings{'bbstitle'} <$settings{'webmaster'}>";
	my $to = "$userinfo{'displayname'} <$email>";
	&sendemail( $from, $to, $dict{'subunsub'}, \($msgs{$lang}) );
	&sendnews( 0, $userid, \($msgs{$lang}) );
	my $param = unpack( "h*", pack( "uS*", $lang, $userid, $fr, $pg, $md, 0 ) );
	print "Location:index.cgi?param=$param\n\n";
	exit;
}

sub sendnewsmsg {
	&sendnews( $thisuser, $fields{'recipient'}, \($fields{'newstext'}) );
	print "location: index.cgi?param=$fields{'param'}\n\n";
	exit;
}

$separator = qq{
	<table border=0 cellspacing=0 cellpadding=0 width="600">
	<tr height="8">
		<td background="$baseurl/img/barbg.gif"><img src="$baseurl/img/clear.gif" border=0 height=8 width=12></td>
	</tr>
	</table>
};

sub regset {

my ( %userdb, %flds, %useremails, %userdispnames, %usernames, @entries );
$ok = 1;

if( $taskname eq "regcontinue" || $taskname eq "update" ){

	if( $fields{'password'} =~ /\W/ ){
		$fields{'errmsg'} = $errmsg{'INVALID_PWD'};
		$ok = 0;
	} elsif( $fields{'username'} =~ /\W/ ){
		$fields{'errmsg'} = $errmsg{'INVALID_UNAME'};
		$ok = 0;
	} elsif( $fields{'email'} !~ /^\S+\@(\S+\.)+\S+$/ ){
		$fields{'errmsg'} = $errmsg{'INVALID_EMAIL'};
		$ok = 0;
	}
	if( $ok ){
		# Now filter the username, display name, and email addresses of all users.
		tie( %userdb, $DB_Type, "dat/users", &GDBM_WRCREAT, 0666 );
		for( 0..$userdb{'fields'}-1 ){
			$userdb{ 'f' . $_ } =~ /^(\w+)\t/;
			$flds{$1} = $_;
		}
		foreach( grep{ $_ && /^\d+$/ } keys %userdb ){
			my @udata = split( /\t/, $userdb{$_} );
			$useremails{ lc( $udata[$flds{'email'}] ) } = 1;
			$usernames{ lc( $udata[$flds{'username'}] ) } = 1;
			$userdispnames{ lc( $udata[$flds{'displayname'}] ) } = 1;
		}
		untie( %userdb );
	} else {
		$taskname = ( $taskname eq "regcontinue"? "register": "settings" );
	}

	if( $ok && $taskname eq "regcontinue" ){
		if( $usernames{ lc($fields{'username'}) } ) {
			$fields{'errmsg'} = $errmsg{'NAME_OCCUPIED'};
			$ok = 0;
		} elsif( $useremails{ lc($fields{'email'}) } ) {
			$fields{'errmsg'} = $errmsg{'EMAIL_USED'};
			$ok = 0;
		} elsif( $userdispnames{ lc($fields{'displayname'}) } ) {
			$fields{'errmsg'} = $errmsg{'DISPNAME_USED'};
			$ok = 0;
		}
		if( !$ok ){
			$taskname = "register";
		}
	}

	if( $ok ){
	$fields{'displayname'} =~ s/["<>\@]//g;
	if( $thisuser ){
		&getuserinfo( $thisuser );
		$fields{'username'} = $userinfo{'username'};
	}
	tie( %userdb, $DB_Type, "dat/users", &GDBM_WRCREAT, 0666 );
	if( !$thisuser ){	# New user, is guest at this stage
		$thisuser = $userdb{'nextuserid'}++;
		$userdb{'nextuserid'}++;
		$fields{'param'} = unpack( "h*", pack( "uS*", $lang, $thisuser, $fr, $pg, $md, $msg ) );
		$fields{'permission'} = $sMember;
	} else {
		@userdata = split( /\t/, $userdb{$thisuser} );
		$fields{'permission'} = $userdata[2];	# Access permission, 0 through 6
	}
	
	map{ $entries[$flds{$_}] = $_ } keys %flds;
	$entries[2] = "permission";	# The permission field is not shown in the form.
	for( 0..$#entries ){
		1 while( $fields{$entries[$_]} =~ s{\t+}{' ' x (length($&) * 8 - length($`) % 8)}e );
	}
	$userdb{$thisuser} = join( "\t", @fields{ @entries } );
	untie %users;

	$from = $dict{'webmaster'} . " - " . $settings{'bbstitle'} . " <$settings{'webmaster'}>";
	$to = $fields{'lastname'} . " <" . $fields{'email'} . ">";
	%msgs = (
		'eng' => qq{Your record as a user on the "$settings{'bbstitle'}" has been updated. Below are the messages you disclosed. You may change any of these values by logging on.\n},
		'fr' => qq{Votre enregistrement en tant qu'utilisateur sur le forum "$settings{'bbstitle'}" a &eacute;t&eacute; mis &agrave; jour. Au-dessous de sont les messages que vous avez r&eacute;v&eacute;l&eacute;s. Vous pouvez changer n'importe laquelle de ces valeurs en entrant.\n},
		'de' => qq{Ihr Satz als Benutzer auf dem Forum "$settings{'bbstitle'}" ist aktualisiert worden. Unter sind die Meldungen, die Sie freigaben. Sie k&ouml;nnen irgendwelche dieser Werte &auml;ndern, indem Sie anmelden.\n},
		'gb' => qq{$settings{'bbstitle'}û¼Ѿ£дϢҪ޸ģٴڵ¼лл\n},
		'big5' => qq{zb$settings{'bbstitle'}ΤOwgsAHUOzgHCpzݭnקAЦAbnC¡I\n},
	);
	$msgbody = $msgs{$lang};
	for( 0..$#entries ){
		$msgbody .= $dict{$entries[$_]} . ": " . $fields{$entries[$_]} . "\n";
	}
	&sendemail( $from, $to, $dict{'regset'}, \$msgbody );
	tie( %sess, $DB_Type, "dat/sess", &GDBM_WRCREAT, 0666 );
	if( $taskname eq "update" ){
		$sess{ join( ".", $ENV{'REMOTE_ADDR'}, $cookies{'sessionid'} ) } = join( "\t", $thisuser, time, $userdata[2] );
		%welcomemsg = (
			'eng' => qq{Your record has been updated, and a copy has been sent to your email address.},
			'fr' => qq{Votre enregistrement a &eacute;t&eacute; mis &agrave; jour, et une copie a &eacute;t&eacute; envoy&eacute;e &agrave; votre courriel address.},
			'de' => qq{Ihr Satz ist aktualisiert worden, und ein Exemplar ist zu Ihrem email address geschickt worden.},
			'gb' => qq{עϢѾ²ѷһݵĵʼַ},
			'big5' => qq{z`UHwgs\}woe@zqlla\}C},
		);
	} else {
		srand($$|time);
		$sessionid = int(rand(50000));
		$sess{ join( ".", $ENV{'REMOTE_ADDR'}, $sessionid ) } = join( "\t", $thisuser, time, $sMember );
		&setcookie( "sessionid", $sessionid, 100 );
		%welcomemsg = (
			'eng' => qq{Welcome to the message board! You have been registered as a regular member, and a copy of your user information has been sent to your email address.},
			'fr' => qq{Bienvenue au panneau de message! Vous registre en tant que membre r&eacute;gulier, et une copie de votre information d'utilisateur a &eacute;t&eacute; envoy&eacute;e &agrave; votre courriel address.},
			'de' => qq{Willkommen zum Meldung Brett! Sie sind als regelm&auml;&szlig;iges Bauteil registriert worden, und ein Exemplar Ihrer Benutzerinformationen ist zu Ihrem email address geschickt worden.},
			'gb' => qq{ӭллǼǳΪʽûעϢѾ͵ĵʼַ},
			'big5' => qq{wI±znOΤAz`UHwgoezqlla\}C},
		);
	}
	untie %sess;
	&sendnews( 0, $thisuser, \($welcomemsg{ $settings{'defaultlang'} }) );
	$lang = $fields{'langpref'} || $lang;
	my $param = unpack( "h*", pack( "uS*", $lang, $thisuser, $fr, $pg, $md, 0 ) );
	print "Location: index.cgi?param=$param\n\n";
	exit;
	}
}

if( $taskname eq "settings" ){
	&getuserinfo( $thisuser ) if( $thisuser );
	map{ $fields{$_} = $userinfo{$_} } keys %userinfo;
	$fields{'usernameisreadonly'} = "Disabled";
}

if( $taskname eq "settings" || $taskname eq "register" ){
	for( @provlangs ){
		$fields{ 'lang' . $_ . 'checked' } = ( $fields{'langpref'} eq $_ )? "Checked": "";
	}
	if( !join( "", map{ $fields{ 'lang' . $_ . 'checked' } } @provlangs ) ){
		$fields{ 'lang' . $lang . 'checked' } = "Checked";
	}
	for ( qw(F M U) ){
		$fields{ 'sex' . $_ . 'checked' } = ( $fields{'sex'} eq $_ )? "Checked": "";
	}
	if( !$fields{ 'sexFchecked' } && !$fields{ 'sexMchecked' } ) {
		$fields{ 'sexUchecked' } = "Checked";
	}
	print "\n";
	$fields{'newtask'} = unpack( "H*", pack( "uS", ( $taskname eq "register"? "regcontinue": "update" ), $thisuser ) );
	$fields{'validatecode'} = qq{
	<script language="JavaScript">
	function validate( frm ){
		if( !frm.email.value.match( /^\\S+\@(\\S+\\.)+\\S+\$/ ) ){
			alert( "$errmsg{'INVALID_EMAIL'}" );
			return false;
		}
		if( frm.username.value.match( /\W/ ) ){
			alert( "$errmsg{'INVALID_UNAME'}" );
			return false;
		}
		if( frm.password.value.match( /\W/ ) ){
			alert( "$errmsg{'INVALID_PWD'}" );
			return false;
		}
		if( frm.password.value.length < 4 ){
			alert( "$errmsg{'PWD_TOO_SHORT'}" );
			return false;
		}
		if( frm.password.value != frm.passwdver.value ){
			alert( "$errmsg{'PWD_NOT_EQ'}" );
			return false;
		}
		if( frm.firstname.value.length < 1 || frm.lastname.value.length < 1 || frm.displayname.value.length < 1 || frm.username.value.length < 4 ){
			alert( "$errmsg{'FILL_REQ_FIELD'}" );
			return false;
		}
		return true;
	}
	</script>
	};

	# The following operation makes the captions of form fields be indicative of its access key.
	tie( %userdb, $DB_Type, "dat/users", &GDBM_WRCREAT, 0666 );
	for( 0..$userdb{'fields'}-1 ){
		my @desc = split( /\t/, $userdb{ "f" . $_ } );
		next unless( $desc[2] =~ /^\w/ );
		$dict{ $desc[0] } .= " (<u>$desc[2]</u>)";
	}
	untie %userdb;
	open( HTT, "<tmp/regset.htt" );
	while( <HTT> ){
		s/{%(\w+)%}/$fields{$1}/g;
		s/<%(\w+)%>/$dict{$1}/g;
		print;
	}
	close( HTT );
	exit;
}

}

sub newfr {

unless( $mystatus{'senior'} ){
	print "Location: index.cgi?param=$fields{'param'}\n\n";
	exit;
}

if( $taskname eq "newfr" ){
	$fields{'newtask'} = unpack( "H*", pack( "uS", "newfrcontinue", $thisuser ) );
	%promptmsg = (
		'eng' => qq{For your convenience, you can pick up to three forum topics now. These forums will be placed under current forum, but can be moved to any place later.},
		'fr' => qq{Pour votre convenance, vous pouvez s&eacute;lectionner jusqu'&agrave; trois sujets de forum maintenant. Ces forum seront plac&eacute;s sous le forum actuel, mais peuvent &ecirc;tre d&eacute;plac&eacute;s &agrave; n'importe quel endroit plus tard.},
		'de' => qq{F&uuml;r Ihre Bequemlichkeit k&ouml;nnen Sie bis drei Forumthemen jetzt ausw&auml;hlen. Diese Foren werden unter aktuelles Forum plaziert, aber k&ouml;nnen auf jeden m&ouml;glichen Platz sp&auml;ter verschoben werden.},
		'gb' => qq{Ϊһѡͬķ⡣Щ⽫ڵǰ֮£ԺҲʱƶκλá},
		'big5' => qq{zK_AziH\@̦ܳhܤTӤPեDDCoǥDDNmbeQײդUALHZ]iHHɲʨmC},
	);
	print <<FORM;

<!doctype html public "-//W3C//DTD HTML 4.0 Transitional//EN">
<html>
<head>
	<meta http-equiv="Content-type" content="text/html; charset=$fields{'charset'}">
	<title>$dict{'newforum'}</title>
	<link rel="stylesheet" href="$baseurl/fe.css">
	<style>
	</style>
</head>
<body>
<form method="post" autocomplete="on">
<input type="hidden" name="task" value="$fields{'newtask'}">
<input type="hidden" name="param" value="$fields{'param'}">
<center>
<table border=0 cellspacing=0 cellpadding=0 width="600">
<tr>
<td>
<table border=0 cellspacing=0 cellpadding=0>
<tr height="16">
	<td width=8><img src="$baseurl/img/tagleft.gif" width=8 height=16 border=0></td>
	<td background="$baseurl/img/tagbg.gif"><b>$dict{'newforum'}</b></td>
	<td width=8><img src="$baseurl/img/tagright.gif" width=8 height=16 border=0></td>
</tr>
</table>
</td>
</tr>
</table>
$separator
<table border=0 cellpadding=0 cellspacing=1 width="600" bgcolor="black">
<tr><td>
<table border=0 cellspacing=0 cellpadding=2 width="100%" bgcolor="white">
<tr>
	<td>$promptmsg{$lang}
	<br><br>
	$dict{'topics'}<ol type="1">
	<li>$dict{'topic'} <input type="text" name="topic1" size=50 maxlen=80><br>
	<textarea name="desc1" cols=40 rows=3>($dict{'description'})</textarea></li>
	<li>$dict{'topic'} <input type="text" name="topic2" size=50 maxlen=80><br>
	<textarea name="desc2" cols=40 rows=3>($dict{'description'})</textarea></li>
	<li>$dict{'topic'} <input type="text" name="topic3" size=50 maxlen=80><br>
	<textarea name="desc3" cols=40 rows=3>($dict{'description'})</textarea></li>
	</ol>
	<input type="Submit" value="$dict{'create'}">
	</td>
</tr>
</table>
</td></tr>
</table>
$separator
</center>
</form>
</body>
</html>
FORM
exit;

} else {

	&readtree( "dat/topics.dat" );
	my $np = 0;
	my $pp = &searchtree( $root, $fr ) || $root;
	my %topicdb = ( );
	tie( %forumdb, $DB_Type, "dat/forum", &GDBM_WRCREAT, 0666 );
	for( 1..3 ){
		my $topicid = $forumdb{'nexttopicid'};
		my $tpname = "topic" . $_;
		if( $fields{$tpname} !~ /^\s*$/ ){
		my $ndatum = join( "\t", $topicid, $fields{$tpname}, $thisuser, time, 0, 1 );
		$np = &tnode( $ndatum );
		if( !$$pp{'son'} ){
			$$pp{'son'} = $np;
		} else {
			$$np{'prev'} = $$pp{'last'};
			$$pp{'last'}{'next'} = $np;
		}
		$$pp{'last'} = $np;
		$$np{'par'} = $pp;
		open( FR, ">dat/fr$topicid.dat" );
		flock( FR, LOCK_EX );
		print FR join( "\t", "", 0, $fields{$tpname}, $thisuser, time, 0, 1 );
		# About the line above: 0 stands for the root record.
		flock( FR, LOCK_UN );
		close( FR );
		tie( %frdb, $DB_Type, "dat/fr$topicid", &GDBM_WRCREAT, 0666 );
		untie %frdb;
		$forumdb{ 'fr' . $topicid } = $fields{'desc' . $_ };
		$forumdb{'nexttopicid'}++;
		$forumdb{'numtopics'}++;
		}
	}
	untie %forumdb;
	&writetree( "dat/topics.dat" );
	print "Location: index.cgi?param=$fields{'param'}\n\n";
	exit;
}

}

sub lockunlockfr {
	&readtree( "dat/topics.dat" );
	my $np = &searchtree( $root, $fr );
	my @fdata = split( /\t/, $$np{'cap'} );
	if( $mystatus{'webmaster'} || $fdata[1] == $thisuser ){
		$fdata[4] = !$fdata[4];
		$$np{'cap'} = join( "\t", @fdata );
		&writetree( "dat/topics.dat" );
	}
	print "Location: index.cgi?param=$fields{'param'}\n\n";
	exit;
}

sub edit {

&readfrm( $fr, ) if $frm;
&readmsg( $fr, $msg ) if $msg;

if( $msg ){
	unless( $mystatus{'webmaster'} || $settings{'allowedit'} &&
		( $mystatus{'manager'} || $thisfrm{'mngrid'} == $thisuser || $thismsg{'authorid'} == $thisuser )
		){
		print "Location: index.cgi?param=$fields{'param'}\n\n";
		exit;
	}
} else {
	unless( $mystatus{'manager'} || $thisfrm{'mngrid'} == $thisuser || $thismsg{'authorid'} == $thisuser ){
		print "Location: index.cgi?param=$fields{'param'}\n\n";
		exit;
	}
}

if( $taskname eq "edit" ){
	if( $msg ){
		&readtree( "dat/fr$fr.dat" );
		$np = &searchtree( $root, $msg );
		@ndata = split( /\t/, $$np{'cap'}, 5 );
		tie( %frdb, $DB_Type, "dat/fr$fr", &GDBM_WRCREAT, 0666 );
		@mdata = split( /\t/, $frdb{$msg}, 5 );
	} else {
		&readtree( "dat/topics.dat" );
		$np = &searchtree( $root, $fr );
		@ndata = split( /\t/, $$np{'cap'}, 5 );
		tie( %frdb, $DB_Type, "dat/forum", &GDBM_WRCREAT, 0666 );
		$mdata[4] = $frdb{'fr'.$fr};
		$dict{'message'} = $dict{'description'};
	}
	$fields{'newtask'} = unpack( "H*", pack( "uS", "editcontinue", $thisuser ) );
	print "\n";
	print <<FORM;
<!doctype html public "-//W3C//DTD HTML 4.0 Transitional//EN">
<html>
<head>
	<meta http-equiv="Content-type" content="text/html; charset=$fields{'charset'}">
	<title>$dict{'edit'}</title>
	<link rel="stylesheet" href="$baseurl/fe.css">
	<style>
	</style>
</head>
<body>
<form method="post" autocomplete="on">
<input type="hidden" name="task" value="$fields{'newtask'}">
<input type="hidden" name="param" value="$fields{'param'}">
<center>
<table border=0 cellspacing=0 cellpadding=0 width="600">
<tr>
<td>
<table border=0 cellspacing=0 cellpadding=0>
<tr height="16">
	<td width=8><img src="$baseurl/img/tagleft.gif" width=8 height=16 border=0></td>
	<td background="$baseurl/img/tagbg.gif"><b>$dict{'edit'}</b></td>
	<td width=8><img src="$baseurl/img/tagright.gif" width=8 height=16 border=0></td>
</tr>
</table>
</td>
</tr>
</table>
$separator
<table border=0 cellpadding=0 cellspacing=1 width="600" bgcolor="black">
<tr><td>
<table border=0 cellspacing=0 cellpadding=2 width="100%" bgcolor="white">
<tr>
	<td align="right">$dict{'title'} (T)</td>
	<td><input type="Text" accesskey="t" name="title" size="50" maxlength="80" value="$ndata[0]">
</tr>
<tr>
	<td align="right">$dict{'message'} (M)</td>
	<td><textarea name="message" accesskey="m" cols="50" rows="12" wrap="VIRTUAL">$mdata[4]</textarea>
</tr>
<tr>
	<td>&nbsp;</td>
	<td><input type="Reset" value="$dict{'cancel'}"> <input type="submit" value="$dict{'update'}"></td>
</tr>
</table>
</td></tr>
</table>
$separator
</center>
</form>
</body>
</html>
FORM
	untie %frdb;
	exit;

} else {

	if( $msg ){
		&readtree( "dat/fr$fr.dat" );
		$np = &searchtree( $root, $msg );
		@ndata = split( /\t/, $$np{'cap'} );
		$ndata[0] = $fields{'title'};
		$$np{'cap'} = join( "\t", @ndata );
		&writetree( "dat/fr$fr.dat" );
		tie( %frdb, $DB_Type, "dat/fr$fr", &GDBM_WRCREAT, 0666 );
		@mdata = split( /\t/, $frdb{$msg}, 5 );
		if( $settings{'wordfilter'} ){
			@badwords = split( /[,|\.]?\s+/, $settings{ 'badwords' . $lang } );
			if( $#badwords >= 0 ){
				foreach( @badwords ){
					$fields{'message'} =~ s/$_/"*" x length($_)/ige;
				}
			}
		}
		$mdata[4] = $fields{'message'};
		$fields{'title'} =~ s/<[^<>	]*>//g;
		$mdata[3] = $fields{'title'};
		$frdb{$msg} = join( "\t", @mdata );
	} else {
		&readtree( "dat/topics.dat" );
		$np = &searchtree( $root, $fr );
		@ndata = split( /\t/, $$np{'cap'} );
		$ndata[0] = $fields{'title'};
		$$np{'cap'} = join( "\t", @ndata );
		&writetree( "dat/topics.dat" );
		$root = 0;
		&readtree( "dat/fr$fr.dat" );
		@ndata = split( /\t/, $$root{'cap'} );
		$ndata[0] = $fields{'title'};
		$$root{'cap'} = join( "\t", @ndata );
		&writetree( "dat/fr$fr.dat" );
		tie( %frdb, $DB_Type, "dat/forum", &GDBM_WRCREAT, 0666 );
		$frdb{'fr'.$fr} = $fields{'message'};
	}
	untie %frdb;
	print "Location: index.cgi?param=$fields{'param'}\n\n";
	exit;
}

}

sub lockunlock {
	&readtree( "dat/fr$fr.dat" );
	my $np = &searchtree( $root, $msg );
	my @ndata = split( /\t/, $$np{'cap'} );
	if( $mystatus{'webmaster'} || ( $mystatus{'member'} && $ndata[1] == $thisuser ) ){
		$ndata[4] = !$ndata[4];
		$$np{'cap'} = join( "\t", @ndata );
		&writetree( "dat/fr$fr.dat" );
	}
	print "Location: index.cgi?param=$fields{'param'}\n\n";
	exit;
}

sub autoinform {
	&readtree( "dat/fr$fr.dat" );
	my $np = &searchtree( $root, $msg );
	my @ndata = split( /\t/, $$np{'cap'} );
	if( $mystatus{'member'} && $ndata[1] == $thisuser ){
		$ndata[4] = ( $taskname eq "autoinform"? 2: 1 );
		$$np{'cap'} = join( "\t", @ndata );
		&writetree( "dat/fr$fr.dat" );
	}
	print "Location: index.cgi?param=$fields{'param'}\n\n";
	exit;
}

# This subroutine is internally used by node-removing subroutines to find out all nodes need to be removed.

sub findnodes {	# Accept a node as paramter, then set the tag fields of all nodes (this and subs).
	my $np = shift;
	my $pp = $$np{'son'};
	if( $pp ){
		if( $$np{'tag'} ){	
			$$np{'tag'} .= ( ":" . $$pp{'id'} );
		} else {
			$$np{'tag'} = $$pp{'id'};
		}
		&findnodes( $pp );
		$pp = $$pp{'next'};
		while( $pp ){
			$$np{'tag'} .= ":" . $$pp{'id'};
			&findnodes( $pp );
			$pp = $$pp{'next'};
		}
	}
	push( @rmnodes, $$np{'id'} ) if( $np != $root );	# The special root node doesn't count.
}

sub findfrnodes {	# Accept a forum node as paramter, then set the tag fields of all nodes (this and subs).
	my $np = shift;
	my $pp = $$np{'son'};
	if( $pp ){
		if( $$np{'tag'} ){	
			$$np{'tag'} .= ( ":fr" . $$pp{'id'} );
		} else {
			$$np{'tag'} = "fr" . $$pp{'id'};
		}
		&findfrnodes( $pp );
		$pp = $$pp{'next'};
		while( $pp ){
			$$np{'tag'} .= ":fr" . $$pp{'id'};
			&findfrnodes( $pp );
			$pp = $$pp{'next'};
		}
	}
	push( @rmfrnodes, $$np{'id'} ) if( $np != $root );	# The special root node doesn't count.
}

sub removemsg {		# Two paramters: forum id, message id
	my ( $frid, $msgid ) = @_;
	my $origtree = $root;	# Save original tree
	&readtree( "dat/fr$frid.dat" );
	my $np = $msgid? &searchtree( $root, $msgid ): $root;
	# If zero, start from root, i.e. deleting the entire tree.
	@rmnodes = ( );		# Reset @rmnodes array each time before finding message nodes.
	&findnodes( $np );
	my( %frdb, $ky );
	tie( %frdb, $DB_Type, "dat/fr$frid", &GDBM_WRCREAT, 0666 );
	foreach $ky ( @rmnodes ){
	# Kill leaves first. For leaves of same level, last one first.
	# Neither the time of post nor id numbers can be used to determine the sequence of removal,
	# only logical relations are reliable!
		$np = &searchtree( $root, $ky );
		my @ndata = split( /\t/, $$np{'cap'}, 5 );
		my @fdata = split( /\t/, $frdb{$ky}, 5 );
		$recbin{$ky} = join( "\t", $frid, $$np{'par'}{'id'}, $$np{'tag'}, @ndata, $fdata[1], $userid, time, $fdata[4] );
		# Fields: forum id, parent id, sons ids, title, authorid, last mod time, reads, status, ip address, eraser id, del time, content.
		&removenode( $np );
		delete $frdb{$ky};
		my $currlang = $lang;
		my( %posttimeinfo, %deltimeinfo );
		foreach $lang (@provlangs) {
			$posttimeinfo{$lang} = &customtime( $ndata[2] );
			$deltimeinfo{$lang} = &customtime( time );
		}
		$lang = $currlang;
		my %newstext = (
			'eng' => qq{Your message "$ndata[0]" posted on $posttimeinfo{'eng'} has been sent to recycle bin on $deltimeinfo{'eng'}.},
			'fr' => qq{Votre message " 123 " &eacute;crit $posttimeinfo{'fr'} a &eacute;t&eacute; retir&eacute; $deltimeinfo{'fr'}.},
			'de' => qq{Ihre Meldung "$ndata[0]" bekanntgegeben an $posttimeinfo{'de'} ist an $deltimeinfo{'de'} gel&ouml;scht worden. },
			'gb' => qq{$posttimeinfo{'gb'}ӡ$ndata[0]Ѿ$deltimeinfo{'gb'}վ},
			'big5' => qq{z_$posttimeinfo{'big5'}ol$ndata[0]wg_$deltimeinfo{'big5'}Qܦ^C},
		);
		&sendnews( $userid, $ndata[1], \($newstext{$lang}) );
	}
	$frdb{'nummsgs'} -= ( $#rmnodes + 1 );
	untie %frdb;
	&writetree( "dat/fr$frid.dat" );
	$root = $origtree;
	return ( $#rmnodes + 1 );
}

sub remove {
	my( %frdb );
	&readtree( "dat/topics.dat" );
	my $frnode = &searchtree( $root, $fr );
	if( $fr && $frnode && $mystatus{'member'} ){
		my @frdata = split( /\t/, $$frnode{'cap'} );
		&readmsg( $fr, $msg );
		if( $thismsg{'authorid'} == $thisuser || $frdata[1] == $thisuser || $mystatus{'manager'} ){
			# Remember %recbin is a global hash.
			tie( %recbin, $DB_Type, "dat/recbin", &GDBM_WRCREAT, 0666 );
			my $rmcnt = &removemsg( $fr, $msg );
			untie %recbin;
			$frdata[3] -= $rmcnt;
			$$frnode{'cap'} = join( "\t", @frdata );
			&writetree( "dat/topics.dat" );
			tie( %frdb, $DB_Type, "dat/forum", &GDBM_WRCREAT, 0666 );
			$frdb{'nummsgs'} -= $rmcnt;
			untie %frdb;
			%frdb = ( );
			tie( %frdb, $DB_Type, "dat/fr$fr", &GDBM_WRCREAT, 0666 );
			$frdb{'nummsgs'} -= $rmcnt;
			untie %frdb;
		}
	}
	$nparam = unpack( "h*", pack( "uS*", $lang, $thisuser, $fr, $pg, $md, 0 ) );
	print "Location: index.cgi?param=$nparam\n\n";
	exit;
}

sub removefr {
	&readtree( "dat/topics.dat" );
	my $np = &searchtree( $root, $fr );
	&readfrm( $fr );
	unless( $np && ( $mystatus{'webmaster'} || ( $mystatus{'senior'} && $thisfrm{'mngrid'} == $thisuser ) ) ){
		print "Location: index.cgi?param=$nparam\n\n";
		exit;
	}
	if( $$np{'son'} && $settings{'disabledeltree'} ){
		&tellerror( "NOT_EMPTY" );
		exit;
	}
	&findfrnodes( $np );
	my $rmcnt = 0;
	# Note now the @rmfrnodes is made, and the tag fields of relevant forum nodes are set.
	tie( %recbin, $DB_Type, "dat/recbin", &GDBM_WRCREAT, 0666 );
	my( $frid, %frdb );
	&readusers( );
	foreach $frid ( @rmfrnodes ){
		&exportfr( $frid );
		$rmcnt += &removemsg( $frid, 0 );
		# Now the @rmnodes is updated to contain the nodes in this forum.
		# Also note the message nodes have been sent to recycle bin by &removemsg.
		$np = &searchtree( $root, $frid );
		&removenode( $np );		# Remove from the forum tree.
		$recbin{ 'fr' . $frid } = join( "\t", 0, $$np{'par'}{'id'}, $$np{'tag'}, $$np{'cap'}, "", $userid, time, "" );
		unlink( "dat/fr$frid.dat" );	# Physically remove the forum data file.
		tie( %frdb, $DB_Type, "dat/fr$frid", &GDBM_WRCREAT, 0666 );
		%frdb = ( );		# Cleanup the forum database. Can't specify a file name to unlink because it varies on different machines.
		untie %frdb;
		@frdata = split( /\t/, $$np{'cap'}, 5 );
		my $currlang = $lang;
		my( %posttimeinfo, %deltimeinfo );
		foreach $lang (@provlangs) {
			$posttimeinfo{$lang} = &customtime( $frdata[2] );
			$deltimeinfo{$lang} = &customtime( time );
		}
		$lang = $currlang;
		my %newstext = (
			'eng' => qq{The forum "$frdata[0]" you created on $posttimeinfo{'eng'} has been sent to recycle bin on $deltimeinfo{'eng'}.},
			'fr' => qq{Le forum "$frdata[0]" que vous avez cr&eacute;&eacute;s $posttimeinfo{'fr'} a &eacute;t&eacute; retir&eacute; $deltimeinfo{'fr'}.},
			'de' => qq{Das Forum "$frdata[0]", das Sie an $posttimeinfo{'de'} sind gel&ouml;scht worden an $deltimeinfo{'de'} erstellten.},
			'gb' => qq{$posttimeinfo{'gb'}顰$frdata[0]Ѿ$deltimeinfo{'gb'}վ},
			'big5' => qq{z_$posttimeinfo{'big5'}إߪQײա$frdata[0]wg_$deltimeinfo{'big5'}Qܦ^C},
		);
		&sendnews( $userid, $frdata[1], \($newstext{ $settings{'defaultlang'} }) );
		&removenode( $np );		# Remove from the forum tree.
	}
	untie %recbin;
	&writetree( "dat/topics.dat" );
	tie( %frdb, $DB_Type, "dat/forum", &GDBM_WRCREAT, 0666 );
	$frdb{'numtopics'} -= ( $#rmfrnodes + 1 );
	$frdb{'nummsgs'} -= $rmcnt;
	untie %forumdb;
	my $nparam = unpack( "h*", pack( "uS*", $lang, $thisuser, 0, $pg, $md, 0 ) );
	print "Location: index.cgi?param=$nparam\n\n";
	exit;
}

sub listtree{
	my $node = shift;
	$dep++;
	print qq{<option value="$treetag$$node{'id'}"}, ( $$node{'id'} == $markedid? " selected": ""), ">";
	if( $dep > 1 ){
		my $dp = $dep;
		my @prefix;
		my $np = $node;
		my $pp = $$np{'par'};
		if( $$np{'next'} ){
			unshift( @prefix, "|-" );
			$np = $pp;
			$pp = $$np{'par'};
			$dp--;
		}
		while( $dp > 1 ){
			if( $$pp{'last'} == $np ){
				unshift( @prefix, $$np{'tag'}? "&nbsp;&nbsp;": "\\-" );
			} else {
				unshift( @prefix, "|&nbsp;" );
			}
			$np = $pp;
			$pp = $$np{'par'};
			$dp--;
		}
		print @prefix;
	}
	$$node{'tag'} = 1;
	if( $$node{'son'} ){
		print "+&nbsp;";
	} else {
		print "-&nbsp;";
	}
	if( $node != $root ){
		my @ndata = split( /\t/, $$node{'cap'} );
		if( length($ndata[0]) > 28 - $dep * 2 ){
			substr( $ndata[0], 28 - $dep * 2 ) = "...";
		}
		print $ndata[0];
	} else {
		print ( $treetag eq "f"? $settings{'bbstitle'}: "( Forum root )" );
	}
	print "</option>\n";
	my $ptr = $$node{'son'};
	if( $ptr ){
		while( $ptr ){
			&listtree( $ptr );
			$ptr = $$ptr{'next'};
		}
	}
	$dep--;
}

sub movenode { 
	&readtree( "dat/topics.dat" );
	$fields{'leftfr'} ||= "f0";
	$fields{'rightfr'} ||= "f0";
	$fields{'leftmsg'} ||= 0;
	$fields{'rightmsg'} ||= 0;
	my $leftfrid = substr( $fields{'leftfr'}, 1 );
	my $rightfrid = substr( $fields{'rightfr'}, 1 );
	if( !$mystatus{'webmaster'} || $fields{'exit.x'} || $fields{'exit.y'} ){
		print "Location: index.cgi?param=$fields{'param'}\n\n";
		exit;
	}
	if( $fields{'lupper.x'} || $fields{'lupper.y'} ){
		if( $fields{'leftmsg'} =~ /^f(\d+)/ ){
			&moveupper( $1 );
			&writetree( "dat/topics.dat" );
		} elsif ( $fields{'leftmsg'} ){
			my $frtree = $root;
			&readtree( "dat/fr$leftfrid.dat" );
			&moveupper( $fields{'leftmsg'} );
			&writetree( "dat/fr$leftfrid.dat" );
			$root = $frtree;
		}
	} elsif( $fields{'llower.x'} || $fields{'llower.y'} ){
		if( $fields{'leftmsg'} =~ /^f(\d+)/ ){
			&movelower( $1 );
			&writetree( "dat/topics.dat" );
		} elsif ( $fields{'leftmsg'} ){
			my $frtree = $root;
			&readtree( "dat/fr$leftfrid.dat" );
			&movelower( $fields{'leftmsg'} );
			&writetree( "dat/fr$leftfrid.dat" );
			$root = $frtree;
		}
	} elsif( $fields{'lsink.x'} || $fields{'lsink.y'} ){
		if( $fields{'leftmsg'} =~ /^f(\d+)/ ){
			&sinknode( $1 );
			&writetree( "dat/topics.dat" );
		} elsif ( $fields{'leftmsg'} ){
			my $frtree = $root;
			&readtree( "dat/fr$leftfrid.dat" );
			&sinknode( $fields{'leftmsg'} );
			&writetree( "dat/fr$leftfrid.dat" );
			$root = $frtree;
		}
	} elsif( $fields{'lbubble.x'} || $fields{'lbubble.y'} ){
		if( $fields{'leftmsg'} =~ /^f(\d+)/ ){
			&bubblenode( $1 );
			&writetree( "dat/topics.dat" );
		} elsif ( $fields{'leftmsg'} ){
			my $frtree = $root;
			&readtree( "dat/fr$leftfrid.dat" );
			&bubblenode( $fields{'leftmsg'} );
			&writetree( "dat/fr$leftfrid.dat" );
			$root = $frtree;
		}
	} elsif( $fields{'rupper.x'} || $fields{'rupper.y'} ){
		if( $fields{'rightmsg'} =~ /^f(\d+)/ ){
			&moveupper( $1 );
			&writetree( "dat/topics.dat" );
		} elsif ( $fields{'rightmsg'} ){
			my $frtree = $root;
			&readtree( "dat/fr$rightfrid.dat" );
			&moveupper( $fields{'rightmsg'} );
			&writetree( "dat/fr$rightfrid.dat" );
			$root = $frtree;
		}
	} elsif( $fields{'rlower.x'} || $fields{'rlower.y'} ){
		if( $fields{'rightmsg'} =~ /^f(\d+)/ ){
			&movelower( $1 );
			&writetree( "dat/topics.dat" );
		} elsif ( $fields{'rightmsg'} ){
			my $frtree = $root;
			&readtree( "dat/fr$rightfrid.dat" );
			&movelower( $fields{'rightmsg'} );
			&writetree( "dat/fr$rightfrid.dat" );
			$root = $frtree;
		}
	} elsif( $fields{'rsink.x'} || $fields{'rsink.y'} ){
		if( $fields{'rightmsg'} =~ /^f(\d+)/ ){
			&sinknode( $1 );
			&writetree( "dat/topics.dat" );
		} elsif ( $fields{'rightmsg'} ){
			my $frtree = $root;
			&readtree( "dat/fr$rightfrid.dat" );
			&sinknode( $fields{'rightmsg'} );
			&writetree( "dat/fr$rightfrid.dat" );
			$root = $frtree;
		}
	} elsif( $fields{'rbubble.x'} || $fields{'rbubble.y'} ){
		if( $fields{'rightmsg'} =~ /^f(\d+)/ ){
			&bubblenode( $1 );
			&writetree( "dat/topics.dat" );
		} elsif ( $fields{'rightmsg'} ){
			my $frtree = $root;
			&readtree( "dat/fr$rightfrid.dat" );
			&bubblenode( $fields{'rightmsg'} );
			&writetree( "dat/fr$rightfrid.dat" );
			$root = $frtree;
		}
	} elsif( $fields{'moveright.x'} || $fields{'moveright.y'} ){
		if ( $fields{'leftmsg'} =~ /^\d+$/ && $fields{'leftmsg'} && $rightfrid ){
			my $frtree = $root;
			&readtree( "dat/fr$leftfrid.dat" );
			my $np = &searchtree( $root, $fields{'leftmsg'} );
			&findnodes( $np );
			&removenode( $np );
			&writetree( "dat/fr$leftfrid.dat" );
			$root = 0;
			&readtree( "dat/fr$rightfrid.dat" );
			my $pp = $root;
			if( !$$pp{'son'} ){
				$$pp{'son'} = $np;
			} else {
				$$np{'prev'} = $$pp{'last'};
				$$pp{'last'}{'next'} = $np;
			}
			$$pp{'last'} = $np;
			$$np{'par'} = $pp;
			$$np{'next'} = 0;
			&writetree( "dat/fr$rightfrid.dat" );
			$root = $frtree;
			tie( %lfrdb, $DB_Type, "dat/fr$leftfrid", &GDBM_WRCREAT, 0666 );
			tie( %rfrdb, $DB_Type, "dat/fr$rightfrid", &GDBM_WRCREAT, 0666 );
			for ( @rmnodes ){
				$rfrdb{$_} = $lfrdb{$_};
				delete $lfrdb{$_};
			}
			$lfrdb{'nummsgs'} -= ( $#rmnodes + 1 );
			$rfrdb{'nummsgs'} += ( $#rmnodes + 1 );
			untie %rfrdb;
			untie %lfrdb;
			$root = 0;
			&readtree( "dat/topics.dat" );
			my $lfrnode = &searchtree( $root, $leftfrid );
			my $rfrnode = &searchtree( $root, $rightfrid );
			my @frdata = split( /\t/, $$lfrnode{'cap'} );
			$frdata[3] -= ( $#rmnodes + 1 );
			$$lfrnode{'cap'} = join( "\t", @frdata );
			@frdata = split( /\t/, $$rfrnode{'cap'} );
			$frdata[3] += ( $#rmnodes + 1 );
			$$rfrnode{'cap'} = join( "\t", @frdata );
			&writetree( "dat/topics.dat" );
		}
	} elsif( $fields{'moveleft.x'} || $fields{'moveleft.y'} ){
		if( $fields{'rightmsg'} =~ /^\d+$/ && $fields{'rightmsg'} && $leftfrid ){
			my $frtree = $root;
			&readtree( "dat/fr$rightfrid.dat" );
			my $np = &searchtree( $root, $fields{'rightmsg'} );
			&findnodes( $np );
			&removenode( $np );
			&writetree( "dat/fr$rightfrid.dat" );
			$root = 0;
			&readtree( "dat/fr$leftfrid.dat" );
			my $pp = $root;
			if( !$$pp{'son'} ){
				$$pp{'son'} = $np;
			} else {
				$$np{'prev'} = $$pp{'last'};
				$$pp{'last'}{'next'} = $np;
			}
			$$pp{'last'} = $np;
			$$np{'par'} = $pp;
			$$np{'next'} = 0;
			&writetree( "dat/fr$leftfrid.dat" );
			$root = $frtree;
			tie( %lfrdb, $DB_Type, "dat/fr$leftfrid", &GDBM_WRCREAT, 0666 );
			tie( %rfrdb, $DB_Type, "dat/fr$rightfrid", &GDBM_WRCREAT, 0666 );
			for ( @rmnodes ){
				$rfrdb{$_} = $lfrdb{$_};
				delete $lfrdb{$_};
			}
			$rfrdb{'nummsgs'} -= ( $#rmnodes + 1 );
			$lfrdb{'nummsgs'} += ( $#rmnodes + 1 );
			untie %rfrdb;
			untie %lfrdb;
			$root = 0;
			&readtree( "dat/topics.dat" );
			my $lfrnode = &searchtree( $root, $leftfrid );
			my $rfrnode = &searchtree( $root, $rightfrid );
			my @frdata = split( /\t/, $$lfrnode{'cap'} );
			$frdata[3] += ( $#rmnodes + 1 );
			$$lfrnode{'cap'} = join( "\t", @frdata );
			@frdata = split( /\t/, $$rfrnode{'cap'} );
			$frdata[3] -= ( $#rmnodes + 1 );
			$$rfrnode{'cap'} = join( "\t", @frdata );
			&writetree( "dat/topics.dat" );
		}
	}
	print qq{
		<html>
		<head>
		<link rel="stylesheet" href="$baseurl/fe.css">
		<style>
		td.tcell {
			background-image: url("$baseurl/img/tblwhitebg.gif");
		}
		</style>
		</head>
		<body>
		<form action="admin.cgi" method="post">
		<input type="Hidden" name="task" value="$fields{'task'}">
		<input type="Hidden" name="param" value="$fields{'param'}">
		<center>
		<table border=0 cellspacing=0 cellpadding=0 width="600">
		<tr>
		<td>
		<table border=0 cellspacing=0 cellpadding=0>
		<tr height="16">
			<td width=8><img src="$baseurl/img/tagleft.gif" width=8 height=16 border=0></td>
			<td background="$baseurl/img/tagbg.gif"><b>Move form/message nodes</b></td>
			<td width=8><img src="$baseurl/img/tagright.gif" width=8 height=16 border=0></td>
		</tr>
		</table>
		</td>
		</tr>
		</table>
	}, $separator, qq{
		<table border=0 cellpadding=0 cellspacing=1 width="600" bgcolor="black">
	};
	print qq{
		<tr>
		<td class="tcell">
		<select name="leftfr" size=1 style="font-family: Courier; font-size: 10pt;" onChange="this.form.submit( );">
	};
	$markedid = $leftfrid;
	&listtree( $root );
	print qq{
		</select>
		</td>
		<td class="tcell" align="center">
		<input type="Image" width=32 height=32 border=0 name="refresh" src="$baseurl/img/gogo.gif" alt="$dict{'refresh'}">
		</td>
	};
	print qq{
		<td class="tcell" align="right">
		<select name="rightfr" size=1 style="font-family: Courier; font-size: 10pt;" onChange="this.form.submit( );">
	};
	$markedid = $rightfrid;
	&readtree( "dat/topics.dat" );
	&listtree( $root );
	print qq{
		</select>
		</td>
		</tr>
	};
	print qq{
		<tr>
		<td class="tcell">
		<select name="leftmsg" size=16 style="font-family: Courier; font-size: 10pt;">
		<option value="0">--------S U B T O P I C--------</option>
	};
	$markedid = $leftfrid;
	&readtree( "dat/topics.dat" );
	&listtree( &searchtree( $root, $markedid ) );
	$treetag = "";
	if( $markedid ){
		print qq{
			<option value="0">--------M E S S A G E S--------</option>
		};
		&readtree( "dat/fr$leftfrid.dat" );
		$markedid = $fields{'leftmsg'};
		&listtree( $root );
	}
	$treetag = "f";
	print qq{
		</select>
		</td>
		<td class="tcell" align="center" valign="center">
		<input type="Image" width=32 height=32 border=0 name="moveleft" src="$baseurl/img/goleft.gif" alt="$dict{'left'}"><br>
		<input type="Image" width=32 height=32 border=0 name="moveright" src="$baseurl/img/goright.gif" alt="$dict{'right'}">
		</td>
	};
	print qq{
		<td class="tcell" align="right">
		<select name="rightmsg" size=16 style="font-family: Courier; font-size: 10pt;">
		<option value="0">--------S U B T O P I C--------</option>
	};
	$markedid = $rightfrid;
	&readtree( "dat/topics.dat" );
	&listtree( &searchtree( $root, $markedid ) );
	$treetag = "";
	if( $markedid ){
		print qq{
			<option value="0">--------M E S S A G E S--------</option>
		};
		&readtree( "dat/fr$rightfrid.dat" );
		$markedid = $fields{'rightmsg'};
		&listtree( $root );
	}
	$treetag = "f";
	print qq{
		</select>
		</td>
		</tr>
		<tr>
		<td class="tcell" align="left">
		<input type="Image" width=32 height=32 border=0 name="lbubble" src="$baseurl/img/goup.gif" alt="$dict{'bubble'}">
		<input type="Image" width=32 height=32 border=0 name="lsink" src="$baseurl/img/godown.gif" alt="$dict{'sink'}">
		<input type="Image" width=32 height=32 border=0 name="lupper" src="$baseurl/img/goleft.gif" alt="$dict{'upper'}">
		<input type="Image" width=32 height=32 border=0 name="llower" src="$baseurl/img/goright.gif" alt="$dict{'lower'}">
		</td>
		<td class="tcell">
		<input type="Image" width=32 height=32 border=0 name="exit" src="$baseurl/img/goexit.gif" alt="$dict{'exit'}">
		</td>
		<td class="tcell" align="right">
		<input type="Image" width=32 height=32 border=0 name="rbubble" src="$baseurl/img/goup.gif" alt="$dict{'bubble'}">
		<input type="Image" width=32 height=32 border=0 name="rsink" src="$baseurl/img/godown.gif" alt="$dict{'sink'}">
		<input type="Image" width=32 height=32 border=0 name="rupper" src="$baseurl/img/goleft.gif" alt="$dict{'upper'}">
		<input type="Image" width=32 height=32 border=0 name="rlower" src="$baseurl/img/goright.gif" alt="$dict{'lower'}">
		</td>
		</tr>
		</table>
		$separator
		</center>
		</form>
		</body>
		</html>
	};
	exit;
}

sub showuserinfo {
	for( sort keys %userinfo ) {
		print qq{<b>$dict{$_}</b>: $userinfo{$_}<br>\n};
	}
}

sub users {
	if( !$mystatus{'webmaster'} || $fields{'exit.x'} || $fields{'exit.y'} ){
		print "Location: index.cgi?param=$fields{'param'}\n\n";
		exit;
	}
	&readusers;
	if( !defined $fields{'ugroup'} ){
		$fields{'ugroup'} = 0;
	}
	if( ( $fields{'delete.x'} || $fields{'delete.y'} )  && $fields{'userlist'} ){
		my @selusers = split( /\s+/, $fields{'userlist'} );
		$fields{'userlist'} = "";
		tie( %ugroup, $DB_Type, "dat/users", &GDBM_WRCREAT, 0666 );
		foreach $seluserid( @selusers ) {
			delete $ugroup{$seluserid};
			delete $users{$seluserid};
			for( 0..5 ){
				$ugroup{"g" . $_} =~ s/(\t?)\b$seluserid\b(\t?)/(length($1.$2)-1)x"\t"/e;
			}
			$ugroup{'numusers'} -= 1;
		}
		untie %ugroup;
	}
	if( ( $fields{'add.x'} || $fields{'add.y'} ) && $fields{'userlist'} ){
		tie( %ugroup, $DB_Type, "dat/users", &GDBM_WRCREAT, 0666 );
		@selusers = split( /\s+/, $fields{'userlist'} );
		if( $fields{'ugroup'} < 6 ){
			my @grpusers = split( /\t/, $ugroup{ 'g' . $fields{'ugroup'}} );
			my %grpusershash = map { $_ => 1 } @grpusers;
			foreach( @selusers ){
				$grpusershash{$_} = 1;
			}
			@grpusers = keys %grpusershash;
			$ugroup{ 'g' . $fields{'ugroup'} } = join( "\t", @grpusers );
			if( $fields{'ugroup'} == 0 ){
				foreach $seluserid ( @selusers ){
					my @userdata = split( /\t/, $ugroup{ $seluserid } );
					$userdata[2] = $sBanned;
					$ugroup{ $seluserid } = join( "\t", @userdata );
				}
			}
		} else {
			foreach $seluserid ( @selusers ){
				my @userdata = split( /\t/, $ugroup{ $seluserid } );
				$userdata[2] = $fields{'ugroup'} - 2;
				$ugroup{ $seluserid } = join( "\t", @userdata );
			}
		}
		untie %ugroup;
	} elsif( ( $fields{'remove.x'} || $fields{'remove.y'} ) && $fields{'grouplist'} ){
		tie( %ugroup, $DB_Type, "dat/users", &GDBM_WRCREAT, 0666 );
		@selusers = split( /\s+/, $fields{'grouplist'} );
		if( $fields{'ugroup'} < 6 ){
			my @grpusers = split( /\t/, $ugroup{ 'g' . $fields{'ugroup'}} );
			my %grpusershash = map { $_ => 1 } @grpusers;
			foreach( @selusers ){
				delete $grpusershash{$_};
			}
			@grpusers = keys %grpusershash;
			$ugroup{ 'g' . $fields{'ugroup'}} = join( "\t", @grpusers );
			if( $fields{'ugroup'} == 0 ){
				foreach $seluserid ( @selusers ){
					my @userdata = split( /\t/, $ugroup{ $seluserid } );
					$userdata[2] = $sMember;
					$ugroup{ $seluserid } = join( "\t", @userdata );
				}
			}
		} else {
			foreach $seluserid ( @selusers ){
				my @userdata = split( /\t/, $ugroup{ $seluserid } );
				$userdata[2]--;
				$ugroup{ $seluserid } = join( "\t", @userdata );
			}
		}
		untie %ugroup;
	}
	print qq{
		<html>
		<head>
		<link rel="stylesheet" href="$baseurl/fe.css">
		<style>
		td.tcell {
			background-image: url("$baseurl/img/tblwhitebg.gif");
		}
		</style>
		</head>
		<body>
		<form action="admin.cgi" method="post">
		<input type="Hidden" name="task" value="$fields{'task'}">
		<input type="Hidden" name="param" value="$fields{'param'}">
		<center>
		<table border=0 cellspacing=0 cellpadding=0 width="600">
		<tr>
		<td>
		<table border=0 cellspacing=0 cellpadding=0>
		<tr height="16">
			<td width=8><img src="$baseurl/img/tagleft.gif" width=8 height=16 border=0></td>
			<td background="$baseurl/img/tagbg.gif"><b>User management</b></td>
			<td width=8><img src="$baseurl/img/tagright.gif" width=8 height=16 border=0></td>
		</tr>
		</table>
		</td>
		</tr>
		</table>
	}, $separator, qq{
		<table border=0 cellpadding=2 cellspacing=1 width="600" bgcolor="black">
		<tr>
		<td class="tcell" valign="top">
		User groups<br>
		<select name="ugroup" size=1 style="font-family: Courier; font-size: 10pt; width: 250" onChange="this.form.submit( );">
	};
	my @grpnames = ( "Banned Users", "Red Team", "Blue Team", "White Team", "Yellow Team", "Green Team", "Senior Members", "Managers" );
	for( 0..$#grpnames ){
		my $isselected = ( ( $fields{'ugroup'} == $_ )? "selected": "" );
		print qq{<option value="$_" $isselected>$grpnames[$_]</option>\n};
	}
	print qq{
		</select>
		<br>
		<select name="grouplist" size=10 multiple style="font-family: Courier; font-size: 10pt; width: 250" onDblClick="this.form.submit();">
	};
	tie( %ugroup, $DB_Type, "dat/users", &GDBM_WRCREAT, 0666 );
	@grpusers = ( );
	if( $fields{'ugroup'} < 6 ){
		@grpusers = split( /\t/, $ugroup{ 'g' . $fields{'ugroup'} } );
	} else {
		foreach( keys %ugroup ){
			next unless( /^(\d+)$/ );
			my $tempvar = $1;
			my @userdata = split( /\t/, $ugroup{$_}, 4 );
			next if( $userdata[2] != $fields{'ugroup'} - 2 );
			push( @grpusers, $tempvar );
		}
	}
	untie %ugroup;
	if( $#grpusers < 0 ){
		print qq{<option value="0">--------N O   U S E R S--------</option>\n};
	} else {
		@grpusers = sort { uc( $users{$a} ) cmp uc( $users{$b} ) } @grpusers;
		foreach( @grpusers ){
			my $isselected = ( ( $fields{'grouplist'} == $_ )? "selected": "" );
			print qq{<option value="$_" $isselected>$users{$_}</option>\n};
		}
	}
	print qq{
		</select>
		</td>
		<td class="tcell" width=36 valign="middle" align="center">
		<input type="Image" width=32 height=32 border=0 name="refresh" src="$baseurl/img/gogo.gif" alt="$dict{'refresh'}"><br>
		<input type="Image" width=32 height=32 border=0 name="add" src="$baseurl/img/goleft.gif" alt="$dict{'add'}"><br>
		<input type="Image" width=32 height=32 border=0 name="remove" src="$baseurl/img/goright.gif" alt="$dict{'remove'}"><br>
		<input type="Image" width=32 height=32 border=0 name="delete" src="$baseurl/img/goremove.gif" alt="$dict{'delete'}"><br>
		<a href="utils.cgi?task=} . unpack( "H*", pack( "uS*", "exportusers", $thisuser ) ) .qq{" target="_blank"><img src="$baseurl/img/gosendmail.gif" border=0 width=32 height=32></a>
		</td>
		<td class="tcell">
		Registered users<br>
		<select name="userlist" size=16 multiple style="font-family: Courier; font-size: 10pt; width: 250" onDblClick="this.form.submit();">
	};
	@allusers = grep{ /^\d+$/ } sort { uc( $users{$a} ) cmp uc( $users{$b} ) } keys %users;
	for( @allusers ){
		next if( $_ <= 1 );		# Webmaster or guest does not count.
		my $isselected = ( ( $fields{'userlist'} == $_ )? "selected": "" );
		print qq{<option value="$_" $isselected>$users{$_}</option>\n};
	}
	print qq{
		</select>
		</td>
		</tr>
		<tr>
	};
	print "<td class=tcell valign=top>";
	if( $fields{'grouplist'} =~ /^(\d+)/ ){
		&getuserinfo( $1 );
		&showuserinfo;
	} else {
		print "&nbsp;";
	}
	print qq{
		</td><td class=tcell valign="top" align="center">
		<input type="Image" width=32 height=32 border=0 name="exit" src="$baseurl/img/goexit.gif" alt="$dict{'exit'}">
		</td><td class=tcell valign=top>
	};
	if( $fields{'userlist'} =~ /^(\d+)/ && $fields{'grouplist'} !~ /$1/ ){
		&getuserinfo( $1 );
		&showuserinfo;
	} else {
		print "&nbsp;";
	}
	print qq{
		</td>
		</tr>
		</table>
		$separator
		</center>
		</form>
		</body>
		</html>
	};
	exit;
}

sub dictionary {
	if( !$mystatus{'webmaster'} || $fields{'exit.x'} || $fields{'exit.y'} ){
		print "Location: index.cgi?param=$fields{'param'}\n\n";
		exit;
	}
	$destlang = $fields{'destlang'} || $lang;
	foreach( @provlangs ){
		if( $fields{ $_ . '.x' } || $fields{ $_ . '.y' } ){
			$destlang = $_;
			last;
		}
	}
	if( $fields{'eterms'} && ( $fields{'update.x'} || $fields{'update.y'} ) && $fields{'newtext'} ){
		tie( %destdict, $DB_Type, "dat/$destlang", &GDBM_WRCREAT, 0666 );
		$destdict{$fields{'eterms'}} = $fields{'newtext'};
		untie %destdict;
	}
	print qq{
		<html>
		<head>
		<meta http-equiv="Content-type" content="text/html; charset=$charsets{$destlang}">
		<link rel="stylesheet" href="$baseurl/fe.css">
		<style>
		td.tcell {
			background-image: url("$baseurl/img/tblwhitebg.gif");
		}
		</style>
		</head>
		<body>
		<form action="admin.cgi" method="post">
		<input type="Hidden" name="task" value="$fields{'task'}">
		<input type="Hidden" name="param" value="$fields{'param'}">
		<input type="Hidden" name="destlang" value="$destlang">
		<center>
		<table border=0 cellspacing=0 cellpadding=0 width="600">
		<tr>
		<td>
		<table border=0 cellspacing=0 cellpadding=0>
		<tr height="16">
			<td width=8><img src="$baseurl/img/tagleft.gif" width=8 height=16 border=0></td>
			<td background="$baseurl/img/tagbg.gif"><b>Dictionary management</b></td>
			<td width=8><img src="$baseurl/img/tagright.gif" width=8 height=16 border=0></td>
		</tr>
		</table>
		</td>
		</tr>
		</table>
	}, $separator, qq{
		<table border=0 cellpadding=2 cellspacing=1 width="600" bgcolor="black">
		<tr>
		<td class="tcell">
		English terms<br>
		<select name="eterms" size=16 style="font-family: Courier; font-size: 10pt; width: 500" onChange="this.form.newtext.value=terms[this.selectedIndex];">
	};
	$currlang = $lang;
	$lang = "eng";
	&makedict;
	my @dictterms = sort { uc($dict{$a}) cmp uc($dict{$b}) } keys %dict;
	for( @dictterms ){
		$isselected = ( ( $fields{'eterms'} eq $_ )? "selected": "" );
		print qq{<option value="$_" $isselected>$dict{$_}</option>\n};
	}
	print qq{
		</select>
		</td>
		<td class="tcell" valign="top">
	};
	foreach $langname ( @provlangs ) {
		$isonoff = ( $langname eq $destlang )? "on": "";
		print qq{ <br><input type="Image" src="$baseurl/img/lang$langname$isonoff.gif" border=0 name="$langname" alt="$dict{$langname}"> };
	}
	$lang = $destlang;
	&makedict;
	print qq{
		<script language="JavaScript">
		var terms = new Array;
	};
	for( 0..$#dictterms ){
		print qq{terms[$_] = "$dict{$dictterms[$_]}";\n};
	}
	$lang = $currlang;
	print qq{
		</script>
		</td>
		</tr>
		<tr><td class="tcell">
		<input type="Text" size=40 maxlength=200 name="newtext" value="$dict{$fields{'eterms'}}" style="font-family: Courier; font-size: 10pt;">
		<input type="Image" width=32 height=32 border=0 name="update" src="$baseurl/img/goupdate.gif" alt="$dict{'update'}">
	};
	print qq{
		</td><td class="tcell">
		<input type="Image" width=32 height=32 border=0 name="exit" src="$baseurl/img/goexit.gif" alt="$dict{'exit'}">
		</td></tr>
		</table>
		$separator
		</center>
		</form>
		</body>
		</html>
	};
	exit;
}

sub travftree {
	my $node = shift;
	$dep++;
	my @frdata = split( /\t/, $$node{'cap'} );
	if( !$frdata[4] || !$$node{'id'} ){
		print qq{<option value="">};
	} elsif( $$node{'id'} == $settings{'mailinfrid'} ){
		print qq{<option value="$$node{'id'}" selected>};
	} else {
		print qq{<option value="$$node{'id'}">};
	}
	if( $dep > 1 ){
		my $dp = $dep;
		my $prefix = "";
		my $np = $node;
		my $pp = $$np{'par'};
		if( $$np{'next'} ){
			$prefix = "|-";
			$np = $pp;
			$pp = $$np{'par'};
			$dp--;
		}
		while( $dp > 1 ){
			if( $$pp{'last'} == $np ){
				$prefix = ( $$np{'tag'}? "&nbsp; ": "\\-" ) . $prefix;
			} else {
				$prefix = "| " . $prefix;
			}
			$np = $pp;
			$pp = $$np{'par'};
			$dp--;
		}
		print $prefix;
	}
	$$node{'tag'} = 100;
	if( $$node{'son'} ){
		$jumpform .= "+ ";
	} else {
		$jumpform .= "- ";
	}
	my $displen = MAXTITLECLIP - $dep * 2;
	if( $displen < 4 ){
		$displen = 4;
	}
	if( length( $frdata[0] ) > $displen ){
		substr( $frdata[0], $displen ) = "...";
	}
	print $frdata[0], "</option>\n";
	my $ptr = $$node{'son'};
	if( $ptr ){
		while( $ptr ){
			&travftree( $ptr );
			$ptr = $$ptr{'next'};
		}
	}
	$dep--;
}

sub setup {

if( !$mystatus{'webmaster'} || $fields{'exit.x'} || $fields{'exit.y'} ){
	print "Location: index.cgi?param=$fields{'param'}\n\n";
	exit;
}

$langsub = { 'eng' => 0, 'fr' => 1, 'de' => 2, 'gb' => 3, 'big5' => 4 }->{$lang};
@checked = ( "", "checked" );

# The following four lines is for debug only.
%tabcaps = (
	'post' => [ "Posting", "Affichage", "Schreiben", "ѡ", "[Kﶵ" ],
	'view' => [ "Browsing", "Navigation", "Navigation", "ѡ", "sﶵ" ],
	'color' => [ "Colors", "Couleurs", "Farben", "ɫ", "mtm" ],
	'admin' => [ "Parameters", "Param&egrave;tres", "Parameter", "̳", "׾°Ѽ" ],
	'user' => [ "User profile", "Profil d'utilisateur", "Benutzerprofil", "û", "Τu" ],
);

if( !{'view' => 1, 'post' => 1, 'color' => 1, 'admin' => 1, 'user' => 1}->{$fields{'grp'}} ){
	$fields{'grp'} = "post";
}

print qq{
	<html>
	<head>
	<link rel="stylesheet" href="$baseurl/fe.css">
	</head>
	<body>
	<form action="admin.cgi" method="post" onSubmit="return validate( this );">
	<input type="Hidden" name="task" value="$fields{'task'}">
	<input type="Hidden" name="param" value="$fields{'param'}">
	<center>
	<table border=0 cellspacing=0 cellpadding=0 width="600">
	<tr>
		<td>
		<table border=0 cellpadding=0 cellspacing=0>
		<tr>
};

foreach $paramgrp ( "post", "view", "color", "admin", "user" ){
	print ( $paramgrp eq $fields{'grp'} ?
		qq{
		<td width=8><img src="$baseurl/img/tagleft.gif" width=8 height=16 border=0></td>
		<td background="$baseurl/img/tagbg.gif"><b>$tabcaps{$paramgrp}[$langsub]</b></td>
		<td width=8><img src="$baseurl/img/tagright.gif" width=8 height=16 border=0></td>
		}:
		qq{
		<td width=8><img src="$baseurl/img/tagleftoff.gif" width=8 height=16 border=0></td>
		<td background="$baseurl/img/tagbgoff.gif"><a href="admin.cgi?task=$fields{'task'}&amp;param=$fields{'param'}&amp;grp=$paramgrp"><font color="white"><b>$tabcaps{$paramgrp}[$langsub]</b></font></a></td>
		<td width=8><img src="$baseurl/img/tagrightoff.gif" width=8 height=16 border=0></td>
		}
	);
}

print qq{
	</tr>
	</table>
	</td></tr></table>
	$separator
	<table width=600 border=0 cellspacing=0 cellpadding=1>
	<tr>
	<td bgcolor="$settings{'tblbg'}">
	<table width=100% border=0 cellpadding=2 cellspacing=0>
	<tr>
	<td bgcolor="white">
	<input type="Image" width=32 height=32 border=0 name="exit" align="right" src="$baseurl/img/goexit.gif" alt="$dict{'exit'}">
	<input type="Image" width=32 height=32 border=0 name="update" align="right" src="$baseurl/img/goupdate.gif" alt="$dict{'update'}">
};

if( $fields{'grp'} eq "post" ){

if( $fields{'update.x'} || $fields{'update.y'} ){
	tie( %frdb, $DB_Type, "dat/forum", &GDBM_WRCREAT, 0666 );
	for( qw(guestpost allowhtml allowedit appendlast autoinform sendmeall wordfilter maxreplydepth newmsgtime mailinpost pop3server pop3interval pop3user pop3pass mailinfrid) ){
		$frdb{$_} = $settings{$_} = $fields{$_};
	}
	for( @provlangs ){
		my $t = "badwords" . $_;
		$fields{$t} =~ s/^\s+//;
		$fields{$t} =~ s/\s+$//;
		$frdb{$t} = $settings{$t} = $fields{$t} if( defined $fields{$t} );
	}
	untie %frdb;
}

print qq{<input type="Hidden" name="grp" value="post">\n};
%msgs = (
'guestpost' => [
	qq{Allow guests to post messages.},
	qq{Permet aux invit&eacute;s d'afficher des messages.},
	qq{Erlauben G&auml;sten Meldungen bekanntzugeben.},
	qq{ÿͷ},
	qq~\\OWXHNC~,
	],
'allowhtml' => [
	qq{Permit the use of HTML tags in messages.},
	qq{Permet l'usage de code HTML dans les messages.},
	qq{Erm&ouml;glichen den Gebrauch HTML im Meldung Inhalt.},
	qq{ıʹHTMLǡ},
	qq~\\b奻ϥHTMLаOC~,
	],
'appendlast' => [
	qq{Keep the follow-up list of a message in chronological order, otherwise newest atop.},
	qq{Conserve la liste des messages dans un ordre chronologique, ou encore du plus r&eacute;sent au plus ancien.},
	qq{Halten geantwortet von einer Meldung in zeitlicher Reihenfolge, plazieren andernfalls neuestes auf die Oberseite.},
	qq{ʱ˳ибӷ档},
	qq~ɶǱƦC^KCA_hsKlb̤WC~,
	],
'allowedit' => [
	qq{Allow content modification after posting.},
	qq{Permettez la modification contente apr&egrave;s la signalisation.},
	qq{Nach der Eintragung erlauben zufriedene &Auml;nderung.},
	qq{߶ӽб༭},
	qq~\\\@̹恵lisC~,
	],
'autoinform' => [
	qq{Allow email auto-notification of replies to a message.},
	qq{Avertissement automatique disponible pour une r&eacute;ponse re&ccedil;ue un message.},
	qq{Erlauben Email-Mitteilung von Antworten auf eine Meldung.},
	qq{ŸԶ֪ͨܡ},
	qq~۩K۰ʳq\\C~,
	],
'sendmeall' => [
	qq{Send me a copy of ALL new messages posted in the entire forum.},
	qq{R&eacute;ception d'une copie de TOUS les nouveaux messages affich&eacute;s dans l'ensemble forum.},
	qq{Schicken mir ein Exemplar aller neuen Meldungen, die in das gesamte Forum geschrieben werden.},
	qq{еӶһ͸ҵ䡣},
	qq~Ҧsl@eڪlcC~,
	],
'wordfilter' => [
	qq{Fitler out these offensive words (separate them by a comma, semicolon, or just space):},
	qq{Filtre pour le langage abusif (s&eacute;parez les par une virgule, un point-virgule ou un espace).},
	qq{Fitler aus diesen beleidigenden W&ouml;rtern (trennen Sie sie durch ein Komma, einen Semicolon oder einen geraden Platz):},
	qq{²öšֺŻոָ},
	qq~LopU}y]iγrBΪŮj^G~,
	],
'maxreplydepth' => [
	qq{Maximum level of replies (0 if unlimited): },
	qq{Niveau maximum des r&eacute;ponses (0 s' illimit&eacute;):},
	qq{Maximale Stufe der Antworten (0, wenn unbegrenzt):},
	qq{޶0},
	qq~̤jKżơ]Yw0^G~,
	],
'newmsgtime' => [
	qq{Mark new messages that were posted within last <input type="Text" name="newmsgtime" value="$settings{'newmsgtime'}" size="4" maxlength="4"> hours.},
	qq{Marquez les nouveaux messages qui ont &eacute;t&eacute; signal&eacute;s dans le bout pendant <input type="Text" name="newmsgtime" value="$settings{'newmsgtime'}" size="4" maxlength="4"> heures.},
	qq{Kennzeichnen neue Meldungen, die innerhalb des Letzten <input type="Text" name="newmsgtime" value="$settings{'newmsgtime'}" size="4" maxlength="4"> Stunden bekanntgegeben wurden.},
	qq{ǹȥ<input type="Text" name="newmsgtime" value="$settings{'newmsgtime'}" size="4" maxlength="4">Сʱ֮ڷΪ},
	qq~аOLh<input type="Text" name="newmsgtime" value="$settings{'newmsgtime'}" size="4" maxlength="4">pɤolsKC~,
	],
'mailinpost' => [
	q{Allow posting messages via email.},
	q{Permettez les messages d'&eacute;criture par l'email.},
	q{Erlauben Schreiben Meldungen durch email},
	q{ͨʼ},
	q{e\\qLqllWKC},
	],
'pop3server' => [
	q{POP3 mail server},
	q{Mail server POP3},
	q{Mail server POP3},
	q{POP3},
	q{POP3lcAȾ},
	],
'pop3interval' => [
	qq{Check POP3 mailbox every <input type="Text" name="pop3interval" value="$settings{'pop3interval'}" size="4" maxlength="4"> minutes.},
	qq{Contr&ocirc;lez la bo&icirc;te aux lettres POP3 toutes les <input type="Text" name="pop3interval" value="$settings{'pop3interval'}" size="4" maxlength="4"> minutes.},
	qq{&Uuml;berpr&uuml;fen Sie Mailbox POP3 alle <input type="Text" name="pop3interval" value="$settings{'pop3interval'}" size="4" maxlength="4"> Minuten.},
	qq{ÿ<input type="Text" name="pop3interval" value="$settings{'pop3interval'}" size="4" maxlength="4">Ӽһ䡣},
	qq{Cj<input type="Text" name="pop3interval" value="$settings{'pop3interval'}" size="4" maxlength="4">ˬd\@lcC},
	],
'mailinfrid' => [
	qq{Import all mail-in posts to this forum:},
	qq{Importez tous courrier des poteaux vers ce forum.},
	qq{Importieren Sie alle emailpfosten zu diesem Forum.},
	qq{ʼȫ͵飺},
	qq{l[KeӰQײաG},
	],
'myerr' => [
	qq{The forum you designated is closed. Please use another one.},
	qq{Le forum que vous avez indiqu est ferm. Veuillez utiliser encore.},
	qq{Das Forum, das Sie kennzeichneten, ist geschlossen. Verwenden Sie bitte ein anderes.},
	qq{ָѹرգѡ},
	qq{zwQײդwAХt\@ܡC},
	],
);

foreach( (qw(guestpost allowhtml appendlast allowedit autoinform sendmeall mailinpost)) ){
	print qq{
	<input type="Checkbox" name="$_" value="1" $checked[$settings{$_}]> $msgs{$_}[$langsub]<br>
	};
}

print qq{
	<img src="$baseurl/img/clear.gif" width="20" heigth="10"> $msgs{'pop3server'}[$langsub]
	<input type="Text" name="pop3server" value="$settings{'pop3server'}" size=40 maxlength=60><br>
	<img src="$baseurl/img/clear.gif" width="20" heigth="10">
	$dict{'username'} <input type="Text" name="pop3user" value="$settings{'pop3user'}" size=12 maxlength=40> &nbsp;&nbsp;
	$dict{'password'} <input type="Password" name="pop3pass" value="$settings{'pop3pass'}" size=12 maxlength=40> <br>
	<img src="$baseurl/img/clear.gif" width="20" heigth="10"> $msgs{'pop3interval'}[$langsub] <br>
	<img src="$baseurl/img/decdiamond.gif" width=11 height=11 border=0> 
	$msgs{'mailinfrid'}[$langsub]<br><img src="$baseurl/img/clear.gif" width="20" heigth="10"> 
	<select name="mailinfrid" size="6">
};

&readtree( "dat/topics.dat" );
&travftree( $root );

print qq{
	</select><br>
	<input type="Checkbox" name="wordfilter" value="1" $checked[$settings{'worlfilter'}]> $msgs{'wordfilter'}[$langsub]<br>
};

for( @availlangs ){
	my $t = "badwords" . $_;
	print qq{
	<img src="$baseurl/img/clear.gif" width="20" heigth="10"> <input type="Text" name="$t" value="$settings{$t}" size=30 maxlength=200> <img src="$baseurl/img/lang$_.gif"> <br>
	};
}

print qq{
	<img src="$baseurl/img/decdiamond.gif" width=11 height=11 border=0> $msgs{'maxreplydepth'}[$langsub] <input type="Text" name="maxreplydepth" value="$settings{'maxreplydepth'}" maxlength=2 size=2><br>
	<img src="$baseurl/img/decdiamond.gif" width=11 height=11 border=0> $msgs{'newmsgtime'}[$langsub]<br>
	<script language="Javascript">
	function validate( frm ){
		if( frm.mailinpost.check && !frm.mailinfrid.value ){
			alert( "$msgs{'myerr'}[$langsub]" );
			return false;
		}
		return true;
	}
	</script>
};

} elsif( $fields{'grp'} eq "view" ){

if( $fields{'update.x'} || $fields{'update.y'} ){
	tie( %frdb, $DB_Type, "dat/forum", &GDBM_WRCREAT, 0666 );
	for( qw(toolbarstyle upperlinkstyle expandall hidelangbuttons hideonline hidepoptopics jumpform markwebmaster markusergroups maxlistentry skipcountsubs countsubhits findemoticons findhyperlinks hideip insertimage showfollowups) ){
		$frdb{$_} = $settings{$_} = $fields{$_};
	}
	untie %frdb;
}

print qq{<input type="Hidden" name="grp" value="view">\n};
%msgs = (
'toolbarstyle' => [
	qq{Toolbar style:},
	qq{Mod&egrave;le de Toolbar:},
	qq{Art Toolbar},
	qq{ʽ},
	qq{u˦G},
	],
'tbstyle0' => [
	qq{Show icons only},
	qq{Graphismes seulement},
	qq{Nur Ikonen},
	qq{ֻʾͼ},
	qq{Nܹϼ},
	],
'tbstyle1' => [
	qq{Icons and text},
	qq{Graphismes et texte},
	qq{Ikonen und Text},
	qq{ʾͼ},
	qq{ܹϼЩMr},
	],
'tbstyle2' => [
	qq{Show text only},
	qq{Texte seulement},
	qq{Nur Text},
	qq{ֻʾ},
	qq{Nܤr},
	],
'expandall' => [
	qq{Expand all trees in index pages by default.},
	qq{Expansion de tous les arbres d'index par d&eacute;faut.},
	qq{Erweitern immer alle B&auml;ume in den Indexseiten.},
	qq{Ŀ¼Ĭչз֧㡣},
	qq~ؿq{i۩Ҧ䵲IC~,
	],
'markwebmaster' => [
	qq{Mark messages posted by the webmaster.},
	qq{S&eacute;lectionner les messages affich&eacute;s par le ma&icirc;tre du forum.},
	qq{Kennzeichnen die Meldungen, die vom Verwalter geschrieben werden.},
	qq{ǰ񷢵ӡ},
	qq~аOiiܡC~,
	],
'markusergroups' => [
	qq{Show special user group marks (up to five groups).},
	qq{Afficher les s&eacute;lections des groupes d'usagers sp&eacute;ciaux (maximum de cinq groupes).},
	qq{Zeigen spezielle Benutzergruppe Markierungen (bis f&uuml;nf Gruppen).},
	qq{ʾû飨飩},
	qq~ܷ|SOpա]̦hա^C~,
	],
'hidepoptopics' => [
	qq{Do not show popular topics in main index page.},
	qq{Ne pas afficher la liste des sujets les plus populaires dans l'index principal.},
	qq{Zeigen die popul&auml;re Themen nicht in der Hauptindexseite.},
	qq{ҳʾŻ⡱},
	qq~DܡD~,
	],
'hideonline' => [
	qq{Do not show online users list and the instant messager form.},
	qq{Ne pas afficher la liste des usagers actifs et la fen&ecirc;tre du message instant.},
	qq{Zeigen nicht Onlinebenutzerliste und Momentmessagerformular.},
	qq{ʾûбʱѶϢ},
	qq~ܦbu|CΧYɰTءC~,
	],
'hidelangbuttons' => [
	qq{Do not show the language selection buttons.},
	qq{Ne pas afficher les boutons de s&eacute;lection de la langue.},
	qq{Zeigen nicht die Sprachauswahltasten.},
	qq{ʾлť},
	qq~ܻysC~,
	],
'maxlistentry' => [
	qq{Maximum number of items to be listed page:},
	qq{Nombre maximum d'items lister:},
	qq{H&ouml;chstzahl der Einzelteile zum Sein ausgedruckte Seite.},
	qq{Ŀ¼ÿҳʾĿ಻},
	qq{ؿCܪؼƳ̦hWLG},
	],
'skipcountsubs' => [
	qq{Do not include non top-level entries in counting this number.},
	qq{Ne pas inclure les entr&eacute;es secondaires en comptant ce nombre.},
	qq{Umfassen nicht erste Eintr&auml;ge nicht, wenn diese Zahl z&auml;hlen},
	qq{мʱǶĿ},
	qq{ipƮɤDŶءC},
	],
'insertimage' => [
	qq{Change URLs for images into embedded image.},
	qq{Changer les URL d'images en image int&eacute;gr&eacute;es.},
	qq{&Auml;ndern URLs f&uuml;r Bilder in Inline-Bild},
	qq{ͼƬӵַתͼƬ},
	qq{Ϥ챵a\}ƦuϤC},
	],
'findemoticons' => [
	qq{Convert common emoticons in message content to gifs.},
	qq{Convertion des ic&ocirc;nes d'&eacute;motion du contenu des messages en format GIF.},
	qq{Wandeln allgemeine Emoticons im Meldung Inhalt in Graphiken um.},
	qq{ıϢеıתΪͼΡ},
	qq~奻HŸഫuϧΡC~,
	],
'findhyperlinks' => [
	qq{Convert URLs in message content to hyperlinks.},
	qq{Convertion des URL dans les messages en hyperliens.},
	qq{Wandeln URLs im Meldung Inhalt in Hyperlinks um.},
	qq{ıϢеURLתΪӵַ},
	qq~奻HURLഫWsa}C~,
	],
'showfollowups' => [
	qq{Show all follow-ups when viewing a message.},
	qq{Afficher tous les suivis lors du visionnement des messages.},
	qq{Zeigen alle Antworten, wenn Sie eine Meldung ansehen.},
	qq{Ķʱͬʱʾи},
	qq~\\Ū峹ɦPܩҦKC~,
	],
'countsubhits' => [
	qq{Count the number of access for follow-ups.},
	qq{D&eacute;compte du nombre d'acc&egrave;s pour les suivis.},
	qq{Z&auml;hlen die Zahl des Zugriffs f&uuml;r Antworten.},
	qq{¼Ķ¼},
	qq~OK\\ŪOC~,
	],
'hideip' => [
	qq{Hide user's IP addresses in messages.},
	qq{Masquer l'adresse IP de Lusager dans les messages.},
	qq{Verstecken den IP Adresse des Benutzers in den Meldungen.},
	qq{ʾߵIP},
	qq~ܵo̪IPC~,
	],
'jumpform' => [
	qq{Show the quick jump form.},
	qq{Afficher la fen&ecirc;tre de saut rapide.},
	qq{Zeigen das schnelle Sprungformular.},
	qq{ʾתб},
	qq~ܦۥѸUԦCC~,
	],
'toc' => [
	qq{Table of contents},
	qq{Table des mati&egrave;res},
	qq{Inhaltsverzeichnis},
	qq{Ŀ¼б},
	qq{ؿC},
	],
'msg' => [
	qq{Message reading options},
	qq{Options de lecture des messages},
	qq{Meldung Leseoptionen},
	qq{Ķѡ},
	qq{\\Ūﶵ},
	],
'upperlinkstyle' => [
	qq{Listing style of upper-level item links:},
	qq{Modle de liste des liens de niveau suprieur d'lment:},
	qq{Listeart der Links fr hochgradige Einzelteile:},
	qq{ϼĿʾʽ},
	qq{Wűܤ覡G},
	],
'listline' => [
	qq{List in a line, separated by an arrow sign.},
	qq{numrez dans une ligne, spare par un signe de flche.},
	qq{Drucken Sie in einer Zeile aus, getrennt durch ein Pfeilzeichen.},
	qq{üͷָһС},
	qq{νbYj\@C},
	],
'liststack' => [
	qq{Stack in a tree form, showing levels.},
	qq{La pile sous une forme d'arbre, montrant nivelle.},
	qq{Stapel in einer Baumform, darstellend ebnet.},
	qq{ʾΪһּб},
	qq{ܬ\@ӤŦCC},
	],
'myerr' => [
	qq{The maximum number of listed items is too small.},
	qq{Le nombre maximum des lments numrs est trop petit.},
	qq{Die Hchstzahl der aufgefhrten Einzelteile ist zu klein.},
	qq{ʾĿ̫С},
	qq{̤jܱؼƤӤpC},
	],
);

@tbschecked = ( "", "", "" );
$tbschecked[$settings{'toolbarstyle'} + 0] = "Checked";

print qq{
	<b>$msgs{'toc'}[$langsub]</b><br>
	<img src="$baseurl/img/decdiamond.gif" width=11 height=11 border=0> $msgs{'toolbarstyle'}[$langsub]<br>
	<img src="$baseurl/img/clear.gif" width="20" heigth="10">
};

for( 0..2 ){
	print qq{<input type="Radio" name="toolbarstyle" value="$_" $tbschecked[$_]>}, $msgs{'tbstyle' . $_}[$langsub], "&nbsp;&nbsp;";
}

@uplchecked = ( "", "" );
$uplchecked[$settings{'upperlinkstyle'} + 0] = "Checked";

print qq{
	<br>
	<img src="$baseurl/img/decdiamond.gif" width=11 height=11 border=0>
	$msgs{'upperlinkstyle'}[$langsub]<br><img src="$baseurl/img/clear.gif" width="20" heigth="10">
	<input type="radio" name="upperlinkstyle" value="0" $uplchecked[0]> $msgs{'listline'}[$langsub]&nbsp;&nbsp;
	<input type="radio" name="upperlinkstyle" value="1" $uplchecked[1]> $msgs{'liststack'}[$langsub]<br>
};

foreach( (qw(expandall hidelangbuttons hideonline hidepoptopics jumpform markwebmaster markusergroups)) ){
	print qq{
	<input type="Checkbox" name="$_" value="1" $checked[$settings{$_}]> $msgs{$_}[$langsub]<br>
	};
}
print qq{
	<img src="$baseurl/img/decdiamond.gif" width=11 height=11 border=0>
	$msgs{'maxlistentry'}[$langsub]<input type="Text" name="maxlistentry" value="$settings{'maxlistentry'}" size="4" maxlength="3" size=3><br>
	<input type="Checkbox" name="skipcountsubs" value="1" $checked[$settings{'skipcountsubs'}]> $msgs{'skipcountsubs'}[$langsub]<br>
	<br><b>$msgs{'msg'}[$langsub]</b><br>
};

foreach( (qw(findemoticons findhyperlinks hideip insertimage showfollowups countsubhits)) ){
	print qq{
	<input type="Checkbox" name="$_" value="1" $checked[$settings{$_}]> $msgs{$_}[$langsub]<br>
	};
}

print qq{
	<script language="Javascript">
	function validate( frm ){
		if( parseInt( frm.maxlistentry.value ) < 2 ){
			alert( "$msgs{'myerr'}[$langsub]" );
			return false;
		}
		return true;
	}
	</script>
};

} elsif( $fields{'grp'} eq "admin" ) {

if( $fields{'update.x'} || $fields{'update.y'} ){
	tie( %frdb, $DB_Type, "dat/forum", &GDBM_WRCREAT, 0666 );
	for( qw(baseurl bbstitle siteroot webmaster mydomain validrefs expiretime checkupsess defaultlang timezone disabledeltree intellidestroy intellirestore emailmethod mailprog blatprog smtpserver timeeng timefr timegb timebig timede) ){
		$frdb{$_} = $settings{$_} = $fields{$_};
	}
	@provlangs = ( );
	for( @availlangs ){
		if( $fields{'use' . $_} ){ push( @provlangs, $_ ); }
	}
	$frdb{'provlangs'} = join( "\t", @provlangs );
	%definedlangs = map{ $_ => 1 } @provlangs;
	untie %frdb;
	&readtree( "dat/topics.dat" );
	@frdata = split( /\t/, $$root{'cap'} );
	$frdata[0] = $fields{'bbstitle'};
	$$root{'cap'} = join( "\t", @frdata );
	&writetree( "dat/topics.dat" );
}

print qq{<input type="Hidden" name="grp" value="admin">\n};
print qq{<input type="Hidden" name="defaultlang" value="$settings{'defaultlang'}">\n};

$expiretimeinput = qq{<input type="Text" name="expiretime" value="$settings{'expiretime'}" size="4" maxlength="4">};
$checkupsessinput = qq{<input type="Text" name="checkupsess" value="$settings{'checkupsess'}" size="4" maxlength="4">};

%msgs = (
'expiretime' => [
	qq{A session expires after remaining inactive in $expiretimeinput minutes.},
	qq{Une session expire lorsqu'inactive pour plus de $expiretimeinput minutes.},
	qq{Eine Sitzung l&auml;uft nach restlichem unaktiviertem in $expiretimeinput Minuten ab.},
	qq{¼Ľ̳ $expiretimeinput ûл϶Ϊڡ},
	qq~ni{WL $expiretimeinput SʱN{wLC~,
	],
'checkupsess' => [
	qq{Check and clean all inactive sessions every $checkupsessinput hours.},
	qq{Contr&ocirc;lez et nettoyez toutes les sessions inactives toutes les $checkupsessinput heures},
	qq{&Uuml;berpr&uuml;fen und s&auml;ubern alle unaktivierten Sitzungen alle $checkupsessinput Stunden},
	qq{ÿ $checkupsessinput Сʱһν̼¼ڼ¼},
	qq~Cj $checkupsessinput pˬd\@i{OAMLOC~,
	],
'disabledeltree' => [
	qq{Do not remove a forum with sub-level forums.},
	qq{N'enlevez pas un forum avec des forum de sous-niveau.},
	qq{L&auml;schen ein Forum nicht mit sub-level foren},
	qq{ɾ¼顣},
	qq~RaUŤժQײաC~,
	],
'intellirestore' => [
	qq{Enable IntelliRestore for the recycle bin.},
	qq{Permettez "IntelliRestore".},
	qq{Aktivieren IntelliRestore.},
	qq{ûվָܻܡ},
	qq~ҥΦ^`\\C~,
	],
'intellidestroy' => [
	qq{Enable IntelliDestroy for the recycle bin.},
	qq{Permettez "IntelliDestroy".},
	qq{Aktivieren IntelliDestroy.},
	qq{ûվܡ},
	qq~ҥΦ^M\\C~,
	],
'webmaster' => [
	qq{Webmaster's email address for out-going mails:},
	qq{Courriel du ma&icirc;tre du forum pour le courrier sortant:},
	qq{Email Adress des Verwalters f&uumml;r gehend Post.},
	qq{Ƶַ},
	qq{޹~ź٪lca\}G},
	],
'mydomain' => [
	qq{Your domain name used for manipulating cookies:},
	qq{Votre nom de domaine utilis?pour manipuler les &quot;cookies&quot;},
	qq{Ihr Domain Name, das f&uuml;r die Manipulierung der "cookies" verwendet wird},
	qq{Cookie},
	qq{zW]Ψӳ]mCookie^G},
	],
'validrefs' => [
	qq{Calls made to CGI scripts coming from these domains are valid:},
	qq{Les appels effectu&eacute;s aux script CGI partir de ces domaines sont valides:},
	qq{G&uuml;ltige HTTP-referer domains:},
	qq{ɽЩCGI},
	qq{iӦ۳oǰWCGIާ\@ШDG},
	],
'bbstitle' => [
	qq{Title of your message board:},
	qq{Titre de votre babillard},
	qq{Forumname},
	qq{̳ı⣺},
	qq{z׾ªDG},
	],
'baseurl' => [
	qq{The URL of the common files used by the forum (change only when really necessary and with caution):},
	qq{Le URL des fichiers communs utilis&eacute;s par ce forum (ne changer seulement lorsque vraiment n&eacute;cessaire et faire attention):},
	qq{Dieses ist das URL f&uuml;r der Standarddateien wie Bilder.},
	qq{̳ļڵĵַҪʱ޸ģע׼ȷԣ},
	qq{׾±`ΤҦba\}]uݭnɤ~קAЪ`N̩ʡ^G},
	],
'siteroot' => [
	qq{URL of your site:},
	qq{URL de votre site:},
	qq{Site Homepage:},
	qq{վҳ},
	qq{zDG},
	],
'provlangs' => [
	qq{Please chose the language packages you want to provide (use check boxes) and speficy the default language (click on the icons).},
	qq{Veuillez choisir les modules de langage que vous voulez fournir (contr&ocirc;lez les cadres) et speficy le langage de d&eacute;faut (cliquetez en fonction les graphismes).},
	qq{W&auml;hlte bitte die Sprachpakete, die Sie zur Verf&uuml;gung stellen m&ouml;chten (&uuml;berpr&uuml;fen Sie die K&auml;sten) und speficy die R&uuml;ckstellung Sprache (klicken Sie an die Ikonen).},
	qq{ѡûṩԣʹøѡ򣩲ָ̳ѡԣͼ꣩},
	qq~пܹΤᴣѪy]ϥ`ء^}w׾­y]IϼС^C~,
	],
'timezone' => [
	qq{Server's time zone},
	qq{Fuseau horaire du serveur},
	qq{Zeitzone des Servers},
	qq{ʱ},
	qq{AȾҦbɰ},
	],
'emailmethod' => [
	qq{How would you like to send outgoing emails?},
	qq{Comment vous aiment envoyer les email sortants?},
	qq{Wie wurde Sie m&ouml;gen gehend email senden?},
	qq{ַʽʼ},
	qq{έ覡oqllH},
	],
'forum' => [
	qq{Forum parameters},
	qq{Param&egrave;tres du forum},
	qq{Forumparameter},
	qq{̳},
	qq{׾°Ѽ},
	],
'misc' => [
	qq{Miscellaneous options},
	qq{Options diverses},
	qq{Verschiedene Optionen},
	qq{ѡ},
	qq{Lﶵ},
	],
'use' => [
	qq{Use},
	qq{Utilisez},
	qq{Benutzen},
	qq{ʹ},
	qq{ϥ},
	],
'timeformat' => [
	qq{Time format},
	qq{Format de temps},
	qq{Zeitformat},
	qq{ʱʽ},
	qq{ɶ榡},
	],
'myerr' => [
	qq{Either one or both of the time intervals are set too short.},
	qq{Un ou tous les deux intervalles de temps sont placs trop courts.},
	qq{Entweder einer oder beide der Zeitabstnde werden zu kurz eingestellt.},
	qq{ʱ̡̫},
	qq{ɶjӵuC},
	],
);
print qq{<b>$msgs{'forum'}[$langsub]</b><br>};
for( qw(baseurl bbstitle siteroot webmaster mydomain validrefs) ){
	print qq{
		<img src="$baseurl/img/decdiamond.gif" width=11 height=11 border=0>
	}, $msgs{$_}[$langsub], qq{<input type="Text" name="$_" value="$settings{$_}" size=30 maxlength=80><br>
	};
}
print join( qq{<br><img src="$baseurl/img/decdiamond.gif" width=11 height=11 border=0> }, "", $msgs{'expiretime'}[$langsub], $msgs{'checkupsess'}[$langsub] );

print qq{
	<br><br><b>$msgs{'misc'}[$langsub]</b><br>
	<img src="$baseurl/img/decdiamond.gif" width=11 height=11 border=0>
	}, $msgs{'provlangs'}[$langsub], "<br>";

foreach $language ( qw(eng fr de gb big5) ){
	print qq{<input type="Checkbox" name="use$language" value="1" },
		( $definedlangs{$language} ? "checked": "" ), qq{>
		<a href="javascript: setme( '$language' )"><img id="$language" src="$baseurl/img/lang$language}, ( $settings{'defaultlang'} eq $language ? "on": "" ), qq{.gif" border=0></a> &nbsp;&nbsp;
	};
}
print qq{
	<script language="JavaScript">
	function setme( name ){
		var old = document.forms[0].defaultlang.value;
		document.images[old].src = "$baseurl/img/lang" + old + ".gif";
		document.images[name].src = "$baseurl/img/lang" + name + "on.gif";
		document.forms[0].defaultlang.value = name;
	}
	function validate( frm ){
		if( parseInt( frm.expiretime.value ) < 3 || parseInt( frm.checkupsess.value ) < 1 ){
			alert( "$msgs{'myerr'}[$langsub]" );
			return false;
		}
		return true;
	}
	</script>
	<br>
	<img src="$baseurl/img/decdiamond.gif" width=11 height=11 border=0>
	$msgs{'timezone'}[$langsub]
	<select name="timezone">
};

use Time::Local;
my @tt = localtime( time );
splice( @tt, 6 );
$servtimezone = ( timegm( @tt ) - timelocal( @tt ) ) / 3600;

for( $tz = -12; $tz <=12 ; $tz++ ){
	my $isselected = ( $servtimezone == $tz )? "selected": "";
	print qq{
		<option value="$tz" $isselected>$tz</option>
	};
}

print qq{
	</select><br>
	<img src="$baseurl/img/decdiamond.gif" width=11 height=11 border=0>
	}, $msgs{'timeformat'}[$langsub], "<br>";

$currlang = $lang;
for( @availlangs ){
	my $t = "time" . $_;
	$lang = $_;
	&makedict;
	print qq{
		<img src="$baseurl/img/clear.gif" width="20" heigth="10">
		<img src="$baseurl/img/lang$lang.gif">
		<input type="Text" name="$t" value="$settings{$t}" size=40 maxlength=200>
	};
	print "(", &customtime( time ), ")<br>\n";
}
$lang = $currlang;
&makedict;

for( qw(disabledeltree intellidestroy intellirestore) ){
	$ischecked = ( $settings{$_}? "checked": "" );
	print qq{
		<input type="Checkbox" name="$_" value="$settings{$_}" $ischecked> $msgs{$_}[$langsub]<br>
	};
}

@isselected = ( "", "", "" );
@emailmethods = ( "sendmail", "blat", "smtp" );
for( 0..2 ){
	if( $settings{'emailmethod'} eq $emailmethods[$_] ){
		$isselected[$_] = "CHECKED";
	}
}
print qq{
	$msgs{'emailmethod'}[$langsub]<br>
	<input type="radio" name="emailmethod" value="sendmail" $isselected[0]> $msgs{'use'}[$langsub] sendmail (Unix)
	$msgs{'location'}[$langsub] <input type="Text" size="30" maxlenth="80" name="mailprog" value="$settings{'mailprog'}"><br>
	<input type="radio" name="emailmethod" value="blat" $isselected[1]> $msgs{'use'}[$langsub] blat.exe (Window NT)
	$msgs{'location'}[$langsub] <input type="Text" size="30" maxlenth="80" name="blatprog" value="$settings{'blatprog'}"><br>
	<input type="radio" name="emailmethod" value="smtp" $isselected[2]> $msgs{'use'}[$langsub] SMTP
	<input type="Text" size="30" maxlenth="80" name="smtpserver" value="$settings{'smtpserver'}"><br>
	<br>
};

} elsif( $fields{'grp'} eq "color" ){

if( $fields{'update.x'} || $fields{'update.y'} ){
	tie( %frdb, $DB_Type, "dat/forum", &GDBM_WRCREAT, 0666 );
	for( qw(tblbg defaultline col0 col1 col2 col3 col0fg col1fg col2fg col3fg theader theaderfg tr0 tr0fg tr0sub tr0subfg tr1 tr1fg tr1sub tr1subfg othbg othfg) ){
		$frdb{$_} = $settings{$_} = $fields{$_};
	}
	untie %frdb;
}

%msgs = (
'noline' => [
	qq{No line},
	qq{Pas de ligne},
	qq{Kein Rand},
	qq{ޱ߽},
	qq~Lɽu~,
	],
'dottedline' => [
	qq{Dotted line},
	qq{Ligne pointill&eacute;e},
	qq{Punktierte Zeile},
	qq{ϸ},
	qq~Iu~,
	],
'dashedline' => [
	qq{Dashed line},
	qq{Ligne de tirets},
	qq{Gestrichelte Zeile},
	qq{},
	qq~Eu~,
	],
'solidline'=> [
	qq{Solid line},
	qq{Ligne pleine},
	qq{Vollinien},
	qq{ϸʵ},
	qq{ӹu},
	],
'bdcolor' => [
	qq{Border color},
	qq{Couleur de la bordure},
	qq{Randfarbe},
	qq{߿ɫ},
	qq{C},
	],
'bdstyle'=> [
	qq{Border style},
	qq{Style de la bordure},
	qq{Randart},
	qq{߿ʽ},
	qq{ؼ˦},
	],
'column'=> [
	qq{Column},
	qq{Colonne},
	qq{Spalte},
	qq{},
	qq{},
	],
'header'=> [
	qq{Header row},
	qq{Rang&eacute;e sup&eacute;rieure},
	qq{Vorsatzreihe},
	qq{},
	qq{D},
	],
'even'=> [
	qq{Even rows},
	qq{Lignes paires},
	qq{Ungerade Reihen},
	qq{ż},
	qq{Ʀ},
	],
'odd'=> [
	qq{Odd rows},
	qq{Lignes impaires},
	qq{Geradzahlige Reihen},
	qq{},
	qq{_Ʀ},
	],
'sub'=> [
	qq{Sublevels},
	qq{Sous-niveaux},
	qq{Sub-levels},
	qq{¼},
	qq{U},
	],
'general'=> [
	qq{General},
	qq{G&eacute;n&eacute;ral},
	qq{Allgemeiner},
	qq{һ},
	qq{\@},
	],
'bgcolor'=> [
	qq{Background color},
	qq{Couleur de fond},
	qq{Hintergrundfarbe},
	qq{ɫ},
	qq{IC},
	],
'fgcolor'=> [
	qq{Text color},
	qq{Couleur de texte},
	qq{Textfarbe},
	qq{ɫ},
	qq{r^C},
	],
);
print qq{<input type="Hidden" name="grp" value="color">\n};

$settings{'theader'} ||= "DarkBlue";
$settings{'theaderfg'} ||= "White";
$settings{'theader'} ||= "DarkBlue";
$settings{'theaderfg'} ||= "White";
for( 0..3 ){
	$tcellbg[0][$_] = $settings{'tr0'} || 'white';
	$tcellbg[1][$_] = $settings{'tr0sub'} || 'white';
	$tcellbg[2][$_] = $settings{'tr1'} || 'white';
	$tcellbg[3][$_] = $settings{'tr1sub'} || 'white';
}

foreach $j ( 0..3 ){
	if( $settings{'col' . $j} ){
		foreach $i ( 0..3 ){
		$tcellbg[$i][$j] = $settings{'col' . $j};
		}
	}
}
for( 0..3 ){
	$tcellfg[0][$_] = $settings{'tr0fg'} || 'black';
	$tcellfg[1][$_] = $settings{'tr0subfg'} || 'black';
	$tcellfg[2][$_] = $settings{'tr1fg'} || 'black';
	$tcellfg[3][$_] = $settings{'tr1subfg'} || 'black';
}

foreach $j ( 0..3 ){
	if( $settings{'col' . $j} ){
		foreach $i ( 0..3 ){
		$tcellfg[$i][$j] = $settings{'col' . $j . 'fg'};
		}
	}
}
for( 0..3 ){
	$sampletimes[$_] = &customtime( time - rand(10000000) );
}
@lineselected = ( "" ) x 4;
$lineselected[$settings{'defaultline'}] = "SELECTED";
@tbllines = ( "tblwhitebg.gif", "tbldotted.gif", "tbldashed.gif");
$ietblline = ( ( $ENV{'HTTP_USER_AGENT'} =~ /MSIE/ && $settings{'defaultline'} < 3 )? qq{style="background-image:url('$baseurl/img/$tbllines[$settings{'defaultline'}]')"}: "" );

print <<EXAMPLE;
$msgs{'bdcolor'}[$langsub] <input type="Text" size="8" maxlength="30" name="tblbg" value="$settings{'tblbg'}">
$msgs{'bdstyle'}[$langsub] <select name="defaultline" size=1>
<option value="0" $lineselected[0]>$msgs{'noline'}[$langsub]</option>
<option value="1" $lineselected[1]>$msgs{'dottedline'}[$langsub]</option>
<option value="2" $lineselected[2]>$msgs{'dashedline'}[$langsub]</option>
<option value="3" $lineselected[3]>$msgs{'solidline'}[$langsub]</option>
</select>
<br clear="all">
<table width=100% border=0 cellspacing=0 cellpadding=0 cols=1 rows=1>
<tr><td bgcolor="$settings{'tblbg'}">

<table width=100% border=0 cellspacing=1 cellpadding=1 cols=5 rows=6 $ietblline>
<tr>
	<td bgcolor="white">$msgs{'general'}[$langsub]<br>
		<img src="$baseurl/img/iconbg.gif" width=12 height=12> <input type="Text" size="8" maxlength="30" name="othbg" value="$settings{'othbg'}"><br>
		<img src="$baseurl/img/iconfg.gif" width=12 height=12> <input type="Text" size="8" maxlength="30" name="othfg" value="$settings{'othfg'}"><br>
	</td>
	<td bgcolor="white">$msgs{'column'}[$langsub] 1<br>
		<img src="$baseurl/img/iconbg.gif" width=12 height=12> <input type="Text" size="8" maxlength="30" name="col0" value="$settings{'col0'}"><br>
		<img src="$baseurl/img/iconfg.gif" width=12 height=12> <input type="Text" size="8" maxlength="30" name="col0fg" value="$settings{'col0fg'}"><br>
	</td>
	<td bgcolor="white">$msgs{'column'}[$langsub] 2<br>
		<img src="$baseurl/img/iconbg.gif" width=12 height=12> <input type="Text" size="8" maxlength="30" name="col1" value="$settings{'col1'}"><br>
		<img src="$baseurl/img/iconfg.gif" width=12 height=12> <input type="Text" size="8" maxlength="30" name="col1fg" value="$settings{'col1fg'}"><br>
	</td>
	<td bgcolor="white">$msgs{'column'}[$langsub] 3<br>
		<img src="$baseurl/img/iconbg.gif" width=12 height=12> <input type="Text" size="8" maxlength="30" name="col2" value="$settings{'col2'}"><br>
		<img src="$baseurl/img/iconfg.gif" width=12 height=12> <input type="Text" size="8" maxlength="30" name="col2fg" value="$settings{'col2fg'}"><br>
	</td>
	<td bgcolor="white">$msgs{'column'}[$langsub] 4<br>
		<img src="$baseurl/img/iconbg.gif" width=12 height=12> <input type="Text" size="8" maxlength="30" name="col3" value="$settings{'col3'}"><br>
		<img src="$baseurl/img/iconfg.gif" width=12 height=12> <input type="Text" size="8" maxlength="30" name="col3fg" value="$settings{'col3fg'}"><br>
	</td>
</tr>
<tr>
	<td bgcolor="white">$msgs{'header'}[$langsub]<br>
		<img src="$baseurl/img/iconbg.gif" width=12 height=12> <input type="Text" size="8" maxlength="30" name="theader" value="$settings{'theader'}"><br>
		<img src="$baseurl/img/iconfg.gif" width=12 height=12> <input type="Text" size="8" maxlength="30" name="theaderfg" value="$settings{'theaderfg'}"><br>
	</td>
	<td bgcolor="$settings{'theader'}"><font color="$settings{'theaderfg'}">$dict{'title'}</font></td>
	<td bgcolor="$settings{'theader'}"><font color="$settings{'theaderfg'}">$dict{'author'}</font></td>
	<td bgcolor="$settings{'theader'}"><font color="$settings{'theaderfg'}">$dict{'time'}</font></td>
	<td bgcolor="$settings{'theader'}"><font color="$settings{'theaderfg'}">$dict{'reads'}</font></td>
</tr>
<tr>
	<td bgcolor="white">$msgs{'even'}[$langsub]<br>
		<img src="$baseurl/img/iconbg.gif" width=12 height=12> <input type="Text" size="8" maxlength="30" name="tr0" value="$settings{'tr0'}"><br>
		<img src="$baseurl/img/iconfg.gif" width=12 height=12> <input type="Text" size="8" maxlength="30" name="tr0fg" value="$settings{'tr0fg'}"><br>
	</td>
	<td bgcolor="$tcellbg[0][0]"><font color="$tcellfg[0][0]">
	<img src="$baseurl/img/msshsubop.gif" width=16 height=16 border=0> <b>FE 2000 Feastures list</b>
	</td>
	<td bgcolor="$tcellbg[0][1]"><font color="$tcellfg[0][1]">Admin</font></td>
	<td bgcolor="$tcellbg[0][2]"><font color="$tcellfg[0][2]">20</font></td>
	<td bgcolor="$tcellbg[0][3]"><font color="$tcellfg[0][3]">$sampletimes[0]</font></td>
</tr>
<tr>
	<td bgcolor="white">$msgs{'sub'}[$langsub]<br>
		<img src="$baseurl/img/iconbg.gif" width=12 height=12> <input type="Text" size="8" maxlength="30" name="tr0sub" value="$settings{'tr0sub'}"><br>
		<img src="$baseurl/img/iconfg.gif" width=12 height=12> <input type="Text" size="8" maxlength="30" name="tr0subfg" value="$settings{'tr0subfg'}"><br>
	</td>
	<td bgcolor="$tcellbg[1][0]"><font color="$tcellfg[1][0]">
	<img src="$baseurl/img/marktm.gif" width=16 height=16 border=0><img src="$baseurl/img/msgnosubop.gif" width=16 height=16 border=0> <b>Enhancements</b>
	</td>
	<td bgcolor="$tcellbg[1][1]"><font color="$tcellfg[1][1]">Admin</font></td>
	<td bgcolor="$tcellbg[1][2]"><font color="$tcellfg[1][2]">11</font></td>
	<td bgcolor="$tcellbg[1][3]"><font color="$tcellfg[1][3]">$sampletimes[1]</font></td>
</tr>
<tr>
	<td bgcolor="white">$msgs{'odd'}[$langsub]<br>
		<img src="$baseurl/img/iconbg.gif" width=12 height=12> <input type="Text" size="8" maxlength="30" name="tr1" value="$settings{'tr1'}"><br>
		<img src="$baseurl/img/iconfg.gif" width=12 height=12> <input type="Text" size="8" maxlength="30" name="tr1fg" value="$settings{'tr1fg'}"><br>
	</td>
	<td bgcolor="$tcellbg[2][0]"><font color="$tcellfg[2][0]">
	<img src="$baseurl/img/msshsubop.gif" width=16 height=16 border=0> <b>Upgrading</b>
	</td>
	<td bgcolor="$tcellbg[2][1]"><font color="$tcellfg[2][1]">Guest</font></td>
	<td bgcolor="$tcellbg[2][2]"><font color="$tcellfg[2][2]">17</font></td>
	<td bgcolor="$tcellbg[2][3]"><font color="$tcellfg[2][3]">$sampletimes[2]</font></td>
</tr>
<tr>
	<td bgcolor="white">$msgs{'sub'}[$langsub]<br>
		<img src="$baseurl/img/iconbg.gif" width=12 height=12> <input type="Text" size="8" maxlength="30" name="tr1sub" value="$settings{'tr1sub'}"><br>
		<img src="$baseurl/img/iconfg.gif" width=12 height=12> <input type="Text" size="8" maxlength="30" name="tr1subfg" value="$settings{'tr1subfg'}"><br>
	</td>
	<td bgcolor="$tcellbg[3][0]"><font color="$tcellfg[3][0]">
	<img src="$baseurl/img/marktm.gif" width=16 height=16 border=0><img src="$baseurl/img/msgnosubop.gif" width=16 height=16 border=0> <b>Forum feastures</b>
	</td>
	<td bgcolor="$tcellbg[3][1]"><font color="$tcellfg[3][1]">Mark</font></td>
	<td bgcolor="$tcellbg[3][2]"><font color="$tcellfg[3][2]">5</font></td>
	<td bgcolor="$tcellbg[3][3]"><font color="$tcellfg[3][3]">$sampletimes[3]</font></td>
</tr>
</table>

</td></tr>
</table>
<br>
<img src="$baseurl/img/iconbg.gif" width=12 height=12> $msgs{'bgcolor'}[$langsub]&nbsp;&nbsp;&nbsp;&nbsp;<img src="$baseurl/img/iconfg.gif" width=12 height=12> $msgs{'fgcolor'}[$langsub]<br>
<script language="Javascript">
function validate( frm ){
	return true;
}
</script>
EXAMPLE

} elsif( $fields{'grp'} eq "user" ){

if( $fields{'currfld'} >= 4 ){

if( $fields{'update.x'} || $fields{'update.y'} ){
	tie( %userdb, $DB_Type, "dat/users", &GDBM_WRCREAT, 0666 );
	my @flddata = split( /\t/, $userdb{ 'f' . $fields{'currfld'} } );
	@flddata[ 1..4 ] = @fields{ qw(vcard acckey reqflag fldclass) };
	$userdb{ 'f' . $fields{'currfld'} } = join( "\t", @flddata );
	untie %userdb;
}

if( ( $fields{'bubble.x'} || $fields{'bubble.y'} ) && $fields{'currfld'} > 4 ){
	tie( %userdb, $DB_Type, "dat/users", &GDBM_WRCREAT, 0666 );
	my( $a, $b, $c ) = ( $fields{'currfld'}-1, $fields{'currfld'}, $userdb{'fields'} );
	foreach $id ( keys %userdb ) {
		next unless( $id =~ /^\d+$/ );
		my @udata = split( /\t/, $userdb{$id}, $c );
		( $udata[$a], $udata[$b] ) = ( $udata[$b], $udata[$a] );	# Perl is cool :)
		$userdb{$id} = join( "\t", @udata );
	}
	( $userdb{ 'f' . $a }, $userdb{ 'f' . $b } ) = ( $userdb{ 'f' . $b }, $userdb{ 'f' . $a } );
	untie %userdb;
}

if( $fields{'sink.x'} || $fields{'sink.y'} ){
	tie( %userdb, $DB_Type, "dat/users", &GDBM_WRCREAT, 0666 );
	if( $fields{'currfld'} < $userdb{'fields'} - 1 ){
	my( $a, $b, $c ) = ( $fields{'currfld'}+1, $fields{'currfld'}, $userdb{'fields'} );
	foreach $id ( keys %userdb ) {
		next unless( $id =~ /^\d+$/ );
		my @udata = split( /\t/, $userdb{$id}, $c );
		( $udata[$a], $udata[$b] ) = ( $udata[$b], $udata[$a] );
		$userdb{$id} = join( "\t", @udata );
	}
	( $userdb{ 'f' . $a }, $userdb{ 'f' . $b } ) = ( $userdb{ 'f' . $b }, $userdb{ 'f' . $a } );
	}
	untie %userdb;
}

if( $fields{'delete.x'} || $fields{'delete.y'} ){
	tie( %userdb, $DB_Type, "dat/users", &GDBM_WRCREAT, 0666 );
	foreach $id ( keys %userdb ) {
		next unless( $id =~ /^\d+$/ );
		my @udata = split( /\t/, $userdb{$id}, $c );
		splice( @udata, $fields{'currfld'}, 1 );
		$userdb{$id} = join( "\t", @udata );
	}
	for( $a = $fields{'currfld'}; $a < $userdb{'fields'}-1; $a++ ){
		$b = $a + 1;
		$userdb{'f'.$a} = $userdb{'f'.$b};
	}
	delete $userdb{ 'f' . $a };
	$userdb{'fields'}--;
	untie %userdb;
}

if( $fields{'insert.x'} || $fields{'insert.y'} ){
	tie( %userdb, $DB_Type, "dat/users", &GDBM_WRCREAT, 0666 );
	foreach $id ( keys %userdb ) {
		next unless( $id =~ /^\d+$/ );
		my @udata = split( /\t/, $userdb{$id}, $c );
		splice( @udata, $fields{'currfld'}, 0, "" );
		$userdb{$id} = join( "\t", @udata );
	}
	for( $a = $userdb{'fields'}-1; $a > $fields{'currfld'}; $a-- ){
		$b = $a - 1;
		$userdb{'f'.$a} = $userdb{'f'.$b};
	}
	$userdb{'f'.$a} = join( "\t", @fields{ qw(newfldname vcard acckey reqflag fldclass) } );
	$userdb{'fields'}++;
	untie %userdb;
	tie( %terms, $DB_Type, "dat/$lang", &GDBM_WRCREAT, 0666 );
	$terms{ $fields{'newfldname'} } = $fields{'fldcap'};
	$dict{ $fields{'newfldname'} } = $fields{'fldcap'};
	untie %terms;
}

print qq{
	<script language="Javascript">
	function validate( frm ){
		return true;
	}
	</script>
};

}

%msgs = (
'prompt' => [
	qq{Please refer to the documentation "Administration Guide" for instructions.},
	qq{Veuillez se r&eacute;f&eacute;rer &agrave; la documentation "Guide de Gestion" pour des instructions.},
	qq{Sprechen Sie bitte die Unterlagen "Leitung Anleitung" f&uuml;r Anweisungen an},
	qq{ġָϡ},
	qq{ާ\@WhаѾ\\޲znC},
	],
'newfield' => [
	qq{Name for NEW field},
	qq{Nom de nouvelle zone},
	qq{Name des neuen Feldes},
	qq{},
	qq{suW},
	],
'caption' => [
	qq{Caption as appeared in profile},
	qq{L&eacute;gende comme apparue dans le profil},
	qq{Untertitel, wie im Profil geerschienen},
	qq{ǩ},
	qq{ñr},
	],
'vcard' => [
	qq{Microsoft vCard field},
	qq{Microsoft vCard zone},
	qq{Microsoft vCard Feld},
	qq{Microsoft vCard},
	qq{Microsoft vCardW},
	],
'acckey' => [
	qq{Access key},
	qq{Cl&eaute; d'acc&egrave;s},
	qq{Zugriffsschl&uuml;ssel},
	qq{ݼ},
	qq{²},
	],
'reqflag' => [
	qq{Check if required},
	qq{Contr&ocic;le s'il y a lieu},
	qq{Erforderlich?},
	qq{ָΪ},
	qq{w},
	],
'class' => [
	qq{Category},
	qq{Cat&eacute;gorie},
	qq{Kategorie},
	qq{},
	qq{},
	],
'loginfo' => [
	qq{Log-in info},
	qq{L'information de log-in},
	qq{Logon Informationen},
	qq{¼Ϣ},
	qq{nH},
	],
'contactinfo' => [
	qq{Contact info},
	qq{L'information de contact},
	qq{Kontaktinformationen},
	qq{ϵϢ},
	qq{ptH},
	],
'optinfo' => [
	qq{Optional info},
	qq{Infomation facultatif},
	qq{Wahlweise infomation.},
	qq{ѡϢ},
	qq{iH},
	],
);

print qq{
	<input type="Hidden" name="grp" value="user">
	$msgs{'prompt'}[$langsub]<br clear=all>
	<table width=100% border=0>
	<tr>
	<td valign="center" align="middle">
		<input type="Image" width=32 height=32 border=0 name="bubble" src="$baseurl/img/goup.gif" alt="$dict{'bubble'}">&nbsp;&nbsp;
		<input type="Image" width=32 height=32 border=0 name="sink" src="$baseurl/img/godown.gif" alt="$dict{'sink'}">
		<br>
		<input type="Image" width=32 height=32 border=0 name="insert" src="$baseurl/img/goinsert.gif" alt="$dict{'insert'}">&nbsp;&nbsp;
		<input type="Image" width=32 height=32 border=0 name="delete" src="$baseurl/img/goremove.gif" alt="$dict{'remove'}">
	</td>
	<td>
	<script Language="JavaScript">
};

@formdata = ( [], [], [], [], [] );

tie( %userdb, $DB_Type, "dat/users", &GDBM_WRCREAT, 0666 );
for( 0..$userdb{'fields'} ){
	my @flds = split( "\t", $userdb{ 'f' . $_ } );
	for( 0..4 ){ push( @{$formdata[$_]}, $flds[$_] ); }
}
untie %userdb;

@formvalues = ( "fldcaps", "vcards", "acckeys", "reqflags", "classes" );

print qq{
	var $formvalues[0] = new Array( "}, join( qq{", "}, @dict{ @{$formdata[0]} } ), qq{" );
};

for( 1..4 ){
	print qq{
	var $formvalues[$_] = new Array( "}, join( qq{", "}, @{$formdata[$_]} ), qq{" );
	};
}

print qq{
	function updateset( s ){
	document.forms[0].fldcap.value = fldcaps[ s ];
	document.forms[0].vcard.value = vcards[ s ];
	document.forms[0].acckey.value = acckeys[ s ];
	document.forms[0].reqflag.checked = ( reqflags[s] == 1 );
	document.forms[0].fldclass[0].checked = ( classes[s] == 1 );
	document.forms[0].fldclass[1].checked = ( classes[s] == 2 );
	document.forms[0].fldclass[2].checked = ( classes[s] == 3 );
	}
	</script>
	<Select name="currfld" size=10 onChange="updateset( this.selectedIndex )">
};

@classes = ( "", $msgs{'loginfo'}[$langsub], $msgs{'contactinfo'}[$langsub], $msgs{'optinfo'}[$langsub] );

$fldcnt = 0;
for( @{$formdata[0]} ){
	if( $_ ){
		print qq{<option value="$fldcnt">$_</option>};
	}
	$fldcnt++;
};

print qq{
	</Select>
	</td>
	<td>
	<img src="$baseurl/img/decdiamond.gif" width=11 height=11 border=0> $msgs{'newfield'}[$langsub] <input type="Text" name="newfldname" size=20 maxlength=40><br>
	<img src="$baseurl/img/decdiamond.gif" width=11 height=11 border=0> $msgs{'caption'}[$langsub] <input type="Text" name="fldcap" value="$dict{${$formdata[0]}[0]}" maxlength=40><br>
	<img src="$baseurl/img/decdiamond.gif" width=11 height=11 border=0> $msgs{'vcard'}[$langsub] <input type="Text" name="vcard" value="${$formdata[1]}[0]" size=20 maxlength=60><br>
	<img src="$baseurl/img/decdiamond.gif" width=11 height=11 border=0> $msgs{'acckey'}[$langsub] <input type="Text" name="acckey" value="${$formdata[2]}[0]" size=1 maxlength=1>&nbsp;&nbsp;&nbsp;&nbsp;
	<br><input type="Checkbox" name="reqflag" value=1
};

print "checked" if( ${$formdata[3]}[0] );

print qq{>
	$msgs{'reqflag'}[$langsub]<br>
	<img src="$baseurl/img/decdiamond.gif" width=11 height=11 border=0>
	}, $msgs{'class'}[$langsub];

for( 1..3 ){
	$ischecked = ( ${$formdata[4]}[0] == $_? "checked": "" );
	print qq{<input type="Radio" name="fldclass" value="$_" $ischecked> $classes[$_] &nbsp;&nbsp;};
}

print qq{
	<br></td></tr>
	</table>
};

}

print qq{
	</td></tr></table>
	</td></tr></table>
	$separator
	</center>
	</form>
	</body>
	</html>
};

exit;
}
