# Copyright 2000 Perl Script Studio and Zhigang Li #
# ------------------------------------------------ #

@availlangs = qw(eng fr de gb big5);

if( $#provlangs < 0 ){
	@provlangs = @availangs;
}

%definedlangs = map{ $_ => 1 } @provlangs;

%charsets = (
	'gb' => "gb-2312",
	'eng' => "iso-8859-1",
	'fr' => "iso-8859-1",
	'de' => "x-IA5-German",
	'big5' => "big5",
);

$fields{'charset'} = $charsets{$lang};

sub makedict {
	my $term, $value, %mydict, $ky;
	tie( %mydict, $DB_Type, "dat/$lang", &GDBM_WRCREAT, 0666 );
	foreach $ky ( keys %mydict ){
		$dict{$ky} = $mydict{$ky};
	}
	untie( %mydict );
}

sub customtime {
	my $tval = shift;
	my $tmstring = $settings{ 'time'.$lang };
	my $timediff = 0;
	my @ts = ( );
	if( $userinfo{'timezone'} ){
		$timediff = $settings{'timezone'} - $userinfo{'timezone'};
		@ts = localtime( $tval -  $timediff * 3600 );
	} else {
		@ts = gmtime( $tval );
	}
	my @mons = qw(jan feb mar apr may jun jul aug sep oct nov dec);
	my @wdays = qw(sun mon tue wed thu fri sat);
	# 0    1    2     3     4    5     6     7     8
	# sec, min, hour, mday, mon, year, wday, yday, isdst
	my %tdata = (
	'sec' => $ts[0],
	'0sec' => sprintf( "%02d", $ts[0] ),
	'min' => $ts[1],
	'0min' => sprintf( "%02d", $ts[1] ),
	'hour' => $ts[2],
	'0hour' => sprintf( "%02d", $ts[2] ),
	'day' => $ts[3],
	'0day' => sprintf( "%02d", $ts[3] ),
	'monval' => $ts[4] + 1,
	'0mon' => sprintf( "%02d", $ts[4]+1 ),
	'mon' => $dict{$mons[$ts[4]]},
	'year' => $ts[5] + 1900,
	'yr' => substr( $ts[5]+1900, 2 ),
	'wday' => $dict{$wdays[$ts[6]]},
	'yday' => $ts[7] + 1,
	);
	$tmstring =~ s/{(\w+)}/$tdata{$1}/g;
	return $tmstring;
}

1;
