# Copyright 2000 Perl Script Studio and Zhigang Li #
# ------------------------------------------------ #

$dep = 0;
$root = 0;

sub tnode {
	my $base = shift;
	if( !ref($base) ){
		$base =~ /^(\d+)\s(.+)$/;
		return {'cap' => $2, 'id' => $1 };
	}
	my $node = shift;
	while( $node ){
	if( !$$base{'son'} ){
		$$base{'son'} = $node;
		$$node{'par'} = $base;
		$$base{'last'} = $$base{'son'};
	} else {
		$$base{'last'}{'next'} = $node;
		$$node{'prev'} = $$base{'last'};
		$$base{'last'} = $node;
		$$node{'par'} = $base;
	}
	$node = shift;
	}
	return $base;
};

sub readtree {
	my $fname = shift;
	$root = 0;
	if( !open( DAT, "<$fname" ) ){
		return;
	}
	my @depths = ( );
	my @caps = ( );
	while( <DAT> ){
		chomp;
		if( m/^(\t*)(.+)$/ ){
		push( @depths, length($1) );
		push( @caps, $2 );
		}
	}
	close( DAT );
	my $expr = "";
	for( 0..$#depths-1 ){
		if( $depths[$_+1] > $depths[$_] ){
			$expr .= "\&tnode(" x ( $depths[$_+1] - $depths[$_] );
		}
		$expr .= ( "\&tnode(\"" . $caps[$_] ."\")," );
		if( $depths[$_+1] < $depths[$_] ){
			$expr .= ")," x ( $depths[$_] - $depths[$_+1] );
		}
	}
	$expr .= ( "\&tnode(\"" . $caps[-1] . "\"" );
	$expr .= ")," x ( $depths[-1] - 1 );
	$expr .= ")";
	eval( "\$root = $expr;" );
}

sub writetnode {
	my $np = shift;
	my $ptr = $$np{'son'};
	print DAT "\t" x ( $dep+1 ), "$$np{'id'}\t$$np{'cap'}\n";
	if( $ptr ){
	$dep++;
	while( $ptr ){
		&writetnode( $ptr );
		$ptr = $$ptr{'next'};
	}
	$dep--;
	}
}

sub writetree {
	my $fname = shift;
	if( !open( DAT, ">$fname" ) ){
		return 0;
	}
	&writetnode( $root );
	close( DAT );
	return 1;
}

sub searchtree {
	my ($np, $id) = @_;
	if( $$np{'id'} eq $id ){
		return $np;
	}
	my $ptr = $$np{'son'};
	if( $ptr ){
	while( $ptr ){
		my $tmp = &searchtree( $ptr, $id );
		if( $tmp ){
			return $tmp;
		} else {
			$ptr = $$ptr{'next'};
		}
	}
	}
	return "";
}

sub readfrm {
	my $fr = shift;
	my $origroot = $root;
	&readtree( "dat/topics.dat" );
	my $currfr = &searchtree( $root, $fr );
	my @fdata = split( /\t/, $$currfr{'cap'} );
	%thisfrm = (
		'mngrid' => $fdata[1],
		'modtime' => $fdata[2],
		'msgs' => $fdata[3],
		'open' => $fdata[4],
		'hassub' => ( $$currfr{'son'}? 1: 0 ),
	);
	$root = $origroot;
}

sub readmsg {
	my ( $fr, $msg ) = @_;
	my $origroot = $root;
	&readtree( "dat/fr$fr.dat" );
	my $currmsg = &searchtree( $root, $msg );
	my @ndata = split( /\t/, $$currmsg{'cap'} );
	%thismsg = (
		'authorid' => $ndata[1],
		'lastmod' => $ndata[2],
		'reads' => $ndata[3],
		'open' => $ndata[4],
		'autoinform' => ( $ndata[4] == 2 )? 1: 0,
		'hassub' => ( $$currmsg{'son'}? 1: 0 ),
	);
	$root = $origroot;
}

1;
