#!/usr/bin/perl

$skiprefcheck = 1;

require "inc/init.pl";
require "inc/localize.pl";
require "inc/treeop.pl";
require "inc/util.pl";

use constant MAXTITLECLIP => 30;
use constant MAXENTRYCLIP => 60;
use constant MAXTEXTCLIP => 300;

&readusers( );

# In whichever case, the forum tree must be read into memory.
# After this call, $root will point to the root node of the forum (subject category) tree.

&readtree( "dat/topics.dat" );

if( $settings{'mailinpost'} && time - $settings{'lastcheckpop3'} > $settings{'pop3interval'} * 60 ){
	my $np = &searchtree( $root, $settings{'mailinfrid'} );
	my @frdata = split( "\t", $$np{'cap'}, 5 );
	if( !$np || $np == $root || !$frdata[4] ){
		my %emailmsg = (
			'eng' => qq{The forum accepting email posts was either locked or removed, please take care of this problem.},
			'fr' => qq{Le forum recevant des poteaux d'email ou a t verrouill ou retir, prenez s'il vous plat soin de ce problme.},
			'de' => qq{Das Forum, das emailpfosten annimmt, wurde entweder gesperrt, oder gelscht, kmmern Sie bitte sich um diesem Problem.},
			'gb' => qq{ʼܹرջɾˣһ⡣},
			'big5' => qq{l[KQײեiΪ̧RFAӤ\@UoӰDC},
		);
		my $from = qq{$settings{'bbstitle'} <$settings{'webmaster'}>};
		&sendemail( $from, $from, "Mail-in forum locked or removed?", \($emailmsg{$lang}) );
	} else {
		socket( MAIL, &AF_INET, &SOCK_STREAM, ( getprotobyname('tcp') )[2] );
		bind( MAIL, pack( 'S n a4 x8', &AF_INET, 0, ( gethostbyname($hostname) )[4] ) );
		connect( MAIL, pack( 'S n a4 x8', &AF_INET, getservbyname($protocol, 'pop3') || 110, ( gethostbyname($settings{'pop3server'}) )[4] ) );
		my ( @femsgbody, @mlfrom, @mlsubject );
		my ($fh) = select(MAIL);
		$| = 1;
		select($fh);
		$_ = <MAIL>;
		print MAIL "USER $settings{'pop3user'}\r\n";
		$_ = <MAIL>;
		print MAIL "PASS $settings{'pop3pass'}\r\n";
		$_ = <MAIL>;
		print MAIL "STAT\r\n";
		$_ = <MAIL>;
		( $totalmsg ) = /^\+OK (\d+) \d+/;
		$i = 0;
		foreach $msgnum ( 1..$totalmsg ){
			$_ = "";
			@hdinfo = ( );
			print MAIL "TOP $msgnum 0\r\n";
			while( 1 ){
				$_ = <MAIL>;
				last if( /^\.\s+$/ );
				push ( @hdinfo, $_ );
			}
			# The following line puts the mail header into a hash.
			foreach( @hdinfo ){
				chomp;
				if( /:/ ){
					split( /:\s+/, $_, 2 );
					$header{ lc($_[0]) } = $_[1];
				}
			}
			# Treat messages whose subject begins with "FE:" (case insensitive) as to be delivered to board.
			next unless( $header{'subject'} =~ /^FE:\s*/i );
			push( @mlsubject, $' );
			$mlsubject[$i] =~ s/=([A-F0-9][A-F0-9])/pack("c", hex($1))/ge;
			$header{'from'} =~ /<\s*(\S+)\s*>/;
			push( @mlfrom, $1 );
			print MAIL "RETR $msgnum\r\n";
			$inbody = 0;
			while( 1 ){
				$_ = <MAIL>;
				last if( /^\.\s+$/ );
				# The following line filters out the mail header.
				next unless( $inbody || /^\s*$/ );
				push( @{$femsgbody[$i]}, $_ );
				$inbody = 1;
			}
			print MAIL "DELE $msgnum\r\n";
			$_ = <MAIL>;
			$i++;
		}
		print MAIL "QUIT\r\n";
		$_ = <MAIL>;
		close( MAIL );
		tie( %forumdb, $DB_Type, "dat/forum", &GDBM_WRCREAT, 0666 );
		$forumdb{'lastcheckpop3'} = time;
		if( $#mlsubject >= 0 ){
			tie( %userdb, $DB_Type, "dat/users", &GDBM_WRCREAT, 0666 );
			for( 0..$userdb{'fields'}-1 ){
				$userdb{ 'f' . $_ } =~ /^(\w+)\t/;
				$flds{$1} = $_;
			}
			foreach( grep{ $_ && /^\d+$/ } keys %userdb ){
				my @udata = split( /\t/, $userdb{$_} );
				$useremails{ lc( $udata[$flds{'email'}] ) } = $_;	# Special treatment
				$userdispnames{ $_ } = $udata[$flds{'displayname'}];	# Special treatment
			}
			untie( %userdb );
			$frdata[2] = time;
			$frdata[3] += ( $#mlsubject + 1 );
			my $msgid = $forumdb{'nextmsgid'};
			$forumdb{'nextmsgid'} += ( $#mlsubject + 1 );
			$forumdb{'nummsgs'} += ( $#mlsubject + 1 );
			$$np{'cap'} = join( "\t", @frdata );
			&writetree( "dat/topics.dat" );
			$root = 0; $np = 0;
			&readtree( "dat/fr$settings{'mailinfrid'}.dat" );
			my %frdb = ( );
			tie( %frdb, $DB_Type, "dat/fr$settings{'mailinfrid'}", &GDBM_WRCREAT, 0666 );
			$frdb{'nummsgs'} += ( $#mlsubject + 1 );
			foreach $msgnum ( 0..$#mlsubject ){
				my $message = join( "", @{$femsgbody[$msgnum]} );
				$mlsubject[$msgnum] =~ s/<[^<>	]*>//g;
				if( $mlsubject[$msgnum] =~ /^\s*$/ ){
					$mlsubject[$msgnum] = $dict{'notitle'};
				}
				if( $settings{'wordfilter'} ){
					@badwords = split( /[,|\.]?\s+/, $settings{ 'badwords' . $lang } );
					if( $#badwords >= 0 ){
						foreach( @badwords ){
							$message =~ s/$_/"*" x length($_)/ige;
						}
					}
				}
				$message =~ s/=([A-F0-9][A-F0-9])/pack("c", hex($1))/ge;	# For compatibility with Far East sets
				my $authorid = $useremails{ lc( $mlfrom[$msgnum] ) } || 0;
				$frdb{$msgid} = join( "\t", $authorid, "", time, $mlsubject[$msgnum], $message );
				$np = &tnode( join( "\t", $msgid, $mlsubject[$msgnum], $authorid, time, 0, 1 ) );
				# Append to the node $msg or the tree TOP. Note "son" and "last" are the first and last node of a bi-direction, non-circular linked list.
				my $pp = $root;
				if( !$$pp{'son'} ){
					$$pp{'son'} = $np;
					$$pp{'last'} = $np;
				} else {
					if( $settings{'appendlast'} && ( $pp != $root ) ){
						$$np{'prev'} = $$pp{'last'};
						$$pp{'last'}{'next'} = $np;
						$$pp{'last'} = $np;
					} else {
						$$np{'next'} = $$pp{'son'};
						$$pp{'son'}{'prev'} = $np;
						$$pp{'son'} = $np;
					}
				}
				$$np{'par'} = $pp;
				my %emailmsg = (
					'eng' => qq{The message "$mlsubject[$msgnum]" was just added to the forum "$frdata[0]" at },
					'fr' => qq{Le message "$mlsubject[$msgnum]" a &eacute;t&eacute; juste ajout&eacute; au forum "$frdata[0]" &agrave; },
					'de' => qq{Die Meldung "$mlsubject[$msgnum]" wurde gerade dem Forum "$frdata[0]" hinzugef&uuml;gt beim },
					'gb' => qq{ӡ$mlsubject[$msgnum]ӵ顰$frdata[0]},
					'big5' => qq{sl$mlsubject[$msgnum][FQײա$frdata[0]b},
				);
				$message = $emailmsg{$lang} . qq{ $settings{'bbstitle'} ($settings{'siteroot'})\n} . ( '-' x 32 ) . "\n\n". $message;
				my $from = $authorid?
					qq{$userdispnames{$authorid} <$mlform[$msgnum]>}:
					qq{$settings{'bbstitle'} <$settings{'webmaster'}>};
				tie( %maillist, $DB_Type, "dat/ml$fr", &GDBM_WRCREAT, 0666 );
				foreach $subscriber ( keys %maillist ){
					next if( lc($mlfrom[$msgnum]) eq lc($subscriber) );
					&sendemail( $from, "Subscriber <$subscriber>", $mlsubject[$msgnum], \$message );
				}
				untie( %maillist );
				if( $settings{'sendmeall'} ){
					&sendemail( $from, "Webmaster <$settings{'webmaster'}>", $mlsubject[$msgnum], \$message );
				}
				$msgid++;
			}
			untie( %frdb );
			&writetree( "dat/fr$settings{'mailinfrid'}.dat" );
			$root = 0;
			&readtree( "dat/topics.dat" );	# Restore the forum tree for subsequent operations.
		}
		untie( %forumdb );
	}
}

@tbllines = ( "tblwhitebg.gif", "tbldotted.gif", "tbldashed.gif");
$ietblline = ( ( $ENV{'HTTP_USER_AGENT'} =~ /MSIE/ && $settings{'defaultline'} < 3 )? qq{style="background-image:url('$baseurl/img/$tbllines[$settings{'defaultline'}]')"}: "" );

$troe = 1;	# Table row is odd or even. Odd = 1, Even = 0.

for( 0..3 ){
	$tcellbg[0][$_] = $settings{'tr0'} || "white";
	$tcellbg[1][$_] = $settings{'tr1'} || "white";
	$tcellbg[2][$_] = $settings{'tr0sub'} || "white";
	$tcellbg[3][$_] = $settings{'tr1sub'} || "white";
	$tcellfg[0][$_] = $settings{'tr0fg'} || "black";
	$tcellfg[1][$_] = $settings{'tr1fg'} || "black";
	$tcellfg[2][$_] = $settings{'tr0subfg'} || "black";
	$tcellfg[3][$_] = $settings{'tr1subfg'} || "black";
}

foreach $j ( 0..3 ){
	if( $settings{'col' . $j} ){
		foreach $i ( 0..3 ){
		$tcellbg[$i][$j] = $settings{'col' . $j};
		}
	}
	if( $settings{'col' . $j} ){
		foreach $i ( 0..3 ){
		$tcellfg[$i][$j] = $settings{'col' . $j . 'fg'};
		}
	}
}

$settings{'othbg'} ||= "white";
$settings{'othfg'} ||= "black";
$settings{'theader'} ||= "darkblue";
$settings{'theaderfg'} ||= "white";

# A parameter string is expected to extract current browsing info.
( $frlang, $thisuser, $fr, $pg, $md, $msg ) = unpack( "uS*", pack( "h*", $fields{'param'} ) );
$fr ||= 0;
$pg ||= 1;
$msg ||= 0;
if( $md eq "" ){ $md = $settings{'expandall'}? 0: 2; }
# $frlang	Currently used language
# $thisuser	User id, must match that recorded for this 
# $fr		Currently accessed forum id
# $pg		Currently accessed page of forum list OR message list, depending on viewing mode
# $md		Maximal listing depth of tree of forums OR messages
# $msg		Currently accessed message id

if( $frlang && $definedlangs{$frlang} ){
	$lang = $frlang;
}

&makedict;

print "Content-type:text/html; charset=$charsets{$lang}\n";

if( !$cookies{'hitrecorded'} ){
	&setcookie( "hitrecorded", 1 );
	my %forumdb;
	tie( %forumdb, $DB_Type, "dat/forum", &GDBM_WRCREAT, 0666 );
	$forumdb{'totalhits'}++;
	$settings{'totalhits'}++;
	untie %forumdb;
}

print "\n";

( $taskname, $thisuser, @taskparams ) = unpack( "uS*", pack( "H*", $fields{'task'} ) );
if( $taskname eq "sort" ){
	$sortby = $taskparams[0];
	$sortdir = $taskparams[1];
}

$perm = &authenticate( );
@permdesc = qw(expired guest banned member senior manager webmaster);
%mystatus = map { $permdesc[$_] => ($_<$sMember)? ($_==$perm): ($_<=$perm) } 0..6;
# Comments about the line above:
# The keys of %mystatus are defined in @permdesc. If permission is 0 ~ 2, then set the
# appropriate key to 1; if 3 ~ 6, then set all lower-priority keys to 1.

$mystatus{'desc'} = $dict{ $permdesc[$perm] };

# If a user id is provided, check it; or otherwise skip and set it to that recorded for this
# session. If a user leaves without logging-out, and back within expiration time, then treat
# it as valid.

if( $thisuser && $thisuser != $userid ){
	$mystatus{'expired'} = 1;
} else {
	$thisuser = $userid;
}

&getuserinfo( $thisuser );
$currtime = &customtime( time );

if( !$userinfo{'timezone'} ){
	$currtime .= " (GMT)";
}

# This is a bar to separate different portions of the layout screen.
$separator = qq{
	<table border=0 cellspacing=0 cellpadding=0 width="100%">
	<tr height="8">
		<td background="$baseurl/img/barbg.gif"><img src="$baseurl/img/clear.gif" border=0 height=8 width=12></td>
	</tr>
	</table>
};

if( $mystatus{'member'} || $mystatus{'banned'} ){
	$fields{'welcomemsg'} = qq{ $dict{'welcome'}, $users{$thisuser}! $dict{'status'}: $mystatus{'desc'} | $dict{'id'}: $userid };
} else {
	$fields{'welcomemsg'} = qq{ $dict{'welcome'}! };
}

$fields{'welcomemsg'} .= qq{ | $dict{'time'}: $currtime | $dict{'topics'}: $settings{'numtopics'} | $dict{'messages'}: $settings{'nummsgs'} | $dict{'hits'}: $settings{'totalhits'} };

# Now read in the template file

$fields{'bbstitle'} = $settings{'bbstitle'};
$fields{'charset'} = $charsets{$lang};

open( TPL, "<tmp/index.htt" );
while( <TPL> ){
	last if( /^<!-- INSERT -->/ );
	s/{%(\w+)%}/$fields{$1}/g;
	print;
}

if( $mystatus{'expired'} || $mystatus{'guest'} ){
	&builderrmsg;
	&buildlogonform;
}

@allfr = ( );
@frmsg = ( );
%thisfrm = ( );
%thismsg = ( );

# These two variables will be used in paginating the forum OR message list. Do not access directly.

$currcnt = 0;
$currpg = 1;

# THE VALUES FOR HYPERLINKS OF THESE TOOLBAR BUTTONS HAVE TO BE DETERMINED CAREFULLY!

@tools_bbs = qw(bbstag new post reply edit);
@tools_nav = qw(navtag refresh previous upper next tpindex index home recbin);
@tools_set = qw(settag settings setup subunsub lockunlock autoinform);
@tools_adm = qw(admtag newforum dictionary movenode users remove);
@tools_oth = qw(othtag print search help exit);
@tools_ins = qw(reply email lockunlock autoinform edit remove);

# Toolbar style: 0 - show icon; 1 - show icon and text; 2 -- show text only.

$showtbicon = ( $settings{'toolbarstyle'} <= 1 );
$showtbtext = ( $settings{'toolbarstyle'} >= 1 );

$toolbars{'bbstag'} = qq{ <img src="$baseurl/img/tbbbstag.gif" width=5 height=17 border=0> } x $showtbicon;
$toolbars{'navtag'} = qq{ <img src="$baseurl/img/tbnavtag.gif" width=5 height=17 border=0> } x $showtbicon;
$toolbars{'settag'} = qq{ <img src="$baseurl/img/tbsettag.gif" width=5 height=17 border=0> } x $showtbicon;
$toolbars{'admtag'} = qq{ <img src="$baseurl/img/tbadmtag.gif" width=5 height=17 border=0> } x $showtbicon;
$toolbars{'othtag'} = qq{ <img src="$baseurl/img/tbothtag.gif" width=5 height=17 border=0> } x $showtbicon;

$toolbars{'refresh'} = join( " ", 
	qq{<a href="javascript:location.reload( );">},
	qq{<img src="$baseurl/img/navrefresh.gif" width=16 height=16 border=0 alt="$dict{'refresh'}">} x $showtbicon,
	( '[' . $dict{'refresh'} . ']' ) x $showtbtext,
	qq{</a>\n} );
$toolbars{'home'} = join( " ",
	qq{<a href="$settings{'siteroot'}">},
	qq{<img src="$baseurl/img/navhome.gif" width=16 height=16 border=0 alt="$dict{'home'}">} x $showtbicon,
	( '[' . $dict{'home'} . ']' ) x $showtbtext,
	qq{</a>\n} );
$toolbars{'search'} = join( " ",
	qq{<a href="utils.cgi?param=} . unpack( "h*", pack( "uS*", $lang, $thisuser, $fr, 0, $md, 0 ) ) . qq{&amp;task=} . unpack( "H*", pack( "uS", "search", $thisuser ) ) . qq{">},
	qq{<img src="$baseurl/img/navfind.gif" width=16 height=16 border=0 alt="$dict{'search'}">} x $showtbicon,
	( '[' . $dict{'search'} . ']' ) x $showtbtext,
	qq{</a>\n} );
$toolbars{'help'} = join( " ",
	qq{<a href="$baseurl/fehelp.html">},
	qq{<img src="$baseurl/img/navhelp.gif" width=16 height=16 border=0 alt="$dict{'help'}">} x $showtbicon,
	( '[' . $dict{'help'} . ']' ) x $showtbtext,
	qq{</a>\n} );
$toolbars{'index'} = ( $fr || $taskname eq "search" )? join( " ",
	qq{<a href="index.cgi?param=} . unpack( "h*", pack( "uS*", $lang, $userid, 0, 1, $md, 0 ) ) . qq{">},
	qq{<img src="$baseurl/img/navindex.gif" width=16 height=16 border=0 alt="$dict{'index'}">} x $showtbicon,
	( '[' . $dict{'index'} . ']' ) x $showtbtext,
	qq{</a>\n} ): "";
$toolbars{'settings'} = $mystatus{'member'}? join( " ",
	qq{<a href="admin.cgi?task=} . unpack( "H*", pack( "uS", "settings", $thisuser ) ) . qq{&amp;param=$fields{'param'}">},
	qq{<img src="$baseurl/img/navsettings.gif" width=16 height=16 border=0 alt="$dict{'settings'}">} x $showtbicon,
	( '[' . $dict{'settings'} . ']' ) x $showtbtext,
	qq{</a>\n} ): "";
$toolbars{'newforum'} = ( $mystatus{'manager'} && !$msg )? join( " ",
	qq{<a href="admin.cgi?param=$fields{'param'}&amp;task=} . unpack( "H*", pack( "uS", "newfr", $thisuser ) ) . qq{&amp;param=$fields{'param'}">},
	qq{<img src="$baseurl/img/navnewfr.gif" width=16 height=16 border=0 alt="$dict{'newforum'}">} x $showtbicon,
	( '[' . $dict{'newforum'} . ']' ) x $showtbtext,
	qq{</a>\n} ): "";
$toolbars{'users'} = $mystatus{'webmaster'}? join( " ",
	qq{<a href="admin.cgi?task=} . unpack( "H*", pack( "uS", "users", $thisuser ) ) . qq{&amp;param=$fields{'param'}">},
	qq{<img src="$baseurl/img/navcrowd.gif" width=16 height=16 border=0 alt="$dict{'users'}">} x $showtbicon,
	( '[' . $dict{'users'} . ']' ) x $showtbtext,
	qq{</a>\n} ): "";
$toolbars{'setup'} = $mystatus{'webmaster'}? join( " ",
	qq{<a href="admin.cgi?task=} . unpack( "H*", pack( "uS", "setup", $thisuser ) ) . qq{&amp;param=$fields{'param'}">},
	qq{<img src="$baseurl/img/navtools.gif" width=16 height=16 border=0 alt="$dict{'setup'}">} x $showtbicon,
	( '[' . $dict{'setup'} . ']' ) x $showtbtext,
	qq{</a>\n} ): "";
$toolbars{'dictionary'} = $mystatus{'webmaster'}? join( " ",
	qq{<a href="admin.cgi?task=} . unpack( "H*", pack( "uS", "dict", $thisuser ) ) . qq{&amp;param=$fields{'param'}">},
	qq{<img src="$baseurl/img/navdict.gif" width=16 height=16 border=0 alt="$dict{'dictionary'}">} x $showtbicon,
	( '[' . $dict{'dictionary'} . ']' ) x $showtbtext,
	qq{</a>\n} ): "";
$toolbars{'movenode'} = $mystatus{'webmaster'}? join( " ",
	qq{<a href="admin.cgi?task=} . unpack( "H*", pack( "uS", "movenode", $thisuser ) ) . qq{&amp;param=$fields{'param'}">},
	qq{<img src="$baseurl/img/navmovenode.gif" width=16 height=16 border=0 alt="$dict{'movenode'}">} x $showtbicon,
	( '[' . $dict{'movenode'} . ']' ) x $showtbtext,
	qq{</a>\n} ): "";
$toolbars{'recbin'} = $mystatus{'member'}? join( " ",
	qq{<a href="recbin.cgi?param=} . unpack( "h*", pack( "uS*", $lang, $userid, $fr, 1, $md, 0 ) ) . qq{">},
	qq{<img src="$baseurl/img/navrecbin.gif" width=16 height=16 border=0 alt="$dict{'recbin'}">} x $showtbicon,
	( '[' . $dict{'recbin'} . ']' ) x $showtbtext,
	qq{</a>\n} ): "";
$toolbars{'exit'} = $mystatus{'guest'}? "": join( " ",
	qq{<a href="admin.cgi?task=} . unpack( "H*", pack( "uS", "logout", $thisuser ) ) . qq{&param=} . unpack( "h*", pack( "uS*", $lang, $userid, $fr, $pg, $md, $msg ) ) . qq{">},
	qq{<img src="$baseurl/img/navexit.gif" width=16 height=16 border=0 alt="$dict{'logout'}">} x $showtbicon,
	( '[' . $dict{'logout'} . ']' ) x $showtbtext,
	qq{</a>\n} );
$toolbars{'new'} = join( " ",
	qq{<a href="index.cgi?param=$fields{'param'}&amp;task=} . unpack( "H*", pack( "uS", "search", $thisuser ) ) . qq{&amp;list=new">},
	qq{<img src="$baseurl/img/marknew$lang.gif" border=0>},
	qq{</a>\n} );

# Read news. A database "news" contains all news. The entry is the userid, the value is news in format of "[sender id]:[time]:[news text]" separated by tabs. Return value is in the form of a table.

sub getinstantnews {
	my %news;
	tie( %news, $DB_Type, "dat/news", &GDBM_WRCREAT, 0666 );
	my @mynews = split( /\t/, $news{$thisuser} );
	delete $news{$thisuser};
	untie %news;
	my $returnvalue = "";
	if( $#mynews >= 0 ){
		$returnvalue = qq{<table width=100% border=0 cellspacing=0 cellpadding=2 cols=3 bgcolor="Yellow">};
		foreach ( @mynews ){
			my @newsdata = split( /:/, $_, 3 );
			$returnvalue .= qq{<tr><td><img src="$baseurl/img/iconnews.gif" width=16 height=16 border=0>
			} . ( $users{$newsdata[0]} || "Forum Engine 2000" ) . qq{
			</td><td>} . &customtime( $newsdata[1] ) . qq{</td><td>$newsdata[2]</td></tr>
			};
		}
		$returnvalue .= "</table><br>";
	}
	return $returnvalue;
}

# Get a list of currently on-line users. Return value is in form of HTML drop-down list.

sub whosonline {
	my ( %sess, $sid, @onliners );
	tie( %sess, $DB_Type, "dat/sess", &GDBM_WRCREAT, 0666 );
	foreach $sid ( keys %sess ){
		next if( $sid !~ /^\d+\./ );
		my @sessdata = split( /\t/, $sess{$sid} );
		push( @onliners, $sessdata[0] );
		push( @logtimes, $sessdata[1] );
	}
	@onliners = @onliners[ sort { $logtime[$b] <=> $logtime[$a] } 0..$#onliners ];
	splice( @onliners, 30 ) if( $#onliners >= 30 );
	my $returnvalue = "";
	if( $#onliners >= 0 ){
		$returnvalue .= qq{<select name="recipient">};
		for( @onliners ){
			$returnvalue .= qq{<option value="$_">$users{$_}</option>\n};
		}
		$returnvalue .= qq{</select>};		
	}
	return $returnvalue;
}

if( $mystatus{'member'} ){
	$instantnews = &getinstantnews;
}

# The &searchkeyword will traverse the forum tree only.
# To find pattern in messages, no tree data file is read. Only directly check the forum databases.
# Use the array @mxxx to store information. Then sort by relevance or time.

@pats = ( );
@mfr = ( );
@mfrcnt = ( );
@mfrtm = ( );
@mmsg = ( );
@mmsgcnt = ( );
@mmsgtm = ( );
$mmaxfr = 0;
$mmaxmsg = 0;

@matchfuncs = (
	sub {
		my ( $target, $pat ) = @_;
		return ( $$target =~ s|$pat|\a$&\b|gi ) || 0;
	},	# Match anywhere and case insensitive
	sub {
		my ( $target, $pat ) = @_;
		return ( $$target =~ s|\b$pat\b|\a$&\b|gi ) || 0;
	},	# Match whole words only
	sub {
		my ( $target, $pat ) = @_;
		return ( $$target =~ s|$pat|\a$&\b|g ) || 0;
	},	# Case sensitive
	sub {
		my ( $target, $pat ) = @_;
		return ( $$target =~ s|\b$pat\b|\a$&\b|g ) || 0;
	},	# Whole word only and case sensitive
);

$newmsgtime = time - $cookies{'lastlogin'};
if( $newmsgtime > $settings{'newmsgtime'} * 3600 ){
	$newmsgtime = $settings{'newmsgtime'} * 3600;
}

sub listnewmsg {
	my $node = shift;
	return if( !$node );
	my $currfrid = $$node{'id'};
	my $msgid = 0;
	tie( %currmatfr, $DB_Type, "dat/fr$currfrid", &GDBM_WRCREAT, 0666 );
	my @frmsgs = sort { $b <=> $a } ( grep { /^\d+$/ } keys %currmatfr );
	foreach $msgid ( @frmsgs ) {
		my @msgdata = split( /\t/, $currmatfr{$msgid}, 5 );
		last if( time - $msgdata[2] > $newmsgtime );
		$totalcnt++;
		if( length( $msgdata[4] ) > MAXTEXTCLIP ){
			substr( $msgdata[4], MAXTEXTCLIP ) = "...";
		}
		my $mparam = unpack( "h*", pack( "uS*", $lang, $thisuser, $currfrid, 1, 0, $msgid ) );
		push( @mmsg, join( "\t", $msgdata[3], $mparam, $msgdata[0], $msgdata[4] ) );	# Message title, Parameter, Author id, Message content
		push( @mmsgcnt, $newmsgtime - ( time - $msgdata[2] ) );
		push( @mmsgtm, $msgdata[2] );
	}
	untie( %currmatfr );
	my $ptr = $$node{'son'};
	if( $ptr ){
		while( $ptr ){
			&listnewmsg( $ptr );
			$ptr = $$ptr{'next'};
		}
	}
}

$fields{'matchcase'} ||= 0;
$fields{'wholeword'} ||= 0;
$matchfuncsub = $fields{'matchcase'} * 2 + $fields{'wholeword'};

sub searchkeyword {
	my $node = shift;
	return if( !$node );
	my %currmatfr = ( );
	my @ndata = split( /\t/, $$node{'cap'} );
	if( $node != $root ){
		$matchcnt = 0;
		$thismatch = 0;
		foreach $pat ( @pats ){
			$thismatch = &{$matchfuncs[$matchfuncsub]}( \($ndata[0]), $pat );
			# If uses "AND" (1), then only record the smallest number of matches in each run.
			# If uses "OR" (0), then sum up the matches of each run.
			if( $fields{'combo'} && defined $thisisatag ){
				$matchcnt = $matchcnt > $thismatch? $thismatch: $matchcnt;
			} else {
				$matchcnt += $thismatch;
			}
			$thisisatag = 1;
			last if( !$matchcnt && $fields{'combo'} );	# If no match, no need to continue "AND" operation again
		};
		undef $thisisatag;
		if( $matchcnt ){
			if( $matchcnt > $mmaxfr ){
				$mmaxfr = $matchcnt;
			}
			my $fparam = unpack( "h*", pack( "uS*", $lang, $thisuser, $$node{'id'}, 1, 0, 0 ) );
			push( @mfr, join( "\t", $ndata[0], $fparam, $ndata[1] ) );	# Forum title, Parameter, Moderator id
			push( @mfrcnt, $matchcnt );
			push( @mfrtm, $ndata[2] );
		}
		my $currfrid = $$node{'id'};
		my $msgid = 0;
		tie( %currmatfr, $DB_Type, "dat/fr$currfrid", &GDBM_WRCREAT, 0666 );
		foreach $msgid ( keys %currmatfr ) {
			next unless( $msgid =~ /^\d+$/ );
			my @msgdata = split( /\t/, $currmatfr{$msgid}, 5 );
			$matchcnt = 0;
			foreach $pat ( @pats ){
				$thismatch = &{$matchfuncs[$matchfuncsub]}( \($msgdata[3]), $pat );
				if( $fields{'combo'} && defined $thisisatag ){
					$matchcnt = $matchcnt > $thismatch? $thismatch: $matchcnt;
				} else {
					$matchcnt += $thismatch;
				}
				$thisisatag = 1;
				last if( !$matchcnt && $fields{'combo'} );
			};
			undef $thisisatag;
			unless( $fields{'titleonly'} ){
				foreach $pat ( @pats ){
					$thismatch = &{$matchfuncs[$matchfuncsub]}( \($msgdata[4]), $pat );
					if( $fields{'combo'} && defined $thisisatag ){
						$matchcnt = $matchcnt > $thismatch? $thismatch: $matchcnt;
					} else {
						$matchcnt += $thismatch;
					}
					$thisisatag = 1;
					last if( !$matchcnt && $fields{'combo'} );
				};
			}
			if( $matchcnt ){
				if( length( $msgdata[4] ) > MAXTEXTCLIP ){
					substr( $msgdata[4], MAXTEXTCLIP ) = "...";
					if( ( $msgdata[4] =~ m/\010/g ) % 2 == 1 ){
						$msgdata[4] .= "\b";
					}
				}
				if( $matchcnt > $mmaxmsg ){
					$mmaxmsg = $matchcnt;
				}
				my $mparam = unpack( "h*", pack( "uS*", $lang, $thisuser, $$node{'id'}, 1, 0, $msgid ) );
				push( @mmsg, join( "\t", $msgdata[3], $mparam, $msgdata[0], $msgdata[4] ) );	# Message title, Parameter, Author id, Message content
				push( @mmsgcnt, $matchcnt );
				push( @mmsgtm, $msgdata[2] );
			}
		}
		untie %currmatfr;
	}
	my $ptr = $$node{'son'};
	if( $ptr ){
		while( $ptr ){
			&searchkeyword( $ptr );
			$ptr = $$ptr{'next'};
		}
	}
}

# In this version, the index.cgi takes over the job of searching.
# Parameters will be passed by a POST form. However, a GET method is also acceptable for now.

if( $taskname eq "search" ){
	print qq{<table width=100% border=0><tr><td>};
	foreach $tb ( @tools_bbs, @tools_nav, @tools_adm, @tools_set, @tools_oth ){
		print $toolbars{$tb};
	}
	if( $fields{'list'} eq "new" ){
		&listnewmsg( $root );
	} else {
		if( $fields{'combo'} != 2 ){
			@pats = split( /\s+/, $fields{'pattern'} );
		} else {
			@pats = ( $fields{'pattern'} );
			$fields{'combo'} = 0;
		}
		for( 0..$#pats ){
			if( $pats[$_] =~ /^\s*$/ ){
				splice( @pats, $_, 1 );
			}
		}
		&searchkeyword( $root );
	}
	$totalcnt = $#mfr + $#mmsg + 2;
	print qq{</td></tr><tr><td align="right"><b>$dict{'searchres'}</b> <small>($dict{'total'}: $totalcnt)</small></td></tr></table>
	}, $instantnews;
	my @idxfr, @idxmsg;
	if( $fields{'sortby'} == 1 && !$fields{'list'} ){
		@idxfr = sort {
			$mfrcnt[$b] <=> $mfrcnt[$a];
		} 0..$#mfr;
		@idxmsg = sort {
			$mmsgcnt[$b] <=> $mmsgcnt[$a];
		} 0..$#mmsg;
	} else {
		if( $fields{'list'} eq "new" ){
			$mmaxmsg = $newmsgtime;
		}
		@idxfr = sort {
			$mfrtm[$b] <=> $mfrtm[$a];
		} 0..$#mfr;
		@idxmsg = sort {
			$mmsgtm[$b] <=> $mmsgtm[$a];
		} 0..$#mmsg;
	}
	$totalcnt = 0;
	if( $#mfr >= 0 ){
		for $i ( 0..$#mfr ){
			$totalcnt++;
			$currcnt++;
			if( $currcnt > $settings{'maxlistentry'} ){
				$currpg++;
				$currcnt = 0;
			}
			next if( $pg != $currpg );
			my @cfrdata = split( /\t/, $mfr[$i], 3 );
			$cfrdata[0] =~ s|\a|<span class="match">|g;
			$cfrdata[0] =~ s|\010|</span>|g;
			if( $currcnt == 1 ){
			print qq{
			<br>
			<table border=0 cellspacing=0 cellpadding=0>
			<tr height="16">
				<td width=8><img src="$baseurl/img/tagleft.gif" width=8 height=16 border=0></td>
				<td background="$baseurl/img/tagbg.gif"><b>$dict{'topics'}</b></td>
				<td width=8><img src="$baseurl/img/tagright.gif" width=8 height=16 border=0></td>
			</tr>
			</table>
			<table width=100% border=0 cellpadding=0 cellspacing=0 cols=1 rows=1>
			<tr>
			<td bgcolor="$settings{'tblbg'}">
			<table border=0 cellpadding=2 cellspacing=1 width="100%" $ietblline>
			<tr>
				<th align="left" bgcolor="$settings{'theader'}"><font color="$settings{'theaderfg'}">$dict{'subject'}</font></th>
				<th align="left" bgcolor="$settings{'theader'}"><font color="$settings{'theaderfg'}">$dict{'moderator'}</font></th>
				<th align="right" bgcolor="$settings{'theader'}"><font color="$settings{'theaderfg'}">$dict{'modified'}</font></th>
				<th align="right" bgcolor="$settings{'theader'}"><font color="$settings{'theaderfg'}">$dict{'relevance'}</font></th>
			</tr>
			};
			}
			$authorname = $cfrdata[2]? $users{$cfrdata[2]}: $dict{'guest'};
			print qq{
			<tr>
			<td bgcolor="$settings{'othbg'}" align="left"><font color="$settings{'othfg'}">
			<img src="$baseurl/img/frnosubop.gif" width=16 height=16 border=0> <b>$totalcnt.</b> <a href="index.cgi?param=$cfrdata[1]">$cfrdata[0]</a>
			</font></td>
			<td bgcolor="$settings{'othbg'}" align="left"><font color="$settings{'othfg'}">$authorname</font></td>
			<td bgcolor="$settings{'othbg'}" align="right"><font color="$settings{'othfg'}">
			}, &customtime( $mfrtm[ $idxfr[ $i ] ] ), qq{</font></td>
			<td bgcolor="$settings{'othbg'}" align="right"><font color="$settings{'othfg'}">
			};
			$rel = int( $mfrcnt[ $idxfr[ $i ] ] / $mmaxfr * 100 + 0.5 );
			$imgwid = int( $rel * 0.4 );
			print qq{$rel <span style="background-color: yellow;"><img src="$baseurl/img/clear.gif" width="$imgwid" height="12" border=0></span></font>
			</td>
			</tr>
			};
		}
		print qq{
		</table>
		</td></tr></table>
		$separator
		};
	}
	if( $#mmsg >= 0 ){
		print qq{
		<br>
		<table border=0 cellspacing=0 cellpadding=0>
		<tr height="16">
			<td width=8><img src="$baseurl/img/tagleft.gif" width=8 height=16 border=0></td>
			<td background="$baseurl/img/tagbg.gif"><b>$dict{'messages'}</b></td>
			<td width=8><img src="$baseurl/img/tagright.gif" width=8 height=16 border=0></td>
		</tr>
		</table>
		<table width=100% border=0 cellpadding=0 cellspacing=0 cols=1 rows=1>
		<tr>
		<td bgcolor="$settings{'tblbg'}">
		<table border=0 cellpadding=2 cellspacing=1 width="100%" $ietblline>
		<tr>
			<th align="left" bgcolor="$settings{'theader'}"><font color="$settings{'theaderfg'}">$dict{'title'}</font></th>
			<th align="left" bgcolor="$settings{'theader'}"><font color="$settings{'theaderfg'}">$dict{'author'}</font></th>
			<th align="right" bgcolor="$settings{'theader'}"><font color="$settings{'theaderfg'}">$dict{'modified'}</font></th>
			<th align="right" bgcolor="$settings{'theader'}"><font color="$settings{'theaderfg'}">$dict{'relevance'}</font></th>
		</tr>
		};
		for $i ( 0..$#mmsg ){
			$currcnt++;
			$totalcnt++;
			if( $currcnt > $settings{'maxlistentry'} ){
				$currpg++;
				$currcnt = 0;
			}
			next if( $pg != $currpg );
			my @cmsgdata = split( /\t/, $mmsg[$i], 4 );
			$cmsgdata[0] =~ s|\a|<span class="match">|g;
			$cmsgdata[0] =~ s|\010|</span>|g;
			$cmsgdata[3] =~ s|\a|<span class="match">|g;
			$cmsgdata[3] =~ s|\010|</span>|g;
			$authorname = $cmsgdata[2]? $users{$cmsgdata[2]}: $dict{'guest'};
			print qq{
			<tr>
			<td bgcolor="$settings{'othbg'}" align="left">
			<font color="$settings{'othfg'}"><img src="$baseurl/img/msnosubop.gif" width=16 height=16 border=0> <b>$totalcnt.</b> <a href="index.cgi?param=$cmsgdata[1]">$cmsgdata[0]</a>
			</font></td>
			<td bgcolor="$settings{'othbg'}" align="left"><font color="$settings{'othfg'}">$authorname</font></td>
			<td bgcolor="$settings{'othbg'}" align="right"><font color="$settings{'othfg'}">
			}, &customtime( $mmsgtm[ $idxmsg[ $i ] ] ), qq{</font></td>
			<td bgcolor="$settings{'othbg'}" align="right"><font color="$settings{'othfg'}">
			};
			$rel = int( $mmsgcnt[ $idxmsg[ $i ] ] / $mmaxmsg * 100 + 0.5 );
			$imgwid = int( $rel * 0.4 );
			print qq{$rel <span style="background-color: yellow;"><img src="$baseurl/img/clear.gif" width="$imgwid" height="12" border=0></span>
			</font></td>
			</tr>
			<tr>
			<td bgcolor="$settings{'othbg'}" colspan="4" align="left"><font color="$settings{'othfg'}">
			<small>$cmsgdata[3]</small></font>
			</td>
			</tr>
			};
		}
		print qq{
		</table>
		</td></tr></table>
		$separator
		};
	}
}

# Three viewing mode will be identified: 1, 2, 3. Also note the root node in either forums tree or messages tree is alwyas zero.

$viewingmode = 0;
if( $taskname ne "search" ){
	$viewingmode = ( $fr && $fr != $$root{'id'} )? ( $msg? 3: 2): 1;
}

# $currfr points to the tree node while $fr is just an id number.

$currfr = &searchtree( $root, $fr );
@fdata = split( /\t/, $$currfr{'cap'} );
%thisfrm = (
	'title' => $fdata[0],
	'mngrid' => $fdata[1],
	'mngrname' => $user{$fdata[1]},
	'modtime' => $fdata[2],
	'msgs' => $fdata[3],
	'open' => $fdata[4],
);
undef @fdata;

sub travjptree {
	my $node = shift;
	$dep++;
	$jumpform .= qq{<option value="index.cgi?param=} . unpack( "h*", pack( "uS*", $lang, $thisuser, $$node{'id'}, 0, 0, 0 ) );
	$jumpform .= ( $fr == $$node{'id'}? "\" selected>": "\">" );
	if( $dep > 1 ){
		my $dp = $dep;
		my $prefix = "";
		my $np = $node;
		my $pp = $$np{'par'};
		if( $$np{'next'} ){
			$prefix = "|-";
			$np = $pp;
			$pp = $$np{'par'};
			$dp--;
		}
		while( $dp > 1 ){
			if( $$pp{'last'} == $np ){
				$prefix = ( $$np{'tag'}? "&nbsp; ": "\\-" ) . $prefix;
			} else {
				$prefix = "| " . $prefix;
			}
			$np = $pp;
			$pp = $$np{'par'};
			$dp--;
		}
		$jumpform .= $prefix;
	}
	$$node{'tag'} = 1;
	if( $$node{'son'} ){
		$jumpform .= "+ ";
	} else {
		$jumpform .= "- ";
	}
	my @ndata = split( /\t/, $$node{'cap'} );
	my $displen = MAXTITLECLIP - $dep * 2;
	if( $displen < 4 ){
		$displen = 4;
	}
	if( length( $ndata[0] ) > $displen ){
		substr( $ndata[0], $displen ) = "...";
	}
	$jumpform .= "$ndata[0]</option>\n";
	my $ptr = $$node{'son'};
	if( $ptr ){
		while( $ptr ){
			&travjptree( $ptr );
			$ptr = $$ptr{'next'};
		}
	}
	$dep--;
}

if( $settings{'jumpform'} ){
	$jumpform = qq{<select name="jump" style="font-family: Courier">\n};
	&travjptree( $root );
	$jumpform .= qq{</select>
	<input type="Button" value="&gt;&gt;" onClick="location=this.form.jump.options[this.form.jump.selectedIndex].value">
	};
}

@authormarks = ( 'markbanned', 'teamred', 'teamblue', 'teamwhite', 'teamyellow', 'teamgreen' );

sub authormark {
	my $auid = shift;
	return "" if( !$auid || !$users{$auid} );	# If guest or removed user
	if( $settings{'markwebmaster'} && $auid == 1 ){
		return qq{ <img src="$baseurl/img/iconwebmaster.gif" width=12 height=12 border=0>};
	} elsif( $settings{'markusergroups'} ){
		for( 0..5 ){
			if( $settings{'g'.$_} =~ /\b$auid\b/ ){
				return qq{ <img src="$baseurl/img/$authormarks[$_].gif" width=12 height=12 border=0>};
			}
		}
	}
	return "";
}

# This subroutine will be used in viewing mode 2 only, and MUST be called BEFORE reading message tree.
# After this call, a global $upperfrlinks will contain a string of HTML text.

sub getupperfrlinks {
	my $currfr = shift;
	return if( $currfr == $root );
	my @uppers = ( );
	my $flparam = "";
	$$currfr{'cap'} =~ /([^\t]+)\t/;
	unshift( @uppers, "<u>$1</u>" );
	my $frptr = $$currfr{'par'};
	if( $frptr ){
		while( $frptr != $root ){
			$flparam = unpack( "h*", pack( "uS*", $lang, $thisuser, $$frptr{'id'}, 1, 0, 0 ) );
			$$frptr{'cap'} =~ /([^\t]*)\t/;
			# Note here: if a forum title is too long, then clip it and show full length title in the "title" field of the "a" tag.
			$frtitleclip = $1;
			$frtitle = "";
			if( length( $frtitleclip ) > MAXTITLECLIP ){
				$frtitle = $frtitleclip;
				substr( $frtitleclip, MAXTITLECLIP ) = "...";
			}
			unshift( @uppers, qq{<a href="index.cgi?param=$flparam" title="$frtitle">$frtitleclip</a>} );
			$frptr = $$frptr{'par'};
		}
	}
	$flparam = unpack( "h*", pack( "uS*", $lang, $thisuser, $$root{'id'}, 1, 0, 0 ) );
	unshift( @uppers, qq{<b><a href="index.cgi?param=$flparam">$settings{'bbstitle'}</a></b>} );
	if( $settings{'upperlinkstyle'} ){
		my $mydep = 0;
		$upperfrlinks = qq{
		<table cellpadding=0 cellspacing=0 border=0>
		<tr><td bgcolor="$settings{'othbg'}">
		};
		while( $#uppers > 0 ){
			$mydep++;
			$upperfrlinks .= shift( @uppers ) . "<br>";
			$upperfrlinks .= qq{<font face="Courier">} . ( "&nbsp;&nbsp;" x $mydep ) . qq{\\- </font>};
		}
		$upperfrlinks .= qq{
		$uppers[0]
		</td></tr>
		</table>
		};
	} else {
		$upperfrlinks = join( qq{ <img src="$baseurl/img/smallbluearr.gif" width=12 height=12> }, @uppers );
	}
}

# This subroutine will also be used in viewing mode 2 only, and MUST be called BEFORE reading message tree.
# This table SHOULD be nested in a cell of a larger table.

sub getsubtopics {
	my $currnode = shift;
	my $frptr = $$currnode{'son'};
	if( !$frptr ){
		$subtopics = "";
		return;
	}
	$subtopics = qq{
		<br>
		<table border=0 cellspacing=0 cellpadding=0>
		<tr height="16">
			<td width=8><img src="$baseurl/img/tagleft.gif" width=8 height=16 border=0></td>
			<td background="$baseurl/img/tagbg.gif"><b>$dict{'subtopics'}</b></td>
			<td width=8><img src="$baseurl/img/tagright.gif" width=8 height=16 border=0></td>
		</tr>
		</table>
		<table width=100% border=0 cellpadding=0 cellspacing=0 cols=1 rows=1>
		<tr>
		<td bgcolor="$settings{'tblbg'}">
		<table border=0 cellpadding=2 cellspacing=1 width="100%" $ietblline>
		<tr>
			<th align="left" bgcolor="$settings{'theader'}"><font color="$settings{'theaderfg'}">$dict{'subject'}</font></th>
			<th align="left" bgcolor="$settings{'theader'}"><font color="$settings{'theaderfg'}">$dict{'moderator'}</font></th>
			<th align="right" bgcolor="$settings{'theader'}"><font color="$settings{'theaderfg'}">$dict{'messages'}</font></th>
			<th align="right" bgcolor="$settings{'theader'}"><font color="$settings{'theaderfg'}">$dict{'modified'}</font></th>
		</tr>
	};
	while( $frptr ){
		my @ndata = ( );
		# @ndata contains five values
		# 0	Title
		# 1	Moderator's user id
		# 2	Last modified time
		# 3	Number of messages
		# 4	Status: 1 = open, 0 = closed
		@ndata = split( /\t/, $$frptr{'cap'} );
		my $frstat = $ndata[4]? "op": "cl";
		my $frsons = $$frptr{'son'}? "hd": "no";
		my $frmark = ( ( time - $ndata[2] < $settings{'newmsgtime'} * 3600 && $cookies{'lastlogin'} < $ndata[2] )? qq{ <img src="$baseurl/img/marknew${lang}.gif" border=0>}: "" );
		my $frparam = unpack( "h*", pack( "uS*", $lang, $thisuser, $$frptr{'id'}, 1, 0, 0 ) );
		$subtopics .= qq{
		<tr>
			<td bgcolor="$settings{'othbg'}" align="left">
			<font color="$settings{'othfg'}"><img src="$baseurl/img/fr${frsons}sub${frstat}.gif" width=16 height=16 border=0> <a href="index.cgi?param=$frparam">$ndata[0]</a> $frmark</font></td>
			<td bgcolor="$settings{'othbg'}" align="left"><font color="$settings{'othfg'}">
		}. ( $users{$ndata[1]} || $dict{'guest'} ). &authormark($ndata[1]) . qq{</font></td>
			<td bgcolor="$settings{'othbg'}" align="right"><font color="$settings{'othfg'}">$ndata[3]</font></td>
			<td bgcolor="$settings{'othbg'}" align="right"><font color="$settings{'othfg'}">
		}. &customtime( $ndata[2] ). qq{</font></td>
		</tr>
		};
		$frptr = $$frptr{'next'};
	}
	$subtopics .= "</table></td></tr></table>" . $separator;
}

# This subroutine is to be called in viewing mode 3 only.
# After this call, the global $followups will hold a table of follow-up messages, similar to that of subtopics made above.

sub getfollowups {
	my $currnode = shift;
	my $msgptr = $$currnode{'son'};
	if( !$msgptr ){
		$followups = "";
		return;
	}
	$followups = qq{
		<table border=0 cellspacing=0 cellpadding=0>
		<tr height="16">
			<td width=8><img src="$baseurl/img/tagleft.gif" width=8 height=16 border=0></td>
			<td background="$baseurl/img/tagbg.gif"><b>$dict{'followups'}</b></td>
			<td width=8><img src="$baseurl/img/tagright.gif" width=8 height=16 border=0></td>
		</tr>
		</table>
		<table width=100% border=0 cellpadding=0 cellspacing=0 cols=1 rows=1>
		<tr>
		<td bgcolor="$settings{'tblbg'}">
		<table border=0 cellpadding=2 cellspacing=1 width="100%" $ietblline>
		<tr>
			<th align="left" bgcolor="$settings{'theader'}"><font color="$settings{'theaderfg'}">$dict{'title'}</font></th>
			<th align="left" bgcolor="$settings{'theader'}"><font color="$settings{'theaderfg'}">$dict{'author'}</font></th>
			<th align="right" bgcolor="$settings{'theader'}"><font color="$settings{'theaderfg'}">$dict{'reads'}</font></th>
			<th align="right" bgcolor="$settings{'theader'}"><font color="$settings{'theaderfg'}">$dict{'time'}</font></th>
		</tr>
	};
	while( $msgptr ){
		my @ndata = ( );
		# @ndata contains four values
		# 0	Title
		# 1	Moderator's user id
		# 2	Last modified time
		# 3 Number of reads
		# 4	Status: 1 = open, 0 = closed
		@ndata = split( /\t/, $$msgptr{'cap'} );
		my $msgtitle = "";
		my $msgtitleclip = $ndata[0];
		if( length( $msgtitleclip ) > MAXENTRYCLIP ){
			$msgtitle = $msgtitle;
			substr( $msgtitleclip, MAXENTRYCLIP ) = "...";
		}
		my $msgstat = $ndata[4]? "op": "cl";
		my $msgsons = $$msgptr{'son'}? "hd": "no";
		my $msgmark = ( ( time - $ndata[2] < $settings{'newmsgtime'} && $cookies{'lastlogin'} < $ndata[2] )? qq{ <img src="$baseurl/img/marknew.gif" width=17 height=9 border=0>}: "" );
		my $msgparam = unpack( "h*", pack( "uS*", $lang, $thisuser, $fr, 0, 0, $$msgptr{'id'} ) );
		$followups .= qq{
		<tr>
			<td bgcolor="$settings{'othbg'}"><font color="$settings{'othfg'}"><img src="$baseurl/img/ms${msgsons}sub${msgstat}.gif" width=16 height=16 border=0> <a href="index.cgi?param=$msgparam" title="$msgtitle">$msgtitleclip</a> $msgmark</font></td>
			<td bgcolor="$settings{'othbg'}"><font color="$settings{'othfg'}">}, 
			( $users{$ndata[1]} || $dict{'guest'} ), &authormark( $ndata[1] ), qq{</font></td>
			<td bgcolor="$settings{'othbg'}" align="right"><font color="$settings{'othfg'}">$ndata[3]</font></td>
			<td bgcolor="$settings{'othbg'}" align="right"><font color="$settings{'othfg'}">
		} . &customtime( $ndata[2] ) . qq{
			</font></td>
			</tr>
		};
		$msgptr = $$msgptr{'next'};
	}
	$followups .= "</table></td></tr></table>";
	$followups .= $separator;
}

# The immediately following subroutine is used internally for displaying nodes in sorted order.
# $sortby and $sortdir are assigned above, if the taskname is "sort".
# $sortby = 0 (title), 1 (author/moderator), 2 (reads/messages), 3 (time)
# $sordir = 0 (a to z), 1 (z to a)
# In this special mode, the branch prefix gifs are not shown.

@sortnodes = ( );	# Pointers to nodes!
@nodesdata = ( );	# Values of nodes, vary with sorting criteria

sub findnodes {	# Should be used to find ALL nodes in a tree!
	my $np = shift;
	my $pp = $$np{'son'};
	if( $pp ){
		&findnodes( $pp );
		$pp = $$pp{'next'};
		while( $pp ){
			&findnodes( $pp );
			$pp = $$pp{'next'};
		}
	}
	if( $np != $root ){	# The special root node doesn't count.
		push( @sortnodes, $np );
		my @ndata = split( /\t/, $$np{'cap'} );
		push( @nodesdata, $ndata[$sortby] );
	}
}

sub striptitle {
	my $txt = shift;
	$txt =~ s/^(((RE)|(RE\[\d+\])):\s+)+//;
	return $txt;
}

sub sortthenodes {
	if( $sortby == 0 ){
		my @sorttitles = map{ &striptitle( $_ ) } @nodesdata;
		@sortnodes = @sortnodes[
			sort {
				uc( $sorttitles[$a] ) cmp uc( $sorttitles[$b] )
			} 0..$#sortnodes
		];
	} elsif( $sortby == 1 ){
		@sortnodes = @sortnodes[
			sort {
				uc( $users{ $nodesdata[$a] } ) cmp uc( $users{ $nodesdata[$b] } )
			} 0..$#sortnodes
		];
	} else {
		@sortnodes = @sortnodes[
			sort {
				$nodesdata[$a] <=> $nodesdata[$b]
			} 0..$#sortnodes
		];
	}
	if( $sortdir ){
		@sortnodes = reverse @sortnodes;
	}
}

# This recursive function should be called in viewing mode 1 only.
# This function will DIRECTLY print a series of TABLE ROWS.

sub sortfrtree {
	&findnodes( $root );
	&sortthenodes;
	for( 0..$#sortnodes ){
		my $node = $sortnodes[$_];	# Remember this is a pointer already.
		$currcnt++;
		if( $currcnt > $settings{'maxlistentry'} ){
			$currpg++;
			$currcnt = 0;
		}
		next if( $currpg != $pg );
		my @ndata = split( /\t/, $$node{'cap'} );
		my $frstat = $ndata[4]? "op": "cl";
		my $frsons = $$node{'son'}? "hd": "no";
		my $frmark = ( ( time - $ndata[2] < $settings{'newmsgtime'} * 3600 && $cookies{'lastlogin'} < $ndata[2] )? qq{ <img src="$baseurl/img/marknew${lang}.gif" border=0>}: "" );
		my $frparam = unpack( "h*", pack( "uS*", $lang, $thisuser, $$node{'id'}, 1, 0, 0 ) );
		print qq{
			<tr>
			<td bgcolor="$settings{'othbg'}">
			<img src="$baseurl/img/fr${frsons}sub${frstat}.gif" width=16 height=16 border=0>
			</td>
			<td bgcolor="$settings{'othbg'}"><font color="$settings{'othfg'}">
			<span style="font-size: 11pt; font-weight: bold;">
			<a href="index.cgi?param=$frparam">$ndata[0]</a>
			</span> $frmark<br>
			$settings{ 'fr' . $$node{'id'} }
			</font>
			</td>
			<td bgcolor="$settings{'othbg'}"><font color="$settings{'othfg'}">$users{$ndata[1]}&nbsp;</font></td>
			<td bgcolor="$settings{'othbg'}" align="right"><font color="$settings{'othfg'}">$ndata[3]</font></td>
			<td bgcolor="$settings{'othbg'}" align="right"><font color="$settings{'othfg'}">
		} , &customtime( $ndata[2] ) , qq{
			</font></td>
			</tr>
		};
	}
}

sub travfrtree {
	my $node = shift;
	return if( !$node );
	my @ndata = ( );
	@ndata = split( /\t/, $$node{'cap'} );
	if( $$node{'id'} && $ndata[3] ){
		push( @allfr, join( "\t", $$node{'id'}, $$node{'cap'} ) );
		push( @frmsg, $ndata[3] );
	}
	$dep++;
	if( $node != $root && (!$md || $dep <= $md) ){
	if( !$settings{'skipcountsubs'} || $$node{'par'} == $root ){ 
		$currcnt++;
	}
	if( $currcnt > $settings{'maxlistentry'} && $$node{'par'} == $root ){
		$currpg++;
		$currcnt = 0;
	}
	if( $currpg == $pg ){
	$troff = ( $dep > 2 )? 2: 0;
	print qq{
		<tr>
		<td bgcolor="$tcellbg[$troe+$troff][0]"><nobr>
	};
	# This "if" block will write a series of <IMG> tags to display proper leading spaces and icons.
	if( $dep > 2 ){
		my $dp = $dep;
		my @prefix = ( );
		my $np = $node;
		my $pp = $$np{'par'};
		if( $$np{'next'} ){
			unshift( @prefix, qq{<img src="$baseurl/img/markbr.gif" width=16 height=16>} );
			$np = $pp;
			$pp = $$np{'par'};
			$dp--;
		}
		while( $dp > 2 ){
			if( $$pp{'last'} == $np ){
				unshift( @prefix, ( $$np{'tag'} == 10 )?
				qq{<img src="$baseurl/img/clear.gif" width=16 height=16>}:
				qq{<img src="$baseurl/img/marktm.gif" width=16 height=16>} );
			} else {
				unshift( @prefix, qq{<img src="$baseurl/img/markcn.gif" width=16 height=16>} );
			}
			$np = $pp;
			$pp = $$np{'par'};
			$dp--;
		}
		print @prefix;
	}
	$$node{'tag'} = 10;
	my $frstat = $ndata[4]? "op": "cl";
	my $frsons = $$node{'son'}? (( !$md || $dep < $md )? "sh": "hd" ): "no";
	my $frmark = ( ( time - $ndata[2] < $settings{'newmsgtime'} * 3600 && $cookies{'lastlogin'} < $ndata[2] )? qq{ <img src="$baseurl/img/marknew${lang}.gif" border=0>}: "" );
	my $frparam = unpack( "h*", pack( "uS*", $lang, $thisuser, $$node{'id'}, 1, 0, 0 ) );
	print qq{
		<img src="$baseurl/img/fr${frsons}sub${frstat}.gif" width=16 height=16 border=0></nobr>
		</td><td bgcolor="$tcellbg[$troe+$troff][0]">
		<font color="$tcellfg[$troe+$troff][0]">
		<span style="font-size: 11pt; font-weight: bold;">
		<a href="index.cgi?param=$frparam">$ndata[0]</a>
		</span> $frmark<br>
		$settings{ 'fr' . $$node{'id'} }
		</font>
		</td>
		<td bgcolor="$tcellbg[$troe+$troff][1]"><font color="$tcellfg[$troe+$troff][1]">$users{$ndata[1]}&nbsp;</font></td>
		<td bgcolor="$tcellbg[$troe+$troff][2]" align="right"><font color="$tcellfg[$troe+$troff][2]">$ndata[3]</font></td>
		<td bgcolor="$tcellbg[$troe+$troff][3]" align="right"><font color="$tcellfg[$troe+$troff][3]">
	} , &customtime( $ndata[2] ) , qq{
		</font>
		</td>
		</tr>
	};
	}
	}
	$$node{'tag'} = 10;
	my $ptr = $$node{'son'};
	if( $ptr ){
		while( $ptr ){
			&travfrtree( $ptr );
			$ptr = $$ptr{'next'};
		}
	}
	$dep--;
	unless( $dep > 1 ) {
		$troe = 1 - $troe;
	}
}

sub sorttree {
	&findnodes( $root );
	&sortthenodes;
	for( 0..$#sortnodes ){
		my $node = $sortnodes[$_];	# Remember this is a pointer already.
		$currcnt++;
		if( $currcnt > $settings{'maxlistentry'} ){
			$currpg++;
			$currcnt = 0;
		}
		next if( $currpg != $pg );
		my @ndata = split( /\t/, $$node{'cap'} );
		my $msgstat = $ndata[4]? "op": "cl";
		my $msgsons = $$node{'son'}? "hd": "no";
		my $msgmark = ( ( time - $ndata[2] < $settings{'newmsgtime'} * 3600 && $cookies{'lastlogin'} < $ndata[2] )? qq{ <img src="$baseurl/img/marknew${lang}.gif" border=0>}: "" );
		my $msgparam = unpack( "h*", pack( "uS*", $lang, $thisuser, $fr, 1, 0, $$node{'id'} ) );
		my $msgtitle = "";
		my $maxtitlelen = MAXENTRYCLIP - $dep * 3;
		if( $maxtitlelen < 6 ){
			$maxtitlelen = 6;
		}
		if( length( $ndata[0] ) > $maxtitlelen ){
			substr( $ndata[0], $maxtitlelen ) = "...";
			$msgtitle = $ndata[0];
		}
		print qq{
			<tr>
			<td bgcolor="$settings{'othbg'}"><font color="$settings{'othfg'}">
			<img src="$baseurl/img/ms${msgsons}sub${msgstat}.gif" width=16 height=16 border=0>
			<a href="index.cgi?param=$msgparam" title="$msgtitle">$ndata[0]</a> $msgmark
			</font></td>
			<td bgcolor="$settings{'othbg'}"><font color="$settings{'othfg'}">}, 
			( $users{$ndata[1]} || $dict{'guest'} ), &authormark( $ndata[1] ), qq{</font></td>
			<td bgcolor="$settings{'othbg'}" align="right"><font color="$settings{'othfg'}">$ndata[3]</font></td>
			<td bgcolor="$settings{'othbg'}" align="right"><font color="$settings{'othfg'}">
		} , &customtime( $ndata[2] ) , qq{</font>
			</td>
			</tr>
		};
	}
}

# This recursive function should be called in viewing mode 2 only.
# The call has to be made AFTER a tree-building call, and the $root is overwritten.
# This function will also DIRECTLY print a series of TABLE ROWS of messages.

sub travtree {
	my $node = shift;
	if( !$node ){
		print qq{
			<tr>
				<td bgcolor="$settings{'othbg'}" colspan=4><font color="$settings{'othfg'}">$dict{'nomessage'}</font></td>
			</tr>
		};
		return;
	}
	$dep++;
	if( $node != $root && (!$md || $dep <= $md) ){
	$currcnt++;
	if( $currcnt > $settings{'maxlistentry'} && $$node{'par'} == $root ){
		$currpg++;
		$currcnt = 0;
	}
	if( $currpg == $pg ){
	$troff = ( $dep > 2 )? 2: 0;
	print qq{
		<tr>
		<td bgcolor="$tcellbg[$troe+$troff][0]">
	};
	if( $dep > 2 ){
		my $dp = $dep;
		my @prefix = ( );
		my $np = $node;
		my $pp = $$np{'par'};
		if( $$np{'next'} ){
			unshift( @prefix, qq{<img src="$baseurl/img/markbr.gif" width=16 height=16>} );
			$np = $pp;
			$pp = $$np{'par'};
			$dp--;
		}
		while( $dp > 2 ){
			if( $$pp{'last'} == $np ){
				unshift( @prefix, $$np{'tag'}?
				qq{<img src="$baseurl/img/clear.gif" width=16 height=16>}:
				qq{<img src="$baseurl/img/marktm.gif" width=16 height=16>} );
			} else {
				unshift( @prefix, qq{<img src="$baseurl/img/markcn.gif" width=16 height=16>} );
			}
			$np = $pp;
			$pp = $$np{'par'};
			$dp--;
		}
		print @prefix;
	}
	$$node{'tag'} = 1;
	my @ndata = ( );
	@ndata = split( /\t/, $$node{'cap'} );
	my $msgstat = $ndata[4]? "op": "cl";
	my $msgsons = $$node{'son'}? (( !$md || $dep < $md )? "sh": "hd" ): "no";
	my $msgmark = ( ( time - $ndata[2] < $settings{'newmsgtime'} * 3600 && $cookies{'lastlogin'} < $ndata[2] )? qq{ <img src="$baseurl/img/marknew${lang}.gif" border=0>}: "" );
	my $msgparam = unpack( "h*", pack( "uS*", $lang, $thisuser, $fr, 1, 0, $$node{'id'} ) );
	my $msgtitle = "";
	my $maxtitlelen = MAXENTRYCLIP - $dep * 3;
	if( $maxtitlelen < 6 ){
		$maxtitlelen = 6;
	}
	if( length( $ndata[0] ) > $maxtitlelen ){
		$msgtitle = $ndata[0];
		substr( $ndata[0], $maxtitlelen ) = "...";
	}
	print qq{
		<img src="$baseurl/img/ms${msgsons}sub${msgstat}.gif" width=16 height=16 border=0>
		<font color="$tcellfg[$troe+$troff][0]">
		<a href="index.cgi?param=$msgparam" title="$msgtitle">$ndata[0]</a> $msgmark
		</font>
		</td>
		<td bgcolor="$tcellbg[$troe+$troff][1]"><font color="$tcellfg[$troe+$troff][1]">
		}, ( $users{$ndata[1]} || $dict{'guest'} ), &authormark( $ndata[1] ), qq{</font></td>
		<td bgcolor="$tcellbg[$troe+$troff][2]" align="right"><font color="$tcellfg[$troe+$troff][2]">$ndata[3]</font></td>
		<td bgcolor="$tcellbg[$troe+$troff][3]" align="right"><font color="$tcellfg[$troe+$troff][3]">
	} , &customtime( $ndata[2] ) , qq{
		</font>
		</td>
		</tr>
	};
	}
	}
	my $ptr = $$node{'son'};
	if( $ptr ){
	while( $ptr ){
		&travtree( $ptr );
		$ptr = $$ptr{'next'};
	}
	}
	$dep--;
	unless( $dep > 1 ){
		$troe = 1 - $troe;
	}
}

%emoticons = (
	':)' => 'emotsmile.gif',
	':(' => 'emotsad.gif',
	'B^)' => 'emotsunglass.gif',
	':-)' => 'emotsmile.gif',
	':-(' => 'emotsad.gif',
	'B-)' => 'emotsunglass.gif',
	':-D' => 'emotlaugh.gif',
	';-)' => 'emotwinkle.gif',
	':D' => 'emotlaugh.gif',
	';)' => 'emotwinkle.gif',
);

sub showmsg {
	my $node = shift;
	my $msgid = $$node{'id'};
	my $nparam = unpack( "h*", pack( "uS*", $lang, $thisuser, $fr, $pg, $md, $msgid ) );
	# Five fields: title, id, time, reads, status
	my @ndata = split( /\t/, $$node{'cap'} );
	$ndata[3]++ if( !defined $thisisforsub || $settings{'countsubhits'} );
	$thisisforsub = 1;	# Defined after first call to "&showmsg"
	$$node{'cap'} = join( "\t", @ndata );
	# Five fields: userid, remote address, time, title, and text
	my @msginfo = split( /\t/, $frdb{$msgid}, 5 );
	%thismsg = (
		'title' => $ndata[0],
		'authorid' => $ndata[1],
		'authorname' => ( $users{$ndata[1]} || $dict{'guest'} ),
		'lastmod' => $ndata[2],
		'posttime' => $msginfo[2],
		'reads' => $ndata[3],
		'open' => $ndata[4],
		'ipaddr' => ( !$settings{'hideip'} || $mystatus{'manager'} )? $msginfo[1]: $dict{'keepsecret'},
		'text' => $msginfo[4],
		'autoinform' => ( $ndata[4] == 2 )? 1: 0,
		'depth' => 0,
	);
	my $ptr = $$node{'par'};
	while( $ptr != $root ){
		$thismsg{'depth'}++;
		$ptr = $$ptr{'par'};
	}
	$toolbars{'reply'} = "";
	$toolbars{'remove'} = "";
	$toolbars{'lockunlock'} = "";
	$toolbars{'autoinform'} = "";
	$toolbars{'edit'} = "";
	$toolbars{'email'} = join( " ",
		qq{<a href="utils.cgi?param=$nparam&amp;task=} . unpack( "H*", pack( "uS", "email", $thisuser ) ) . qq{">},
		qq{<img src="$baseurl/img/navemail.gif" width=16 height=16 border=0 alt="$dict{'email'}">} x $showtbicon,
		( '[' . $dict{'email'} . ']' ) x $showtbtext,
		qq{</a>\n} );
	if( $settings{'showfollowups'} && ( $mystatus{'member'} || ( $mystatus{'guest'} && $settings{'guestpost'} ) ) ){
		$toolbars{'reply'} = ( $thisfrm{'open'} && $thismsg{'open'} && ( !$settings{'maxreplydepth'} || $thismsg{'depth'} <= $settings{'maxreplydepth'} ) )? join( " ",
			qq{<a href="post.cgi?param=$nparam">},
			qq{<img src="$baseurl/img/navreply.gif" width=16 height=16 border=0 alt="$dict{'reply'}">} x $showtbicon,
			( '[' . $dict{'reply'} . ']' ) x $showtbtext,
			qq{</a>\n} ): "";
		if( $mystatus{'member'} && ( $thismsg{'authorid'} == $thisuser ) ){
			$toolbars{'autoinform'} = $thismsg{'autoinform'}?
				join( " ",
					qq{<a href="admin.cgi?task=} . unpack( "H*", pack( "uS", "noinform", $thisuser ) ) . qq{&amp;param=$nparam">},
					qq{<img src="$baseurl/img/navnoinform.gif" width=16 height=16 border=0 alt="$dict{'noinform'}">} x $showtbicon,
					( '[' . $dict{'noinform'} . ']' ) x $showtbtext,
					qq{</a>\n} ):
				join( " ",
					qq{<a href="admin.cgi?task=} . unpack( "H*", pack( "uS", "autoinform", $thisuser ) ) . qq{&amp;param=$nparam">},
					qq{<img src="$baseurl/img/navautoinform.gif" width=16 height=16 border=0 alt="$dict{'autoinform'}">} x $showtbicon,
					( '[' . $dict{'autoinform'} . ']' ) x $showtbtext,
					qq{</a>\n} );
		}
		if( $mystatus{'member'} && ( $thismsg{'authorid'} == $thisuser || $thisfrm{'mngrid'} == $thisuser ) || $mystatus{'manager'} ){
			$toolbars{'remove'} = join( " ",
				qq{<a href="admin.cgi?task=} . unpack( "H*", pack( "uS", "remove", $thisuser ) ) . qq{&amp;param=$nparam">},
				qq{<img src="$baseurl/img/navremove.gif" width=16 height=16 border=0 alt="$dict{'remove'}">} x $showtbicon,
				( '[' . $dict{'remove'} . ']' ) x $showtbtext,
				qq{</a>\n} );
			$toolbars{'edit'} = ( ( $settings{'allowedit'} || $mystatus{'webmaster'} ) ?
				join( " ",
					qq{<a href="admin.cgi?task=} . unpack( "H*", pack( "uS", "edit", $thisuser ) ) . qq{&amp;param=$nparam">},
					qq{<img src="$baseurl/img/navedit.gif" width=16 height=16 border=0 alt="$dict{'edit'}">} x $showtbicon,
					( '[' . $dict{'edit'} . ']' ) x $showtbtext,
					qq{</a>\n} ):
				"" );
			if( !$thisfrm{'open'} ){
				$toolbars{'lockunlock'} = "";
			} else {
				$toolbars{'lockunlock'} = $thismsg{'open'}?
					join( " ",
						qq{<a href="admin.cgi?task=} . unpack( "H*", pack( "uS", "lock", $thisuser ) ) . qq{&amp;param=$nparam">},
						qq{<img src="$baseurl/img/navlock.gif" width=16 height=16 border=0 alt="$dict{'lock'}">} x $showtbicon,
						( '[' . $dict{'lock'} . ']' ) x $showtbtext,
						qq{</a>\n} ):
					join( " ",
						qq{<a href="admin.cgi?task=} . unpack( "H*", pack( "uS", "unlock", $thisuser ) ) . qq{&amp;param=$nparam">},
						qq{<img src="$baseurl/img/navunlock.gif" width=16 height=16 border=0 alt="$dict{'unlock'}">} x $showtbicon,
						( '[' . $dict{'unlock'} . ']' ) x $showtbtext,
						qq{</a>\n} );
			}
		}
	}
	unless( $settings{'allowhtml'} ){
#		$thismsg{'text'} =~ s{</?\w+>}{}g;
		$thismsg{'text'} =~ s{<[^<>]*>}{}g;
		$thismsg{'text'} =~ s{<}{&lt;}g;
		$thismsg{'text'} =~ s{>}{&gt;}g;
	}
	if( $settings{'findhyperlinks'} ){
		$a = "";
		$thismsg{'text'} =~ s{((https?)|(ftp)|)://([^\010\012\015\040,"\(\)\[\]<>])+}{
			( ( $a = $&, chomp $a, $settings{'insertimage'} ) && $a =~ /(\.gif)|(\.je?pg)$/ )?
			qq{<img src="$a" border=0>}:
			qq{<a href="$a">$a</a>}
		}gxe;
		$thismsg{'text'} =~ s{(\w|\.)+\@(\S+\.)+\w+}{<a href="mailto:$&">$&</a>}g;
	}
	$thismsg{'text'} =~ s{([\n|\r]+)}{ "<br>" x ( ( length($1)/2 <=> 1 ) + 1 ) }ge;
	if( $settings{'findemoticons'} ){
		$thismsg{'text'} =~ s{(:-?[\)|\(])|(B[-|\^]\))|(:-?D)|(;-?\))}{<img src="$baseurl/img/$emoticons{$&}" border=0>}g;
	}
	print qq{
		<a name="msg$msgid">
		<table border=0 cellspacing=0 cellpadding=0>
		<tr height="16">
			<td width=8><img src="$baseurl/img/tagleft.gif" width=8 height=16 border=0></td>
			<td background="$baseurl/img/tagbg.gif"><b>$thismsg{'title'}</b></td>
			<td width=8><img src="$baseurl/img/tagright.gif" width=8 height=16 border=0></td>
		</tr>
		</table>
		</a>
		$separator
		<table width=100% border=0 cellpadding=0 cellspacing=0 cols=1 rows=1>
		<tr>
		<td bgcolor="$settings{'tblbg'}">
		<table border=0 cellpadding=2 cellspacing=1 width="100%">
		<tr>
		<td bgcolor="$settings{'othbg'}" align="left">
	};
	foreach $tb ( @tools_ins ) {
		print $toolbars{$tb};
	}
	print qq{
		<img src="$baseurl/img/decdiamond.gif" width=11 height=11 border=0> $dict{'author'}: $thismsg{'authorname'}
	}, &authormark( $thismsg{'authorid'} ), qq{
		<img src="$baseurl/img/decdiamond.gif" width=11 height=11 border=0> $dict{'time'}:
	}, &customtime( $thismsg{'lastmod'} ), qq{
		<img src="$baseurl/img/decdiamond.gif" width=11 height=11 border=0> IP: $thismsg{'ipaddr'}
		</td>
		</tr>
		<tr>
		<td bgcolor="$settings{'othbg'}" align="left">
		$thismsg{'text'}
		</td>
		</tr>
		</table>
		</td></tr></table>
	}, $separator, "<br><br>";
	return unless( $settings{'showfollowups'} );
	$ptr = $$node{'son'};
	if( $ptr ){
		while( $ptr ){
			&showmsg( $ptr );
			$ptr = $$ptr{'next'};
		}
	}
}

# To see if the user is subscribed to current forum. Return 1 on positive answer.

sub usersubscribed {
	my %maillist;
	my $inlist = 0;
	tie( %maillist, $DB_Type, "dat/ml$fr", &GDBM_WRCREAT, 0666 );
	if( defined $maillist{$userinfo{'email'}} ){
		$inlist = 1;
	}
	untie %maillist;
	return $inlist;
}

sub getuppermsglinks {
	my $np = shift;
	return if( $np == $root );
	my $tp = $$np{'par'};
	my @uppers = ( );
	$$np{'cap'} =~ /^([^\t]+)\t/;
	push( @uppers, "<u>$1</u>" );
	while( $tp && $tp != $root ){
		my @ndata = split( /\t/, $$tp{'cap'} );
		if( length( $ndata[0] ) > MAXTITLECLIP ){
			substr( $ndata[0], MAXTITLECLIP ) = "...";
		}
		unshift( @uppers, qq{<a href="index.cgi?param=} . unpack( "h*", pack( "uS*", $lang, $thisuser, $fr, $pg, $md, $$tp{'id'} ) ) . qq{">$ndata[0]</a>} );
		$tp = $$tp{'par'};
	}
	unshift( @uppers, qq{<b><a href="index.cgi?param=} . unpack( "h*", pack( "uS*", $lang, $thisuser, $fr, 1, $md, 0 ) ) . qq{">$thisfrm{'title'}</a></b>} );
	if( $settings{'upperlinkstyle'} ){
		my $mydep = 0;
		$uppermsglinks = qq{
		<table cellpadding=0 cellspacing=0 border=0>
		<tr><td bgcolor="$settings{'othbg'}">
		};
		while( $#uppers > 0 ){
			$mydep++;
			$uppermsglinks .= shift( @uppers ) . "<br>";
			$uppermsglinks .= qq{<font face="Courier">} . ( "&nbsp;&nbsp;" x $mydep ) . qq{\\- </font>};
		}
		$uppermsglinks .= qq{
		$uppers[0]
		</td></tr>
		</table>
		};
	} else {
		$uppermsglinks = join( qq{ <img src="$baseurl/img/smallbluearr.gif" width=12 height=12> }, @uppers );
	}
}

if( $viewingmode == 1 || $viewingmode == 2 ){
	foreach $sortbyvar( 0..3 ) {
		$sorttasks[$sortbyvar][0] = unpack( "H*", pack( "uS*", "sort", $thisuser, $sortbyvar, 0 ) );
		$sorttasks[$sortbyvar][1] = unpack( "H*", pack( "uS*", "sort", $thisuser, $sortbyvar, 1 ) );
	}
	$newtask = "&amp;task=$fields{'task'}";		# This is used for page buttons only. See below for "search".
}

if( $viewingmode == 1 ){
	if( $mystatus{'member'} ){
		if( $mystatus{'senior'} ){
			$toolbars{'newfr'} = join( " ",
				qq{<a href="admin.cgi?task=} . unpack( "H*", pack( "uS", "newfr", $thisuser ) ) . qq{&amp;param=$fields{'param'}">},
				qq{<img src="$baseurl/img/navnewfr.gif" width=16 height=16 border=0 alt="$dict{'newforum'}">} x $showtbicon,
				( '[' . $dict{'newfr'} . ']' ) x $showtbtext,
				qq{</a>\n} );
		}
	}
	print qq{<table width=100% border=0><tr><td>};
	foreach $tb ( @tools_bbs, @tools_nav, @tools_adm, @tools_set, @tools_oth ){
		print $toolbars{$tb};
	}
	print qq{
		</td></tr></table>
		<br>
		$instantnews
		<table border=0 cellspacing=0 cellpadding=0>
		<tr height="16">
			<td width=8><img src="$baseurl/img/tagleft.gif" width=8 height=16 border=0></td>
			<td background="$baseurl/img/tagbg.gif"><b>$dict{'topics'}</b></td>
			<td width=8><img src="$baseurl/img/tagright.gif" width=8 height=16 border=0></td>
		</tr>
		</table>
		<table width=100% border=0 cellpadding=0 cellspacing=0 cols=1 rows=1>
		<tr>
		<td bgcolor="$settings{'tblbg'}">
		<table width=100% cellpadding=2 cellspacing=1 border=0 $ietblline>
		<tr>
			<th align="left" bgcolor="$settings{'theader'}">&nbsp;
			</th>
			<th align="left" bgcolor="$settings{'theader'}"><nobr>
			<a href="index.cgi?param=$fields{'param'}&amp;task=$sorttasks[0][0]"><img src="$baseurl/img/sortatoz.gif" width=12 height=12 border=0></a>
			<a href="index.cgi?param=$fields{'param'}&amp;task=$sorttasks[0][1]"><img src="$baseurl/img/sortztoa.gif" width=12 height=12 border=0></a>
			<font color="$settings{'theaderfg'}">$dict{'subject'}</nobr></font>
			</th>
			<th align="left" bgcolor="$settings{'theader'}"><nobr>
			<a href="index.cgi?param=$fields{'param'}&amp;task=$sorttasks[1][0]"><img src="$baseurl/img/sortatoz.gif" width=12 height=12 border=0></a>
			<a href="index.cgi?param=$fields{'param'}&amp;task=$sorttasks[1][1]"><img src="$baseurl/img/sortztoa.gif" width=12 height=12 border=0></a>
			<font color="$settings{'theaderfg'}">$dict{'moderator'}</nobr></font>
			</th>
			<th align="right" bgcolor="$settings{'theader'}"><nobr>
			<a href="index.cgi?param=$fields{'param'}&amp;task=$sorttasks[3][0]"><img src="$baseurl/img/sortatoz.gif" width=12 height=12 border=0></a>
			<a href="index.cgi?param=$fields{'param'}&amp;task=$sorttasks[3][1]"><img src="$baseurl/img/sortztoa.gif" width=12 height=12 border=0></a>
			<font color="$settings{'theaderfg'}">$dict{'messages'}</nobr></font>
			</th>
			<th align="right" bgcolor="$settings{'theader'}"><nobr>
			<a href="index.cgi?param=$fields{'param'}&amp;task=$sorttasks[2][0]"><img src="$baseurl/img/sortatoz.gif" width=12 height=12 border=0></a>
			<a href="index.cgi?param=$fields{'param'}&amp;task=$sorttasks[2][1]"><img src="$baseurl/img/sortztoa.gif" width=12 height=12 border=0></a>
			<font color="$settings{'theaderfg'}">$dict{'modified'}</nobr></font>
			</th>
		</tr>
	};
	if( $$root{'son'} ){
		( $taskname eq "sort" )?
			&sortfrtree( ):
			&travfrtree( $root );
		$troe = 1;
	} else {
		print qq{
		<tr>
			<td bgcolor="$settings{'othbg'}" colspan=4><font color="$settings{'othfg'}">$dict{'nomessage'}</font></td>
		</tr>
		};
	}
	print qq{
		</table>
		</td></tr></table>
	}, $separator;
	unless( $settings{'hidepoptopics'} || $taskname eq "sort" ){
	@allfr = @allfr[
		sort {
			$frmsg[$b] <=> $frmsg[$a];
		} 0..$#allfr
	];
	$poptopics = qq{
		<br>
		<table border=0 cellspacing=0 cellpadding=0>
		<tr height="16">
			<td width=8><img src="$baseurl/img/tagleft.gif" width=8 height=16 border=0></td>
			<td background="$baseurl/img/tagbg.gif"><b>$dict{'poptopics'}</b></td>
			<td width=8><img src="$baseurl/img/tagright.gif" width=8 height=16 border=0></td>
		</tr>
		</table>
		<table width=100% border=0 cellpadding=0 cellspacing=0 cols=1 rows=1>
		<tr>
		<td bgcolor="$settings{'tblbg'}">
		<table border=0 cellpadding=2 cellspacing=1 width="100%" $ietblline>
		<tr>
			<th align="left" bgcolor="$settings{'theader'}"><font color="$settings{'theaderfg'}">$dict{'subject'}</font></th>
			<th align="left" bgcolor="$settings{'theader'}"><font color="$settings{'theaderfg'}">$dict{'moderator'}</font></th>
			<th align="right" bgcolor="$settings{'theader'}"><font color="$settings{'theaderfg'}">$dict{'messages'}</font></th>
			<th align="right" bgcolor="$settings{'theader'}"><font color="$settings{'theaderfg'}">$dict{'modified'}</font></th>
		</tr>
	};
	$poptopicsprevlength = length( $poptopics );
	my $poptopnum = ( $#allfr > 4 )? 4: $#allfr;
	for( 0..$poptopnum ){
		# Each line of @allfr contains forum id, title, number of messages, and status.
		my @thistopic = split( /\t/, $allfr[$_], 6 );
		my $fricon = $thistopic[5]? "frnosubop" : "frnosubcl";
		my $jpparam = unpack( "h*", pack( "uS*", $lang, $thisuser, $thistopic[0], 1, 0, 0 ) );
		$poptopics .= qq{
		<tr>
		<td bgcolor="$settings{'othbg'}" align="left">
		<font color="$settings{'othfg'}"><img src="$baseurl/img/$fricon.gif" width=16 height=16 border=0> <a href="index.cgi?param=$jpparam">$thistopic[1]</a></font></td>
		<td bgcolor="$settings{'othbg'}" align="left"><font color="$settings{'othfg'}">
		} . ( $users{$thistopic[2]} || $dict{'guest'} ) . &authormark( $thistopic[2] ) . qq{</font></td>
		<td bgcolor="$settings{'othbg'}" align="right"><font color="$settings{'othfg'}">$thistopic[4]</font></td>
		<td bgcolor="$settings{'othbg'}" align="right"><font color="$settings{'othfg'}">
		} . &customtime( $thistopic[3] ) . qq{
		</font></td>
		</tr>
		};
	}
	if( length( $poptopics ) == $poptopicsprevlength ){
		$poptopics .= qq{
		<tr>
			<td bgcolor="$settings{'othbg'}" colspan=4><font color="$settings{'othfg'}">$dict{'nomessage'}</font></td>
		</tr>
		};
	}
	$poptopics .= qq{
		</table>
		</td></tr></table>
	};
	print $poptopics, $separator, "<br>";
	}
} elsif( $viewingmode == 2 ){
	print qq{<table width=100% border=0><tr><td>};
	&getupperfrlinks( $currfr );
	&getsubtopics( $currfr );
	$toolbars{'previous'} = $$currfr{'prev'}? join( " ",
		qq{<a href="index.cgi?param=} . unpack( "h*", pack( "uS*", $lang, $thisuser, $$currfr{'prev'}{'id'}, 1, 0, 0 ) ) . qq{">},
		qq{<img src="$baseurl/img/navprev.gif" width=16 height=16 border=0 alt="$dict{'previous'}">} x $showtbicon,
		( '[' . $dict{'previous'} . ']' ) x $showtbtext,
		qq{</a>\n} ): "";
	$toolbars{'next'} = $$currfr{'next'}? join( " ",
		qq{<a href="index.cgi?param=} . unpack( "h*", pack( "uS*", $lang, $thisuser, $$currfr{'next'}{'id'}, 1, 0, 0 ) ) . qq{">},
		qq{<img src="$baseurl/img/navnext.gif" width=16 height=16 border=0 alt="$dict{'next'}">} x $showtbicon,
		( '[' . $dict{'next'} . ']' ) x $showtbtext,
		qq{</a>\n} ): "";
	$toolbars{'upper'} = ( $$currfr{'par'} == $root || $currfr == $root )? "": join( " ",
		qq{<a href="index.cgi?param=} . unpack( "h*", pack( "uS*", $lang, $thisuser, $$currfr{'par'}{'id'}, 1, 0, 0 ) ) . qq{">},
		qq{<img src="$baseurl/img/navupper.gif" width=16 height=16 border=0 alt="$dict{'upper'}">} x $showtbicon,
		( '[' . $dict{'upper'} . ']' ) x $showtbtext,
		qq{</a>\n} );
	$toolbars{'tpindex'} = ( $taskname eq "sort" )? join( " ",
		qq{<a href="index.cgi?param=} . unpack( "h*", pack( "uS*", $lang, $thisuser, $fr, 1, $md, 0 ) ) . qq{">},
		qq{<img src="$baseurl/img/navfrindex.gif" width=16 height=16 border=0 alt="$dict{'topicindex'}">} x $showtbicon,
		( '[' . $dict{'topicindex'} . ']' ) x $showtbtext,
		qq{</a>\n} ): "";
	$toolbars{'print'} = join( " ", qq{<a href="utils.cgi?task=} . unpack( "H*", pack( "uS", "print", $thisuser ) ) . qq{&amp;param=$fields{'param'}" target="_blank">},
		qq{<img src="$baseurl/img/navprint.gif" width=16 height=16 border=0 alt="$dict{'print'}">} x $showtbicon,
		( '[' . $dict{'print'} . ']' ) x $showtbtext,
		qq{</a>\n} );
	if( $mystatus{'member'} || ( $mystatus{'guest'} && $settings{'guestpost'} ) ){
		$toolbars{'post'} = $thisfrm{'open'}? join( " ",
			qq{<a href="post.cgi?param=} . unpack( "h*", pack( "uS*", $lang, $thisuser, $fr, $pg, $md, 0 ) ) . qq{">},
			qq{<img src="$baseurl/img/navwrite.gif" width=16 height=16 border=0 alt="$dict{'post'}">} x $showtbicon,
			( '[' . $dict{'post'} . ']' ) x $showtbtext,
			qq{</a>} ): "";
		if( $mystatus{'member'} ){
			$toolbars{'subunsub'} = &usersubscribed?
			join( " ",
				qq{<a href="admin.cgi?task=} . unpack( "H*", pack( "uS", "unsub", $thisuser ) ) . qq{&amp;param=$fields{'param'}">},
				qq{<img src="$baseurl/img/navunsub.gif" width=16 height=16 border=0 alt="$dict{'unsubscribe'}">} x $showtbicon,
				( '[' . $dict{'unsubscribe'} . ']' ) x $showtbtext,
				qq{</a>\n} ):
			join( " ",
				qq{<a href="admin.cgi?task=} . unpack( "H*", pack( "uS", "subscribe", $thisuser ) ) . qq{&amp;param=$fields{'param'}">},
				qq{<img src="$baseurl/img/navsubscribe.gif" width=16 height=16 border=0 alt="$dict{'subscribe'}">} x $showtbicon,
				( '[' . $dict{'subscribe'} . ']' ) x $showtbtext,
				qq{</a>\n} );
		}
		if( $mystatus{'senior'} ){
			$toolbars{'newfr'} = join( " ",
				qq{<a href="admin.cgi?task=} . unpack( "H*", pack( "uS", "newfr", $thisuser ) ) . qq{&amp;param=$fields{'param'}">},
				qq{<img src="$baseurl/img/navnewfr.gif" width=16 height=16 border=0 alt="$dict{'newforum'}">} x $showtbicon,
				( '[' . $dict{'newforum'} . ']' ) x $showtbtext,
				qq{</a>\n} );
		}
		if( $mystatus{'webmaster'} || $thisfrm{'mngrid'} == $thisuser ){
			$toolbars{'remove'} = join( " ",
				qq{<a href="admin.cgi?task=} . unpack( "H*", pack( "uS", "removefr", $thisuser ) ) . qq{&amp;param=$fields{'param'}">},
				qq{<img src="$baseurl/img/navremove.gif" width=16 height=16 border=0 alt="$dict{'removefr'}">} x $showtbicon,
				( '[' . $dict{'remove'} . ']' ) x $showtbtext,
				qq{</a>\n} );
			$toolbars{'lockunlock'} = $thisfrm{'open'}?
				join( " ",
					qq{<a href="admin.cgi?task=} . unpack( "H*", pack( "uS", "lockfr", $thisuser ) ) . qq{&amp;param=$fields{'param'}">},
					qq{<img src="$baseurl/img/navlock.gif" width=16 height=16 border=0 alt="$dict{'lock'}">} x $showtbicon,
					( '[' . $dict{'lock'} . ']' ) x $showtbtext,
					qq{</a>\n} ):
				join( " ",
					qq{<a href="admin.cgi?task=} . unpack( "H*", pack( "uS", "unlockfr", $thisuser ) ) . qq{&amp;param=$fields{'param'}">},
					qq{<img src="$baseurl/img/navunlock.gif" width=16 height=16 border=0 alt="$dict{'unlock'}"} x $showtbicon,
					( '[' . $dict{'unlock'} . ']' ) x $showtbtext,
					qq{</a>\n} );
			$toolbars{'edit'} = join( " ",
				qq{<a href="admin.cgi?task=} . unpack( "H*", pack( "uS", "edit", $thisuser ) ) . qq{&amp;param=$fields{'param'}">},
				qq{<img src="$baseurl/img/navedit.gif" width=16 height=16 border=0 alt="$dict{'edit'}">} x $showtbicon,
				( '[' . $dict{'edit'} . ']' ) x $showtbtext,
				qq{</a>\n} );
		}
	}
	foreach $tb ( @tools_bbs, @tools_nav, @tools_adm, @tools_set, @tools_oth ){
		print $toolbars{$tb};
	}
	print qq{</td></tr><tr><td align="right" bgcolor="$settings{'othbg'}">}, $upperfrlinks, qq{</td></tr></table>};
	&readtree( "dat/fr${fr}.dat" );
	print qq{
		<br>
		$instantnews
		<table border=0 cellspacing=0 cellpadding=0>
		<tr height="16">
			<td width=8><img src="$baseurl/img/tagleft.gif" width=8 height=16 border=0></td>
			<td background="$baseurl/img/tagbg.gif"><b>$dict{'messages'}</b></td>
			<td width=8><img src="$baseurl/img/tagright.gif" width=8 height=16 border=0></td>
		</tr>
		</table>
		<table width=100% border=0 cellpadding=0 cellspacing=0 cols=1 rows=1>
		<tr>
		<td bgcolor="$settings{'tblbg'}">
		<table border=0 cellpadding=2 cellspacing=1 width="100%" $ietblline>
		<tr>
			<th align="left" bgcolor="$settings{'theader'}"><nobr>
			<a href="index.cgi?param=$fields{'param'}&amp;task=$sorttasks[0][0]"><img src="$baseurl/img/sortatoz.gif" width=12 height=12 border=0></a>
			<a href="index.cgi?param=$fields{'param'}&amp;task=$sorttasks[0][1]"><img src="$baseurl/img/sortztoa.gif" width=12 height=12 border=0></a>
			<font color="$settings{'theaderfg'}">$dict{'title'}</nobr></font>
			</th>
			<th align="left" bgcolor="$settings{'theader'}"><nobr>
			<a href="index.cgi?param=$fields{'param'}&amp;task=$sorttasks[1][0]"><img src="$baseurl/img/sortatoz.gif" width=12 height=12 border=0></a>
			<a href="index.cgi?param=$fields{'param'}&amp;task=$sorttasks[1][1]"><img src="$baseurl/img/sortztoa.gif" width=12 height=12 border=0></a>
			<font color="$settings{'theaderfg'}">$dict{'author'}</nobr></font>
			</th>
			<th align="right" bgcolor="$settings{'theader'}"><nobr>
			<a href="index.cgi?param=$fields{'param'}&amp;task=$sorttasks[3][0]"><img src="$baseurl/img/sortatoz.gif" width=12 height=12 border=0></a>
			<a href="index.cgi?param=$fields{'param'}&amp;task=$sorttasks[3][1]"><img src="$baseurl/img/sortztoa.gif" width=12 height=12 border=0></a>
			<font color="$settings{'theaderfg'}">$dict{'reads'}</nobr></font>
			</th>
			<th align="right" bgcolor="$settings{'theader'}"><nobr>
			<a href="index.cgi?param=$fields{'param'}&amp;task=$sorttasks[2][0]"><img src="$baseurl/img/sortatoz.gif" width=12 height=12 border=0></a>
			<a href="index.cgi?param=$fields{'param'}&amp;task=$sorttasks[2][1]"><img src="$baseurl/img/sortztoa.gif" width=12 height=12 border=0></a>
			<font color="$settings{'theaderfg'}">$dict{'modified'}</nobr></font>
			</th>
		</tr>
	};
	if( $$root{'son'} ){
		( $taskname eq "sort" )?
			&sorttree( ):
			&travtree( $root );
		$troe = 1;
	} else {
		print qq{
		<tr>
			<td bgcolor="$settings{'othbg'}" colspan=4><font color="$settings{'othfg'}">$dict{'nomessage'}</font></td>
		</tr>
		};
	}
	print "</table></td></tr></table>", $separator, $subtopics;
} elsif( $viewingmode == 3 ){
	%frdb = ( );
	tie( %frdb, $DB_Type, "dat/fr${fr}", &GDBM_WRCREAT, 0666 );
	print qq{<table width=100% border=0><tr><td>};
	&readtree( "dat/fr${fr}.dat" );
	$currmsg = &searchtree( $root, $msg );
	my @ndata = split( /\t/, $$currmsg{'cap'}, 5 );
	my @msginfo = split( /\t/, $frdb{$msg}, 5 );
	%thismsg = (
		'title' => $ndata[0],
		'authorid' => $ndata[1],
		'authorname' => $ndata[1]? $users{$ndata[1]}: $dict{'guest'},
		'lastmod' => $ndata[2],
		'posttime' => $msginfo[2],
		'reads' => $ndata[3] + 1,
		'open' => $ndata[4],
		'ipaddr' => $msginfo[1],
		'text' => $msginfo[4],
		'autoinform' => ( $ndata[4] == 2 )? 1: 0,
	);
	$toolbars{'previous'} = $$currmsg{'prev'}? join( " ",
		qq{<a href="index.cgi?param=} . unpack( "h*", pack( "uS*", $lang, $thisuser, $fr, $pg, $md, $$currmsg{'prev'}{'id'} ) ) . qq{">},
		qq{<img src="$baseurl/img/navprev.gif" width=16 height=16 border=0 alt="$dict{'previous'}">} x $showtbicon,
		( '[' . $dict{'previous'} . ']' ) x $showtbtext,
		qq{</a>\n} ): "";
	$toolbars{'next'} = $$currmsg{'next'}? join( " ",
		qq{<a href="index.cgi?param=} . unpack( "h*", pack( "uS*", $lang, $thisuser, $fr, $pg, $md, $$currmsg{'next'}{'id'} ) ) . qq{">},
		qq{<img src="$baseurl/img/navnext.gif" width=16 height=16 border=0 alt="$dict{'next'}">} x $showtbicon,
		( '[' . $dict{'next'} . ']' ) x $showtbtext,
		qq{</a>\n} ): "";
	$toolbars{'upper'} = ( $$currmsg{'par'} == $root || $currmsg == $root )? "": join( " ",
		qq{<a href="index.cgi?param=} . unpack( "h*", pack( "uS*", $lang, $thisuser, $fr, $pg, $md, $$currmsg{'par'}{'id'} ) ) . qq{">},
		qq{<img src="$baseurl/img/navupper.gif" width=16 height=16 border=0 alt="$dict{'upper'}">} x $showtbicon,
		( '[' . $dict{'upper'} . ']' ) x $showtbtext,
		qq{</a>\n} );
	$toolbars{'tpindex'} = join( " ",
		qq{<a href="index.cgi?param=} . unpack( "h*", pack( "uS*", $lang, $thisuser, $fr, 1, $md, 0 ) ) . qq{">},
		qq{<img src="$baseurl/img/navfrindex.gif" width=16 height=16 border=0 alt="$dict{'topicindex'}">} x $showtbicon,
		( '[' . $dict{'topicindex'} . ']' ) x $showtbtext,
		qq{</a>\n} );
	$toolbars{'print'} = join( " ",
		qq{<a href="utils.cgi?task=} . unpack( "H*", pack( "uS", "print", $thisuser ) ) . qq{&amp;param=} . unpack( "h*", pack( "uS*", $lang, $thisuser, $fr, $pg, $md, $msg ) ) . qq{" target="_blank">},
		qq{<img src="$baseurl/img/navprint.gif" width=16 height=16 border=0 alt="$dict{'print'}">} x $showtbicon,
		( '[' . $dict{'print'} . ']' ) x $showtbtext,
		qq{</a>\n} );
	$toolbars{'post'} = ( ( $mystatus{'member'} || ( $mystatus{'guest'} && $settings{'guestpost'} ) )&& $thisfrm{'open'} )?
		join( " ",
			qq{<a href="post.cgi?param=} . unpack( "h*", pack( "uS*", $lang, $thisuser, $fr, $pg, $md, 0 ) ) . qq{">},
			qq{<img src="$baseurl/img/navwrite.gif" width=16 height=16 border=0 alt="$dict{'post'}">} x $showtbicon,
			( '[' . $dict{'post'} . ']' ) x $showtbtext,
			qq{</a>\n} ):
		"";
	if( $settings{'showfollowups'} ){
		$thismsg{'title'} .= " <small>($dict{'all'})</small>";
	} else {
		if( $mystatus{'member'} || ( $mystatus{'guest'} && $settings{'guestpost'} ) ){
			$toolbars{'reply'} = ( $thisfrm{'open'} && $thismsg{'open'} )? join( " ",
				qq{<a href="post.cgi?param=$fields{'param'}">},
				qq{<img src="$baseurl/img/navreply.gif" width=16 height=16 border=0 alt="$dict{'reply'}">} x $showtbicon,
				( '[' . $dict{'reply'} . ']' ) x $showtbtext,
				qq{</a>\n} ): "";
			if( $thismsg{'authorid'} == $thisuser ){
				$toolbars{'autoinform'} = $thismsg{'autoinform'}?
				join( " ",
					qq{<a href="admin.cgi?task=} . unpack( "H*", pack( "uS", "noinform", $thisuser ) ) . qq{&amp;param=$fields{'param'}">},
					qq{<img src="$baseurl/img/navnoinform.gif" width=16 height=16 border=0 alt="$dict{'noinform'}">} x $showtbicon,
					( '[' . $dict{'noinform'} . ']' ) x $showtbtext,
					qq{</a>\n} ):
				join( " ",
					qq{<a href="admin.cgi?task=} . unpack( "H*", pack( "uS", "autoinform", $thisuser ) ) . qq{&amp;param=$fields{'param'}">},
					qq{<img src="$baseurl/img/navautoinform.gif" width=16 height=16 border=0 alt="$dict{'autoinform'}">} x $showtbicon,
					( '[' . $dict{'autoinform'} . ']' ) x $showtbtext,
					qq{</a>\n} );
			}
			if( $mystatus{'member'} && ( $thismsg{'authorid'} == $thisuser || $thisfrm{'mngrid'} == $thisuser ) || $mystatus{'manager'} ){
				$toolbars{'remove'} = qq{<a href="admin.cgi?task=} . unpack( "H*", pack( "uS", "remove", $thisuser ) ) . qq{&amp;param=$fields{'param'}"><img src="$baseurl/img/navremove.gif" width=16 height=16 border=0 alt="$dict{'remove'}"></a>\n};
				$toolbars{'edit'} = ( ( $settings{'allowedit'} || $mystatus{'webmaster'} ) ?
					join( " ",
						qq{<a href="admin.cgi?task=} . unpack( "H*", pack( "uS", "edit", $thisuser ) ) . qq{&amp;param=$fields{'param'}">},
						qq{<img src="$baseurl/img/navedit.gif" width=16 height=16 border=0 alt="$dict{'edit'}">} x $showtbicon,
						( '[' . $dict{'edit'} . ']' ) x $showtbtext,
						qq{</a>\n} ):
					"" );
				if( !$thisfrm{'open'} ){
					$toolbars{'lockunlock'} = "";
				} else {
					$toolbars{'lockunlock'} = $thismsg{'open'}?
					join( " ",
						qq{<a href="admin.cgi?task=} . unpack( "H*", pack( "uS", "lock", $thisuser ) ) . qq{&amp;param=$fields{'param'}">},
						qq{<img src="$baseurl/img/navlock.gif" width=16 height=16 border=0 alt="$dict{'lock'}">} x $showtbicon,
						( '[' . $dict{'lock'} . ']' ) x $showtbtext,
						qq{</a>\n} ):
					join( " ",
						qq{<a href="admin.cgi?task=} . unpack( "H*", pack( "uS", "unlock", $thisuser ) ) . qq{&amp;param=$fields{'param'}">},
						qq{<img src="$baseurl/img/navunlock.gif" width=16 height=16 border=0 alt="$dict{'unlock'}">} x $showtbicon,
						( '[' . $dict{'unlock'} . ']' ) x $showtbtext,
						qq{</a>\n} );
				}
			}
		}
	}
	foreach $tb ( @tools_bbs, @tools_nav, @tools_adm, @tools_set, @tools_oth ){
		print $toolbars{$tb};
	}
	&getuppermsglinks( $currmsg );
	print qq{
		</td></tr>
		<tr><td align="right">$uppermsglinks</td></tr>
		</table>
	}, $instantnews;
	&getfollowups( $currmsg ) unless( $settings{'showfollowups'} );
	&showmsg( $currmsg );
	print $followups unless( $settings{'showfollowups'} );
	untie %frdb;
	&writetree( "dat/fr$fr.dat" );
}

$fields{'pattern'} =~ y| |+|;

if( $taskname eq "search" ){
	$newtask = "&amp;task=" . unpack( "H*", pack( "uS", "search", $thisuser ) );
	for( "pattern", "matchcase", "wholeword", "titleonly", "sortby", "combo", "list" ){
		if( $fields{$_} ){ $newtask .= "&amp;$_=$fields{$_}"; }
	}
}

# This set of buttons will be used to switch to another language.
$langbuttons = "";
unless( $settings{'hidelangbuttons'} == 1 ){
	foreach $langname ( @provlangs ){
		if( $langname ne $lang ){
			my $lbparam = unpack( "h*", pack( "uS*", $langname, $thisuser, $fr, $pg, $md, $msg ) );
			$langbuttons .= qq{ <a href="index.cgi?param=$lbparam$newtask"><img src="$baseurl/img/lang} . $langname . qq{.gif" border=0></a> };
		} else {
			$langbuttons .= qq{ <img src="$baseurl/img/lang} . $lang . qq{on.gif"> };
		}
	}
}

$onlinerslist = "&nbsp;";
# Note: in search mode, can't send instant messages. May be improved later.
if( !$settings{'hideonline'} && $mystatus{'member'} && $taskname ne "search" ){
	$task = unpack( "H*", pack( "uS", "sendnews", $thisuser ) );
	$onlinerslist = qq{
	<input type=hidden name="task" value="$task">
	<input type=hidden name="param" value="$fields{'param'}">
	$dict{'instantmsgr'}
	<input type=text name="newstext" value="$dict{'hello'}">
	};
	$onlinerslist .= &whosonline;
	$onlinerslist .= qq{
	<input type=submit value="$dict{'send'}">
	};
}

@pgparam = ( "" );	# So as to skip the first element;
$pagebar = "&nbsp;";

if( $viewingmode != 3 ){

for( 1..$currpg ){
	push( @pgparam, unpack( "h*", pack( "uS*", $lang, $thisuser, $fr, $_, $md, 0 ) ) );
}

if( $pg > 1){
	my $prevpage = $pg - 1;
	$pagebar .= qq{<a href="index.cgi?param=$pgparam[1]$newtask"><img src="$baseurl/img/btngofirst.gif" width=16 height=16 border=0 alt="$dict{'firstpage'}"></a>};
	$pagebar .= qq{<a href="index.cgi?param=$pgparam[$prevpage]$newtask"><img src="$baseurl/img/btngoprev.gif" width=16 height=16 border=0 alt="$dict{'prevpage'}"></a>};
}

if( $currpg > 1 ){
	$pagebar .= qq{<select name="pages" style="font-family: Courier" onChange="location=this.options[this.selectedIndex].value">\n};
	for ( 1..$currpg ){
		if( $_ != $pg ){
			$pagebar .= qq{ <option value="index.cgi?param=$pgparam[$_]$newtask">$_ / $currpg</option>\n };
		} else {
			$pagebar .= qq{ <option value="index.cgi?param=$fields{'param'}" selected>$dict{'page'} $_</option>\n };
		}
	}
	$pagebar .= qq{</select>};
}

if( $pg < $currpg ){
	my $nextpage = $pg + 1;
	$pagebar .= qq{<a href="index.cgi?param=$pgparam[$nextpage]$newtask"><img src="$baseurl/img/btngonext.gif" width=16 height=16 border=0 alt="$dict{'nextpage'}"></a>};
	$pagebar .= qq{<a href="index.cgi?param=$pgparam[$currpg]$newtask"><img src="$baseurl/img/btngolast.gif" width=16 height=16 border=0 alt="$dict{'lastpage'}"></a> };
}

}

# The following two arrays are used to construct the $levelbar buttons, which holds a series
# of IMG buttons to control the list depth of the forum/message tree.

$levelbar = "&nbsp;";
if( $viewingmode != 3 && !$taskname ){
	my @levelbtn = (0, 2, 3, 4, 5, ($md>2? $md-1: 2), $md+1 );
	my @levelbtncap = ($dict{'expall'}, $dict{'foldall'}, "1 $dict{'level'}", "2 $dict{'level'}", "3 $dict{'level'}", $dict{'leveldec'}, $dict{'levelinc'} );
	my @levelimg = qw(btnexpall btnfoldall btnexp1 btnexp2 btnexp3 btnfoldone btnexpone);
	$levelbar = "";
	my @levelbuttons = (0..6);
	if( !$md ){ shift @levelbuttons; pop @levelbuttons; }
	if( $md == 2 ){ splice( @levelbuttons, 1, 1 ); splice( @levelbuttons, 4, 1 ); }
	for( @levelbuttons ){
		my $lvparam = unpack( "h*", pack( "uS*", $lang, $thisuser, $fr, $pg, $levelbtn[$_], 0 ) );
		$levelbar .= qq{<a href="index.cgi?param=$lvparam"><img src="$baseurl/img/$levelimg[$_].gif" width=16 height=16 border=0 alt="$levelbtncap[$_]"></a>};
	}
}

print qq{
	<form action="admin.cgi" method="post">
	<table width=100% cellpadding=2 cellspacing=0>
	<tr>
	<td align="left">$pagebar$levelbar</td>
	<td align="right">$langbuttons $jumpform</td>
	</tr>
	</table>
	$onlinerslist
	</form>
	$logonform
};

while( <TPL> ){
	s/{%(\w+)%}/$fields{$1}/g;
	print;
}
close( TPL );
